/**
 * vis-data
 * http://visjs.org/
 *
 * Manage unstructured data using DataSet. Add, update, and remove data, and listen for changes in the data.
 *
 * @version 7.1.7
 * @date    2023-09-13T18:13:28.258Z
 *
 * @copyright (c) 2011-2017 Almende B.V, http://almende.com
 * @copyright (c) 2017-2019 visjs contributors, https://github.com/visjs
 *
 * @license
 * vis.js is dual licensed under both
 *
 *   1. The Apache 2.0 License
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *   and
 *
 *   2. The MIT License
 *      http://opensource.org/licenses/MIT
 *
 * vis.js may be distributed under either license.
 */
function t(t,e){if(!(t instanceof e))throw new TypeError("Cannot call a class as a function")}var e="undefined"!=typeof globalThis?globalThis:"undefined"!=typeof window?window:"undefined"!=typeof global?global:"undefined"!=typeof self?self:{};function r(t){return t&&t.__esModule&&Object.prototype.hasOwnProperty.call(t,"default")?t.default:t}var n={exports:{}},i=function(t){return t&&t.Math==Math&&t},o=i("object"==typeof globalThis&&globalThis)||i("object"==typeof window&&window)||i("object"==typeof self&&self)||i("object"==typeof e&&e)||function(){return this}()||Function("return this")(),a=function(t){try{return!!t()}catch(t){return!0}},u=!a((function(){var t=function(){}.bind();return"function"!=typeof t||t.hasOwnProperty("prototype")})),s=u,c=Function.prototype,f=c.apply,l=c.call,h="object"==typeof Reflect&&Reflect.apply||(s?l.bind(f):function(){return l.apply(f,arguments)}),p=u,v=Function.prototype,d=v.call,y=p&&v.bind.bind(d,d),g=p?y:function(t){return function(){return d.apply(t,arguments)}},m=g,b=m({}.toString),_=m("".slice),w=function(t){return _(b(t),8,-1)},E=w,T=g,O=function(t){if("Function"===E(t))return T(t)},x="object"==typeof document&&document.all,k={all:x,IS_HTMLDDA:void 0===x&&void 0!==x},S=k.all,j=k.IS_HTMLDDA?function(t){return"function"==typeof t||t===S}:function(t){return"function"==typeof t},A={},P=!a((function(){return 7!=Object.defineProperty({},1,{get:function(){return 7}})[1]})),I=u,D=Function.prototype.call,C=I?D.bind(D):function(){return D.apply(D,arguments)},L={},R={}.propertyIsEnumerable,M=Object.getOwnPropertyDescriptor,N=M&&!R.call({1:2},1);L.f=N?function(t){var e=M(this,t);return!!e&&e.enumerable}:R;var F,z,U=function(t,e){return{enumerable:!(1&t),configurable:!(2&t),writable:!(4&t),value:e}},q=a,Y=w,W=Object,G=g("".split),X=q((function(){return!W("z").propertyIsEnumerable(0)}))?function(t){return"String"==Y(t)?G(t,""):W(t)}:W,V=function(t){return null==t},B=V,H=TypeError,$=function(t){if(B(t))throw H("Can't call method on "+t);return t},J=X,K=$,Q=function(t){return J(K(t))},Z=j,tt=k.all,et=k.IS_HTMLDDA?function(t){return"object"==typeof t?null!==t:Z(t)||t===tt}:function(t){return"object"==typeof t?null!==t:Z(t)},rt={},nt=rt,it=o,ot=j,at=function(t){return ot(t)?t:void 0},ut=function(t,e){return arguments.length<2?at(nt[t])||at(it[t]):nt[t]&&nt[t][e]||it[t]&&it[t][e]},st=g({}.isPrototypeOf),ct="undefined"!=typeof navigator&&String(navigator.userAgent)||"",ft=o,lt=ct,ht=ft.process,pt=ft.Deno,vt=ht&&ht.versions||pt&&pt.version,dt=vt&&vt.v8;dt&&(z=(F=dt.split("."))[0]>0&&F[0]<4?1:+(F[0]+F[1])),!z&&lt&&(!(F=lt.match(/Edge\/(\d+)/))||F[1]>=74)&&(F=lt.match(/Chrome\/(\d+)/))&&(z=+F[1]);var yt=z,gt=yt,mt=a,bt=!!Object.getOwnPropertySymbols&&!mt((function(){var t=Symbol();return!String(t)||!(Object(t)instanceof Symbol)||!Symbol.sham&&gt&&gt<41})),_t=bt&&!Symbol.sham&&"symbol"==typeof Symbol.iterator,wt=ut,Et=j,Tt=st,Ot=Object,xt=_t?function(t){return"symbol"==typeof t}:function(t){var e=wt("Symbol");return Et(e)&&Tt(e.prototype,Ot(t))},kt=String,St=function(t){try{return kt(t)}catch(t){return"Object"}},jt=j,At=St,Pt=TypeError,It=function(t){if(jt(t))return t;throw Pt(At(t)+" is not a function")},Dt=It,Ct=V,Lt=function(t,e){var r=t[e];return Ct(r)?void 0:Dt(r)},Rt=C,Mt=j,Nt=et,Ft=TypeError,zt={exports:{}},Ut=o,qt=Object.defineProperty,Yt=function(t,e){try{qt(Ut,t,{value:e,configurable:!0,writable:!0})}catch(r){Ut[t]=e}return e},Wt="__core-js_shared__",Gt=o[Wt]||Yt(Wt,{}),Xt=Gt;(zt.exports=function(t,e){return Xt[t]||(Xt[t]=void 0!==e?e:{})})("versions",[]).push({version:"3.29.0",mode:"pure",copyright:"© 2014-2023 Denis Pushkarev (zloirock.ru)",license:"https://github.com/zloirock/core-js/blob/v3.29.0/LICENSE",source:"https://github.com/zloirock/core-js"});var Vt=zt.exports,Bt=$,Ht=Object,$t=function(t){return Ht(Bt(t))},Jt=$t,Kt=g({}.hasOwnProperty),Qt=Object.hasOwn||function(t,e){return Kt(Jt(t),e)},Zt=g,te=0,ee=Math.random(),re=Zt(1..toString),ne=function(t){return"Symbol("+(void 0===t?"":t)+")_"+re(++te+ee,36)},ie=Vt,oe=Qt,ae=ne,ue=bt,se=_t,ce=o.Symbol,fe=ie("wks"),le=se?ce.for||ce:ce&&ce.withoutSetter||ae,he=function(t){return oe(fe,t)||(fe[t]=ue&&oe(ce,t)?ce[t]:le("Symbol."+t)),fe[t]},pe=C,ve=et,de=xt,ye=Lt,ge=function(t,e){var r,n;if("string"===e&&Mt(r=t.toString)&&!Nt(n=Rt(r,t)))return n;if(Mt(r=t.valueOf)&&!Nt(n=Rt(r,t)))return n;if("string"!==e&&Mt(r=t.toString)&&!Nt(n=Rt(r,t)))return n;throw Ft("Can't convert object to primitive value")},me=TypeError,be=he("toPrimitive"),_e=function(t,e){if(!ve(t)||de(t))return t;var r,n=ye(t,be);if(n){if(void 0===e&&(e="default"),r=pe(n,t,e),!ve(r)||de(r))return r;throw me("Can't convert object to primitive value")}return void 0===e&&(e="number"),ge(t,e)},we=xt,Ee=function(t){var e=_e(t,"string");return we(e)?e:e+""},Te=et,Oe=o.document,xe=Te(Oe)&&Te(Oe.createElement),ke=function(t){return xe?Oe.createElement(t):{}},Se=ke,je=!P&&!a((function(){return 7!=Object.defineProperty(Se("div"),"a",{get:function(){return 7}}).a})),Ae=P,Pe=C,Ie=L,De=U,Ce=Q,Le=Ee,Re=Qt,Me=je,Ne=Object.getOwnPropertyDescriptor;A.f=Ae?Ne:function(t,e){if(t=Ce(t),e=Le(e),Me)try{return Ne(t,e)}catch(t){}if(Re(t,e))return De(!Pe(Ie.f,t,e),t[e])};var Fe=a,ze=j,Ue=/#|\.prototype\./,qe=function(t,e){var r=We[Ye(t)];return r==Xe||r!=Ge&&(ze(e)?Fe(e):!!e)},Ye=qe.normalize=function(t){return String(t).replace(Ue,".").toLowerCase()},We=qe.data={},Ge=qe.NATIVE="N",Xe=qe.POLYFILL="P",Ve=qe,Be=It,He=u,$e=O(O.bind),Je=function(t,e){return Be(t),void 0===e?t:He?$e(t,e):function(){return t.apply(e,arguments)}},Ke={},Qe=P&&a((function(){return 42!=Object.defineProperty((function(){}),"prototype",{value:42,writable:!1}).prototype})),Ze=et,tr=String,er=TypeError,rr=function(t){if(Ze(t))return t;throw er(tr(t)+" is not an object")},nr=P,ir=je,or=Qe,ar=rr,ur=Ee,sr=TypeError,cr=Object.defineProperty,fr=Object.getOwnPropertyDescriptor,lr="enumerable",hr="configurable",pr="writable";Ke.f=nr?or?function(t,e,r){if(ar(t),e=ur(e),ar(r),"function"==typeof t&&"prototype"===e&&"value"in r&&pr in r&&!r[pr]){var n=fr(t,e);n&&n[pr]&&(t[e]=r.value,r={configurable:hr in r?r[hr]:n[hr],enumerable:lr in r?r[lr]:n[lr],writable:!1})}return cr(t,e,r)}:cr:function(t,e,r){if(ar(t),e=ur(e),ar(r),ir)try{return cr(t,e,r)}catch(t){}if("get"in r||"set"in r)throw sr("Accessors not supported");return"value"in r&&(t[e]=r.value),t};var vr=Ke,dr=U,yr=P?function(t,e,r){return vr.f(t,e,dr(1,r))}:function(t,e,r){return t[e]=r,t},gr=o,mr=h,br=O,_r=j,wr=A.f,Er=Ve,Tr=rt,Or=Je,xr=yr,kr=Qt,Sr=function(t){var e=function(r,n,i){if(this instanceof e){switch(arguments.length){case 0:return new t;case 1:return new t(r);case 2:return new t(r,n)}return new t(r,n,i)}return mr(t,this,arguments)};return e.prototype=t.prototype,e},jr=function(t,e){var r,n,i,o,a,u,s,c,f,l=t.target,h=t.global,p=t.stat,v=t.proto,d=h?gr:p?gr[l]:(gr[l]||{}).prototype,y=h?Tr:Tr[l]||xr(Tr,l,{})[l],g=y.prototype;for(o in e)n=!(r=Er(h?o:l+(p?".":"#")+o,t.forced))&&d&&kr(d,o),u=y[o],n&&(s=t.dontCallGetSet?(f=wr(d,o))&&f.value:d[o]),a=n&&s?s:e[o],n&&typeof u==typeof a||(c=t.bind&&n?Or(a,gr):t.wrap&&n?Sr(a):v&&_r(a)?br(a):a,(t.sham||a&&a.sham||u&&u.sham)&&xr(c,"sham",!0),xr(y,o,c),v&&(kr(Tr,i=l+"Prototype")||xr(Tr,i,{}),xr(Tr[i],o,a),t.real&&g&&(r||!g[o])&&xr(g,o,a)))},Ar=jr,Pr=P,Ir=Ke.f;Ar({target:"Object",stat:!0,forced:Object.defineProperty!==Ir,sham:!Pr},{defineProperty:Ir});var Dr=rt.Object,Cr=n.exports=function(t,e,r){return Dr.defineProperty(t,e,r)};Dr.defineProperty.sham&&(Cr.sham=!0);var Lr=n.exports,Rr=Lr,Mr=r(Rr),Nr=w,Fr=Array.isArray||function(t){return"Array"==Nr(t)},zr=Math.ceil,Ur=Math.floor,qr=Math.trunc||function(t){var e=+t;return(e>0?Ur:zr)(e)},Yr=function(t){var e=+t;return e!=e||0===e?0:qr(e)},Wr=Yr,Gr=Math.min,Xr=function(t){return t>0?Gr(Wr(t),9007199254740991):0},Vr=function(t){return Xr(t.length)},Br=TypeError,Hr=function(t){if(t>9007199254740991)throw Br("Maximum allowed index exceeded");return t},$r=Ee,Jr=Ke,Kr=U,Qr=function(t,e,r){var n=$r(e);n in t?Jr.f(t,n,Kr(0,r)):t[n]=r},Zr={};Zr[he("toStringTag")]="z";var tn="[object z]"===String(Zr),en=tn,rn=j,nn=w,on=he("toStringTag"),an=Object,un="Arguments"==nn(function(){return arguments}()),sn=en?nn:function(t){var e,r,n;return void 0===t?"Undefined":null===t?"Null":"string"==typeof(r=function(t,e){try{return t[e]}catch(t){}}(e=an(t),on))?r:un?nn(e):"Object"==(n=nn(e))&&rn(e.callee)?"Arguments":n},cn=j,fn=Gt,ln=g(Function.toString);cn(fn.inspectSource)||(fn.inspectSource=function(t){return ln(t)});var hn=fn.inspectSource,pn=g,vn=a,dn=j,yn=sn,gn=hn,mn=function(){},bn=[],_n=ut("Reflect","construct"),wn=/^\s*(?:class|function)\b/,En=pn(wn.exec),Tn=!wn.exec(mn),On=function(t){if(!dn(t))return!1;try{return _n(mn,bn,t),!0}catch(t){return!1}},xn=function(t){if(!dn(t))return!1;switch(yn(t)){case"AsyncFunction":case"GeneratorFunction":case"AsyncGeneratorFunction":return!1}try{return Tn||!!En(wn,gn(t))}catch(t){return!0}};xn.sham=!0;var kn=!_n||vn((function(){var t;return On(On.call)||!On(Object)||!On((function(){t=!0}))||t}))?xn:On,Sn=Fr,jn=kn,An=et,Pn=he("species"),In=Array,Dn=function(t){var e;return Sn(t)&&(e=t.constructor,(jn(e)&&(e===In||Sn(e.prototype))||An(e)&&null===(e=e[Pn]))&&(e=void 0)),void 0===e?In:e},Cn=function(t,e){return new(Dn(t))(0===e?0:e)},Ln=a,Rn=yt,Mn=he("species"),Nn=function(t){return Rn>=51||!Ln((function(){var e=[];return(e.constructor={})[Mn]=function(){return{foo:1}},1!==e[t](Boolean).foo}))},Fn=jr,zn=a,Un=Fr,qn=et,Yn=$t,Wn=Vr,Gn=Hr,Xn=Qr,Vn=Cn,Bn=Nn,Hn=yt,$n=he("isConcatSpreadable"),Jn=Hn>=51||!zn((function(){var t=[];return t[$n]=!1,t.concat()[0]!==t})),Kn=function(t){if(!qn(t))return!1;var e=t[$n];return void 0!==e?!!e:Un(t)};Fn({target:"Array",proto:!0,arity:1,forced:!Jn||!Bn("concat")},{concat:function(t){var e,r,n,i,o,a=Yn(this),u=Vn(a,0),s=0;for(e=-1,n=arguments.length;e<n;e++)if(Kn(o=-1===e?a:arguments[e]))for(i=Wn(o),Gn(s+i),r=0;r<i;r++,s++)r in o&&Xn(u,s,o[r]);else Gn(s+1),Xn(u,s++,o);return u.length=s,u}});var Qn=sn,Zn=String,ti=function(t){if("Symbol"===Qn(t))throw TypeError("Cannot convert a Symbol value to a string");return Zn(t)},ei={},ri=Yr,ni=Math.max,ii=Math.min,oi=function(t,e){var r=ri(t);return r<0?ni(r+e,0):ii(r,e)},ai=Q,ui=oi,si=Vr,ci=function(t){return function(e,r,n){var i,o=ai(e),a=si(o),u=ui(n,a);if(t&&r!=r){for(;a>u;)if((i=o[u++])!=i)return!0}else for(;a>u;u++)if((t||u in o)&&o[u]===r)return t||u||0;return!t&&-1}},fi={includes:ci(!0),indexOf:ci(!1)},li={},hi=Qt,pi=Q,vi=fi.indexOf,di=li,yi=g([].push),gi=function(t,e){var r,n=pi(t),i=0,o=[];for(r in n)!hi(di,r)&&hi(n,r)&&yi(o,r);for(;e.length>i;)hi(n,r=e[i++])&&(~vi(o,r)||yi(o,r));return o},mi=["constructor","hasOwnProperty","isPrototypeOf","propertyIsEnumerable","toLocaleString","toString","valueOf"],bi=gi,_i=mi,wi=Object.keys||function(t){return bi(t,_i)},Ei=P,Ti=Qe,Oi=Ke,xi=rr,ki=Q,Si=wi;ei.f=Ei&&!Ti?Object.defineProperties:function(t,e){xi(t);for(var r,n=ki(e),i=Si(e),o=i.length,a=0;o>a;)Oi.f(t,r=i[a++],n[r]);return t};var ji,Ai=ut("document","documentElement"),Pi=ne,Ii=Vt("keys"),Di=function(t){return Ii[t]||(Ii[t]=Pi(t))},Ci=rr,Li=ei,Ri=mi,Mi=li,Ni=Ai,Fi=ke,zi="prototype",Ui="script",qi=Di("IE_PROTO"),Yi=function(){},Wi=function(t){return"<"+Ui+">"+t+"</"+Ui+">"},Gi=function(t){t.write(Wi("")),t.close();var e=t.parentWindow.Object;return t=null,e},Xi=function(){try{ji=new ActiveXObject("htmlfile")}catch(t){}var t,e,r;Xi="undefined"!=typeof document?document.domain&&ji?Gi(ji):(e=Fi("iframe"),r="java"+Ui+":",e.style.display="none",Ni.appendChild(e),e.src=String(r),(t=e.contentWindow.document).open(),t.write(Wi("document.F=Object")),t.close(),t.F):Gi(ji);for(var n=Ri.length;n--;)delete Xi[zi][Ri[n]];return Xi()};Mi[qi]=!0;var Vi=Object.create||function(t,e){var r;return null!==t?(Yi[zi]=Ci(t),r=new Yi,Yi[zi]=null,r[qi]=t):r=Xi(),void 0===e?r:Li.f(r,e)},Bi={},Hi=gi,$i=mi.concat("length","prototype");Bi.f=Object.getOwnPropertyNames||function(t){return Hi(t,$i)};var Ji={},Ki=oi,Qi=Vr,Zi=Qr,to=Array,eo=Math.max,ro=function(t,e,r){for(var n=Qi(t),i=Ki(e,n),o=Ki(void 0===r?n:r,n),a=to(eo(o-i,0)),u=0;i<o;i++,u++)Zi(a,u,t[i]);return a.length=u,a},no=w,io=Q,oo=Bi.f,ao=ro,uo="object"==typeof window&&window&&Object.getOwnPropertyNames?Object.getOwnPropertyNames(window):[];Ji.f=function(t){return uo&&"Window"==no(t)?function(t){try{return oo(t)}catch(t){return ao(uo)}}(t):oo(io(t))};var so={};so.f=Object.getOwnPropertySymbols;var co=yr,fo=function(t,e,r,n){return n&&n.enumerable?t[e]=r:co(t,e,r),t},lo=Ke,ho=function(t,e,r){return lo.f(t,e,r)},po={},vo=he;po.f=vo;var yo,go,mo,bo=rt,_o=Qt,wo=po,Eo=Ke.f,To=function(t){var e=bo.Symbol||(bo.Symbol={});_o(e,t)||Eo(e,t,{value:wo.f(t)})},Oo=C,xo=ut,ko=he,So=fo,jo=function(){var t=xo("Symbol"),e=t&&t.prototype,r=e&&e.valueOf,n=ko("toPrimitive");e&&!e[n]&&So(e,n,(function(t){return Oo(r,this)}),{arity:1})},Ao=sn,Po=tn?{}.toString:function(){return"[object "+Ao(this)+"]"},Io=tn,Do=Ke.f,Co=yr,Lo=Qt,Ro=Po,Mo=he("toStringTag"),No=function(t,e,r,n){if(t){var i=r?t:t.prototype;Lo(i,Mo)||Do(i,Mo,{configurable:!0,value:e}),n&&!Io&&Co(i,"toString",Ro)}},Fo=j,zo=o.WeakMap,Uo=Fo(zo)&&/native code/.test(String(zo)),qo=o,Yo=et,Wo=yr,Go=Qt,Xo=Gt,Vo=Di,Bo=li,Ho="Object already initialized",$o=qo.TypeError,Jo=qo.WeakMap;if(Uo||Xo.state){var Ko=Xo.state||(Xo.state=new Jo);Ko.get=Ko.get,Ko.has=Ko.has,Ko.set=Ko.set,yo=function(t,e){if(Ko.has(t))throw $o(Ho);return e.facade=t,Ko.set(t,e),e},go=function(t){return Ko.get(t)||{}},mo=function(t){return Ko.has(t)}}else{var Qo=Vo("state");Bo[Qo]=!0,yo=function(t,e){if(Go(t,Qo))throw $o(Ho);return e.facade=t,Wo(t,Qo,e),e},go=function(t){return Go(t,Qo)?t[Qo]:{}},mo=function(t){return Go(t,Qo)}}var Zo={set:yo,get:go,has:mo,enforce:function(t){return mo(t)?go(t):yo(t,{})},getterFor:function(t){return function(e){var r;if(!Yo(e)||(r=go(e)).type!==t)throw $o("Incompatible receiver, "+t+" required");return r}}},ta=Je,ea=X,ra=$t,na=Vr,ia=Cn,oa=g([].push),aa=function(t){var e=1==t,r=2==t,n=3==t,i=4==t,o=6==t,a=7==t,u=5==t||o;return function(s,c,f,l){for(var h,p,v=ra(s),d=ea(v),y=ta(c,f),g=na(d),m=0,b=l||ia,_=e?b(s,g):r||a?b(s,0):void 0;g>m;m++)if((u||m in d)&&(p=y(h=d[m],m,v),t))if(e)_[m]=p;else if(p)switch(t){case 3:return!0;case 5:return h;case 6:return m;case 2:oa(_,h)}else switch(t){case 4:return!1;case 7:oa(_,h)}return o?-1:n||i?i:_}},ua={forEach:aa(0),map:aa(1),filter:aa(2),some:aa(3),every:aa(4),find:aa(5),findIndex:aa(6),filterReject:aa(7)},sa=jr,ca=o,fa=C,la=g,ha=P,pa=bt,va=a,da=Qt,ya=st,ga=rr,ma=Q,ba=Ee,_a=ti,wa=U,Ea=Vi,Ta=wi,Oa=Bi,xa=Ji,ka=so,Sa=A,ja=Ke,Aa=ei,Pa=L,Ia=fo,Da=ho,Ca=Vt,La=li,Ra=ne,Ma=he,Na=po,Fa=To,za=jo,Ua=No,qa=Zo,Ya=ua.forEach,Wa=Di("hidden"),Ga="Symbol",Xa="prototype",Va=qa.set,Ba=qa.getterFor(Ga),Ha=Object[Xa],$a=ca.Symbol,Ja=$a&&$a[Xa],Ka=ca.TypeError,Qa=ca.QObject,Za=Sa.f,tu=ja.f,eu=xa.f,ru=Pa.f,nu=la([].push),iu=Ca("symbols"),ou=Ca("op-symbols"),au=Ca("wks"),uu=!Qa||!Qa[Xa]||!Qa[Xa].findChild,su=ha&&va((function(){return 7!=Ea(tu({},"a",{get:function(){return tu(this,"a",{value:7}).a}})).a}))?function(t,e,r){var n=Za(Ha,e);n&&delete Ha[e],tu(t,e,r),n&&t!==Ha&&tu(Ha,e,n)}:tu,cu=function(t,e){var r=iu[t]=Ea(Ja);return Va(r,{type:Ga,tag:t,description:e}),ha||(r.description=e),r},fu=function(t,e,r){t===Ha&&fu(ou,e,r),ga(t);var n=ba(e);return ga(r),da(iu,n)?(r.enumerable?(da(t,Wa)&&t[Wa][n]&&(t[Wa][n]=!1),r=Ea(r,{enumerable:wa(0,!1)})):(da(t,Wa)||tu(t,Wa,wa(1,{})),t[Wa][n]=!0),su(t,n,r)):tu(t,n,r)},lu=function(t,e){ga(t);var r=ma(e),n=Ta(r).concat(du(r));return Ya(n,(function(e){ha&&!fa(hu,r,e)||fu(t,e,r[e])})),t},hu=function(t){var e=ba(t),r=fa(ru,this,e);return!(this===Ha&&da(iu,e)&&!da(ou,e))&&(!(r||!da(this,e)||!da(iu,e)||da(this,Wa)&&this[Wa][e])||r)},pu=function(t,e){var r=ma(t),n=ba(e);if(r!==Ha||!da(iu,n)||da(ou,n)){var i=Za(r,n);return!i||!da(iu,n)||da(r,Wa)&&r[Wa][n]||(i.enumerable=!0),i}},vu=function(t){var e=eu(ma(t)),r=[];return Ya(e,(function(t){da(iu,t)||da(La,t)||nu(r,t)})),r},du=function(t){var e=t===Ha,r=eu(e?ou:ma(t)),n=[];return Ya(r,(function(t){!da(iu,t)||e&&!da(Ha,t)||nu(n,iu[t])})),n};pa||(Ia(Ja=($a=function(){if(ya(Ja,this))throw Ka("Symbol is not a constructor");var t=arguments.length&&void 0!==arguments[0]?_a(arguments[0]):void 0,e=Ra(t),r=function(t){this===Ha&&fa(r,ou,t),da(this,Wa)&&da(this[Wa],e)&&(this[Wa][e]=!1),su(this,e,wa(1,t))};return ha&&uu&&su(Ha,e,{configurable:!0,set:r}),cu(e,t)})[Xa],"toString",(function(){return Ba(this).tag})),Ia($a,"withoutSetter",(function(t){return cu(Ra(t),t)})),Pa.f=hu,ja.f=fu,Aa.f=lu,Sa.f=pu,Oa.f=xa.f=vu,ka.f=du,Na.f=function(t){return cu(Ma(t),t)},ha&&Da(Ja,"description",{configurable:!0,get:function(){return Ba(this).description}})),sa({global:!0,constructor:!0,wrap:!0,forced:!pa,sham:!pa},{Symbol:$a}),Ya(Ta(au),(function(t){Fa(t)})),sa({target:Ga,stat:!0,forced:!pa},{useSetter:function(){uu=!0},useSimple:function(){uu=!1}}),sa({target:"Object",stat:!0,forced:!pa,sham:!ha},{create:function(t,e){return void 0===e?Ea(t):lu(Ea(t),e)},defineProperty:fu,defineProperties:lu,getOwnPropertyDescriptor:pu}),sa({target:"Object",stat:!0,forced:!pa},{getOwnPropertyNames:vu}),za(),Ua($a,Ga),La[Wa]=!0;var yu=bt&&!!Symbol.for&&!!Symbol.keyFor,gu=jr,mu=ut,bu=Qt,_u=ti,wu=Vt,Eu=yu,Tu=wu("string-to-symbol-registry"),Ou=wu("symbol-to-string-registry");gu({target:"Symbol",stat:!0,forced:!Eu},{for:function(t){var e=_u(t);if(bu(Tu,e))return Tu[e];var r=mu("Symbol")(e);return Tu[e]=r,Ou[r]=e,r}});var xu=jr,ku=Qt,Su=xt,ju=St,Au=yu,Pu=Vt("symbol-to-string-registry");xu({target:"Symbol",stat:!0,forced:!Au},{keyFor:function(t){if(!Su(t))throw TypeError(ju(t)+" is not a symbol");if(ku(Pu,t))return Pu[t]}});var Iu=g([].slice),Du=Fr,Cu=j,Lu=w,Ru=ti,Mu=g([].push),Nu=jr,Fu=ut,zu=h,Uu=C,qu=g,Yu=a,Wu=j,Gu=xt,Xu=Iu,Vu=function(t){if(Cu(t))return t;if(Du(t)){for(var e=t.length,r=[],n=0;n<e;n++){var i=t[n];"string"==typeof i?Mu(r,i):"number"!=typeof i&&"Number"!=Lu(i)&&"String"!=Lu(i)||Mu(r,Ru(i))}var o=r.length,a=!0;return function(t,e){if(a)return a=!1,e;if(Du(this))return e;for(var n=0;n<o;n++)if(r[n]===t)return e}}},Bu=bt,Hu=String,$u=Fu("JSON","stringify"),Ju=qu(/./.exec),Ku=qu("".charAt),Qu=qu("".charCodeAt),Zu=qu("".replace),ts=qu(1..toString),es=/[\uD800-\uDFFF]/g,rs=/^[\uD800-\uDBFF]$/,ns=/^[\uDC00-\uDFFF]$/,is=!Bu||Yu((function(){var t=Fu("Symbol")();return"[null]"!=$u([t])||"{}"!=$u({a:t})||"{}"!=$u(Object(t))})),os=Yu((function(){return'"\\udf06\\ud834"'!==$u("\udf06\ud834")||'"\\udead"'!==$u("\udead")})),as=function(t,e){var r=Xu(arguments),n=Vu(e);if(Wu(n)||void 0!==t&&!Gu(t))return r[1]=function(t,e){if(Wu(n)&&(e=Uu(n,this,Hu(t),e)),!Gu(e))return e},zu($u,null,r)},us=function(t,e,r){var n=Ku(r,e-1),i=Ku(r,e+1);return Ju(rs,t)&&!Ju(ns,i)||Ju(ns,t)&&!Ju(rs,n)?"\\u"+ts(Qu(t,0),16):t};$u&&Nu({target:"JSON",stat:!0,arity:3,forced:is||os},{stringify:function(t,e,r){var n=Xu(arguments),i=zu(is?as:$u,null,n);return os&&"string"==typeof i?Zu(i,es,us):i}});var ss=so,cs=$t;jr({target:"Object",stat:!0,forced:!bt||a((function(){ss.f(1)}))},{getOwnPropertySymbols:function(t){var e=ss.f;return e?e(cs(t)):[]}}),To("asyncIterator"),To("hasInstance"),To("isConcatSpreadable"),To("iterator"),To("match"),To("matchAll"),To("replace"),To("search"),To("species"),To("split");var fs=jo;To("toPrimitive"),fs();var ls=ut,hs=No;To("toStringTag"),hs(ls("Symbol"),"Symbol"),To("unscopables"),No(o.JSON,"JSON",!0);var ps,vs,ds,ys=rt.Symbol,gs={},ms=P,bs=Qt,_s=Function.prototype,ws=ms&&Object.getOwnPropertyDescriptor,Es=bs(_s,"name"),Ts={EXISTS:Es,PROPER:Es&&"something"===function(){}.name,CONFIGURABLE:Es&&(!ms||ms&&ws(_s,"name").configurable)},Os=!a((function(){function t(){}return t.prototype.constructor=null,Object.getPrototypeOf(new t)!==t.prototype})),xs=Qt,ks=j,Ss=$t,js=Os,As=Di("IE_PROTO"),Ps=Object,Is=Ps.prototype,Ds=js?Ps.getPrototypeOf:function(t){var e=Ss(t);if(xs(e,As))return e[As];var r=e.constructor;return ks(r)&&e instanceof r?r.prototype:e instanceof Ps?Is:null},Cs=a,Ls=j,Rs=et,Ms=Vi,Ns=Ds,Fs=fo,zs=he("iterator"),Us=!1;[].keys&&("next"in(ds=[].keys())?(vs=Ns(Ns(ds)))!==Object.prototype&&(ps=vs):Us=!0);var qs=!Rs(ps)||Cs((function(){var t={};return ps[zs].call(t)!==t}));Ls((ps=qs?{}:Ms(ps))[zs])||Fs(ps,zs,(function(){return this}));var Ys={IteratorPrototype:ps,BUGGY_SAFARI_ITERATORS:Us},Ws=Ys.IteratorPrototype,Gs=Vi,Xs=U,Vs=No,Bs=gs,Hs=function(){return this},$s=g,Js=It,Ks=j,Qs=String,Zs=TypeError,tc=function(t,e,r){try{return $s(Js(Object.getOwnPropertyDescriptor(t,e)[r]))}catch(t){}},ec=rr,rc=function(t){if("object"==typeof t||Ks(t))return t;throw Zs("Can't set "+Qs(t)+" as a prototype")},nc=Object.setPrototypeOf||("__proto__"in{}?function(){var t,e=!1,r={};try{(t=tc(Object.prototype,"__proto__","set"))(r,[]),e=r instanceof Array}catch(t){}return function(r,n){return ec(r),rc(n),e?t(r,n):r.__proto__=n,r}}():void 0),ic=jr,oc=C,ac=Ts,uc=function(t,e,r,n){var i=e+" Iterator";return t.prototype=Gs(Ws,{next:Xs(+!n,r)}),Vs(t,i,!1,!0),Bs[i]=Hs,t},sc=Ds,cc=No,fc=fo,lc=gs,hc=Ys,pc=ac.PROPER,vc=hc.BUGGY_SAFARI_ITERATORS,dc=he("iterator"),yc="keys",gc="values",mc="entries",bc=function(){return this},_c=function(t,e,r,n,i,o,a){uc(r,e,n);var u,s,c,f=function(t){if(t===i&&d)return d;if(!vc&&t in p)return p[t];switch(t){case yc:case gc:case mc:return function(){return new r(this,t)}}return function(){return new r(this)}},l=e+" Iterator",h=!1,p=t.prototype,v=p[dc]||p["@@iterator"]||i&&p[i],d=!vc&&v||f(i),y="Array"==e&&p.entries||v;if(y&&(u=sc(y.call(new t)))!==Object.prototype&&u.next&&(cc(u,l,!0,!0),lc[l]=bc),pc&&i==gc&&v&&v.name!==gc&&(h=!0,d=function(){return oc(v,this)}),i)if(s={values:f(gc),keys:o?d:f(yc),entries:f(mc)},a)for(c in s)(vc||h||!(c in p))&&fc(p,c,s[c]);else ic({target:e,proto:!0,forced:vc||h},s);return a&&p[dc]!==d&&fc(p,dc,d,{name:i}),lc[e]=d,s},wc=function(t,e){return{value:t,done:e}},Ec=Q,Tc=gs,Oc=Zo;Ke.f;var xc=_c,kc=wc,Sc="Array Iterator",jc=Oc.set,Ac=Oc.getterFor(Sc);xc(Array,"Array",(function(t,e){jc(this,{type:Sc,target:Ec(t),index:0,kind:e})}),(function(){var t=Ac(this),e=t.target,r=t.kind,n=t.index++;return!e||n>=e.length?(t.target=void 0,kc(void 0,!0)):kc("keys"==r?n:"values"==r?e[n]:[n,e[n]],!1)}),"values"),Tc.Arguments=Tc.Array;var Pc={CSSRuleList:0,CSSStyleDeclaration:0,CSSValueList:0,ClientRectList:0,DOMRectList:0,DOMStringList:0,DOMTokenList:1,DataTransferItemList:0,FileList:0,HTMLAllCollection:0,HTMLCollection:0,HTMLFormElement:0,HTMLSelectElement:0,MediaList:0,MimeTypeArray:0,NamedNodeMap:0,NodeList:1,PaintRequestList:0,Plugin:0,PluginArray:0,SVGLengthList:0,SVGNumberList:0,SVGPathSegList:0,SVGPointList:0,SVGStringList:0,SVGTransformList:0,SourceBufferList:0,StyleSheetList:0,TextTrackCueList:0,TextTrackList:0,TouchList:0},Ic=o,Dc=sn,Cc=yr,Lc=gs,Rc=he("toStringTag");for(var Mc in Pc){var Nc=Ic[Mc],Fc=Nc&&Nc.prototype;Fc&&Dc(Fc)!==Rc&&Cc(Fc,Rc,Mc),Lc[Mc]=Lc.Array}var zc=ys;To("dispose");var Uc=zc;To("asyncDispose");var qc=jr,Yc=g,Wc=ut("Symbol"),Gc=Wc.keyFor,Xc=Yc(Wc.prototype.valueOf);qc({target:"Symbol",stat:!0},{isRegistered:function(t){try{return void 0!==Gc(Xc(t))}catch(t){return!1}}});for(var Vc=jr,Bc=Vt,Hc=ut,$c=g,Jc=xt,Kc=he,Qc=Hc("Symbol"),Zc=Qc.isWellKnown,tf=Hc("Object","getOwnPropertyNames"),ef=$c(Qc.prototype.valueOf),rf=Bc("wks"),nf=0,of=tf(Qc),af=of.length;nf<af;nf++)try{var uf=of[nf];Jc(Qc[uf])&&Kc(uf)}catch(t){}Vc({target:"Symbol",stat:!0,forced:!0},{isWellKnown:function(t){if(Zc&&Zc(t))return!0;try{for(var e=ef(t),r=0,n=tf(rf),i=n.length;r<i;r++)if(rf[n[r]]==e)return!0}catch(t){}return!1}}),To("matcher"),To("metadataKey"),To("observable"),To("metadata"),To("patternMatch"),To("replaceAll");var sf=Uc,cf=r(sf),ff=g,lf=Yr,hf=ti,pf=$,vf=ff("".charAt),df=ff("".charCodeAt),yf=ff("".slice),gf=function(t){return function(e,r){var n,i,o=hf(pf(e)),a=lf(r),u=o.length;return a<0||a>=u?t?"":void 0:(n=df(o,a))<55296||n>56319||a+1===u||(i=df(o,a+1))<56320||i>57343?t?vf(o,a):n:t?yf(o,a,a+2):i-56320+(n-55296<<10)+65536}},mf={codeAt:gf(!1),charAt:gf(!0)}.charAt,bf=ti,_f=Zo,wf=_c,Ef=wc,Tf="String Iterator",Of=_f.set,xf=_f.getterFor(Tf);wf(String,"String",(function(t){Of(this,{type:Tf,string:bf(t),index:0})}),(function(){var t,e=xf(this),r=e.string,n=e.index;return n>=r.length?Ef(void 0,!0):(t=mf(r,n),e.index+=t.length,Ef(t,!1))}));var kf=po.f("iterator"),Sf=kf,jf=r(Sf);function Af(t){return Af="function"==typeof cf&&"symbol"==typeof jf?function(t){return typeof t}:function(t){return t&&"function"==typeof cf&&t.constructor===cf&&t!==cf.prototype?"symbol":typeof t},Af(t)}var Pf=r(po.f("toPrimitive"));function If(t){var e=function(t,e){if("object"!==Af(t)||null===t)return t;var r=t[Pf];if(void 0!==r){var n=r.call(t,e||"default");if("object"!==Af(n))return n;throw new TypeError("@@toPrimitive must return a primitive value.")}return("string"===e?String:Number)(t)}(t,"string");return"symbol"===Af(e)?e:String(e)}function Df(t,e){for(var r=0;r<e.length;r++){var n=e[r];n.enumerable=n.enumerable||!1,n.configurable=!0,"value"in n&&(n.writable=!0),Mr(t,If(n.key),n)}}function Cf(t,e,r){return e&&Df(t.prototype,e),r&&Df(t,r),Mr(t,"prototype",{writable:!1}),t}function Lf(t,e,r){return(e=If(e))in t?Mr(t,e,{value:r,enumerable:!0,configurable:!0,writable:!0}):t[e]=r,t}var Rf=g,Mf=It,Nf=et,Ff=Qt,zf=Iu,Uf=u,qf=Function,Yf=Rf([].concat),Wf=Rf([].join),Gf={},Xf=Uf?qf.bind:function(t){var e=Mf(this),r=e.prototype,n=zf(arguments,1),i=function(){var r=Yf(n,zf(arguments));return this instanceof i?function(t,e,r){if(!Ff(Gf,e)){for(var n=[],i=0;i<e;i++)n[i]="a["+i+"]";Gf[e]=qf("C,a","return new C("+Wf(n,",")+")")}return Gf[e](t,r)}(e,r.length,r):e.apply(t,r)};return Nf(r)&&(i.prototype=r),i},Vf=Xf;jr({target:"Function",proto:!0,forced:Function.bind!==Vf},{bind:Vf});var Bf=rt,Hf=function(t){return Bf[t+"Prototype"]},$f=Hf("Function").bind,Jf=st,Kf=$f,Qf=Function.prototype,Zf=function(t){var e=t.bind;return t===Qf||Jf(Qf,t)&&e===Qf.bind?Kf:e},tl=r(Zf),el=It,rl=$t,nl=X,il=Vr,ol=TypeError,al=function(t){return function(e,r,n,i){el(r);var o=rl(e),a=nl(o),u=il(o),s=t?u-1:0,c=t?-1:1;if(n<2)for(;;){if(s in a){i=a[s],s+=c;break}if(s+=c,t?s<0:u<=s)throw ol("Reduce of empty array with no initial value")}for(;t?s>=0:u>s;s+=c)s in a&&(i=r(i,a[s],s,o));return i}},ul={left:al(!1),right:al(!0)},sl=a,cl=function(t,e){var r=[][t];return!!r&&sl((function(){r.call(null,e||function(){return 1},1)}))},fl="undefined"!=typeof process&&"process"==w(process),ll=ul.left;jr({target:"Array",proto:!0,forced:!fl&&yt>79&&yt<83||!cl("reduce")},{reduce:function(t){var e=arguments.length;return ll(this,t,e,e>1?arguments[1]:void 0)}});var hl=Hf("Array").reduce,pl=st,vl=hl,dl=Array.prototype,yl=r((function(t){var e=t.reduce;return t===dl||pl(dl,t)&&e===dl.reduce?vl:e})),gl=ua.filter;jr({target:"Array",proto:!0,forced:!Nn("filter")},{filter:function(t){return gl(this,t,arguments.length>1?arguments[1]:void 0)}});var ml=Hf("Array").filter,bl=st,_l=ml,wl=Array.prototype,El=r((function(t){var e=t.filter;return t===wl||bl(wl,t)&&e===wl.filter?_l:e})),Tl=ua.map;jr({target:"Array",proto:!0,forced:!Nn("map")},{map:function(t){return Tl(this,t,arguments.length>1?arguments[1]:void 0)}});var Ol=Hf("Array").map,xl=st,kl=Ol,Sl=Array.prototype,jl=r((function(t){var e=t.map;return t===Sl||xl(Sl,t)&&e===Sl.map?kl:e})),Al=Fr,Pl=Vr,Il=Hr,Dl=Je,Cl=function(t,e,r,n,i,o,a,u){for(var s,c,f=i,l=0,h=!!a&&Dl(a,u);l<n;)l in r&&(s=h?h(r[l],l,e):r[l],o>0&&Al(s)?(c=Pl(s),f=Cl(t,e,s,c,f,o-1)-1):(Il(f+1),t[f]=s),f++),l++;return f},Ll=Cl,Rl=It,Ml=$t,Nl=Vr,Fl=Cn;jr({target:"Array",proto:!0},{flatMap:function(t){var e,r=Ml(this),n=Nl(r);return Rl(t),(e=Fl(r,0)).length=Ll(e,r,r,n,0,1,t,arguments.length>1?arguments[1]:void 0),e}});var zl=Hf("Array").flatMap,Ul=st,ql=zl,Yl=Array.prototype,Wl=r((function(t){var e=t.flatMap;return t===Yl||Ul(Yl,t)&&e===Yl.flatMap?ql:e}));function Gl(t){return new Vl(t)}var Xl=function(){function e(r,n,i){var o,a,u;t(this,e),Lf(this,"_source",void 0),Lf(this,"_transformers",void 0),Lf(this,"_target",void 0),Lf(this,"_listeners",{add:tl(o=this._add).call(o,this),remove:tl(a=this._remove).call(a,this),update:tl(u=this._update).call(u,this)}),this._source=r,this._transformers=n,this._target=i}return Cf(e,[{key:"all",value:function(){return this._target.update(this._transformItems(this._source.get())),this}},{key:"start",value:function(){return this._source.on("add",this._listeners.add),this._source.on("remove",this._listeners.remove),this._source.on("update",this._listeners.update),this}},{key:"stop",value:function(){return this._source.off("add",this._listeners.add),this._source.off("remove",this._listeners.remove),this._source.off("update",this._listeners.update),this}},{key:"_transformItems",value:function(t){var e;return yl(e=this._transformers).call(e,(function(t,e){return e(t)}),t)}},{key:"_add",value:function(t,e){null!=e&&this._target.add(this._transformItems(this._source.get(e.items)))}},{key:"_update",value:function(t,e){null!=e&&this._target.update(this._transformItems(this._source.get(e.items)))}},{key:"_remove",value:function(t,e){null!=e&&this._target.remove(this._transformItems(e.oldData))}}]),e}(),Vl=function(){function e(r){t(this,e),Lf(this,"_source",void 0),Lf(this,"_transformers",[]),this._source=r}return Cf(e,[{key:"filter",value:function(t){return this._transformers.push((function(e){return El(e).call(e,t)})),this}},{key:"map",value:function(t){return this._transformers.push((function(e){return jl(e).call(e,t)})),this}},{key:"flatMap",value:function(t){return this._transformers.push((function(e){return Wl(e).call(e,t)})),this}},{key:"to",value:function(t){return new Xl(this._source,this._transformers,t)}}]),e}(),Bl=C,Hl=rr,$l=Lt,Jl=function(t,e,r){var n,i;Hl(t);try{if(!(n=$l(t,"return"))){if("throw"===e)throw r;return r}n=Bl(n,t)}catch(t){i=!0,n=t}if("throw"===e)throw r;if(i)throw n;return Hl(n),r},Kl=rr,Ql=Jl,Zl=gs,th=he("iterator"),eh=Array.prototype,rh=function(t){return void 0!==t&&(Zl.Array===t||eh[th]===t)},nh=sn,ih=Lt,oh=V,ah=gs,uh=he("iterator"),sh=function(t){if(!oh(t))return ih(t,uh)||ih(t,"@@iterator")||ah[nh(t)]},ch=C,fh=It,lh=rr,hh=St,ph=sh,vh=TypeError,dh=function(t,e){var r=arguments.length<2?ph(t):e;if(fh(r))return lh(ch(r,t));throw vh(hh(t)+" is not iterable")},yh=Je,gh=C,mh=$t,bh=function(t,e,r,n){try{return n?e(Kl(r)[0],r[1]):e(r)}catch(e){Ql(t,"throw",e)}},_h=rh,wh=kn,Eh=Vr,Th=Qr,Oh=dh,xh=sh,kh=Array,Sh=he("iterator"),jh=!1;try{var Ah=0,Ph={next:function(){return{done:!!Ah++}},return:function(){jh=!0}};Ph[Sh]=function(){return this},Array.from(Ph,(function(){throw 2}))}catch(t){}var Ih=function(t,e){if(!e&&!jh)return!1;var r=!1;try{var n={};n[Sh]=function(){return{next:function(){return{done:r=!0}}}},t(n)}catch(t){}return r},Dh=function(t){var e=mh(t),r=wh(this),n=arguments.length,i=n>1?arguments[1]:void 0,o=void 0!==i;o&&(i=yh(i,n>2?arguments[2]:void 0));var a,u,s,c,f,l,h=xh(e),p=0;if(!h||this===kh&&_h(h))for(a=Eh(e),u=r?new this(a):kh(a);a>p;p++)l=o?i(e[p],p):e[p],Th(u,p,l);else for(f=(c=Oh(e,h)).next,u=r?new this:[];!(s=gh(f,c)).done;p++)l=o?bh(c,i,[s.value,p],!0):s.value,Th(u,p,l);return u.length=p,u};jr({target:"Array",stat:!0,forced:!Ih((function(t){Array.from(t)}))},{from:Dh});var Ch=rt.Array.from,Lh=r(Ch),Rh=r(sh),Mh=r(rt.Object.getOwnPropertySymbols),Nh={exports:{}},Fh=jr,zh=a,Uh=Q,qh=A.f,Yh=P;Fh({target:"Object",stat:!0,forced:!Yh||zh((function(){qh(1)})),sham:!Yh},{getOwnPropertyDescriptor:function(t,e){return qh(Uh(t),e)}});var Wh=rt.Object,Gh=Nh.exports=function(t,e){return Wh.getOwnPropertyDescriptor(t,e)};Wh.getOwnPropertyDescriptor.sham&&(Gh.sham=!0);var Xh=r(Nh.exports),Vh=ut,Bh=Bi,Hh=so,$h=rr,Jh=g([].concat),Kh=Vh("Reflect","ownKeys")||function(t){var e=Bh.f($h(t)),r=Hh.f;return r?Jh(e,r(t)):e},Qh=Kh,Zh=Q,tp=A,ep=Qr;jr({target:"Object",stat:!0,sham:!P},{getOwnPropertyDescriptors:function(t){for(var e,r,n=Zh(t),i=tp.f,o=Qh(n),a={},u=0;o.length>u;)void 0!==(r=i(n,e=o[u++]))&&ep(a,e,r);return a}});var rp=r(rt.Object.getOwnPropertyDescriptors),np={exports:{}},ip=jr,op=P,ap=ei.f;ip({target:"Object",stat:!0,forced:Object.defineProperties!==ap,sham:!op},{defineProperties:ap});var up=rt.Object,sp=np.exports=function(t,e){return up.defineProperties(t,e)};up.defineProperties.sham&&(sp.sham=!0);var cp=r(np.exports),fp=r(Lr);jr({target:"Array",stat:!0},{isArray:Fr});var lp=rt.Array.isArray,hp=r(lp);var pp=jr,vp=Fr,dp=kn,yp=et,gp=oi,mp=Vr,bp=Q,_p=Qr,wp=he,Ep=Iu,Tp=Nn("slice"),Op=wp("species"),xp=Array,kp=Math.max;pp({target:"Array",proto:!0,forced:!Tp},{slice:function(t,e){var r,n,i,o=bp(this),a=mp(o),u=gp(t,a),s=gp(void 0===e?a:e,a);if(vp(o)&&(r=o.constructor,(dp(r)&&(r===xp||vp(r.prototype))||yp(r)&&null===(r=r[Op]))&&(r=void 0),r===xp||void 0===r))return Ep(o,u,s);for(n=new(void 0===r?xp:r)(kp(s-u,0)),i=0;u<s;u++,i++)u in o&&_p(n,i,o[u]);return n.length=i,n}});var Sp=Hf("Array").slice,jp=st,Ap=Sp,Pp=Array.prototype,Ip=function(t){var e=t.slice;return t===Pp||jp(Pp,t)&&e===Pp.slice?Ap:e},Dp=Ip,Cp=r(Dp),Lp=r(Ch);function Rp(t,e){(null==e||e>t.length)&&(e=t.length);for(var r=0,n=new Array(e);r<e;r++)n[r]=t[r];return n}function Mp(t,e){var r;if(t){if("string"==typeof t)return Rp(t,e);var n=Cp(r=Object.prototype.toString.call(t)).call(r,8,-1);return"Object"===n&&t.constructor&&(n=t.constructor.name),"Map"===n||"Set"===n?Lp(t):"Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)?Rp(t,e):void 0}}function Np(t,e){return function(t){if(hp(t))return t}(t)||function(t,e){var r=null==t?null:void 0!==cf&&Rh(t)||t["@@iterator"];if(null!=r){var n,i,o,a,u=[],s=!0,c=!1;try{if(o=(r=r.call(t)).next,0===e){if(Object(r)!==r)return;s=!1}else for(;!(s=(n=o.call(r)).done)&&(u.push(n.value),u.length!==e);s=!0);}catch(t){c=!0,i=t}finally{try{if(!s&&null!=r.return&&(a=r.return(),Object(a)!==a))return}finally{if(c)throw i}}return u}}(t,e)||Mp(t,e)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}function Fp(t){return function(t){if(hp(t))return Rp(t)}(t)||function(t){if(void 0!==cf&&null!=Rh(t)||null!=t["@@iterator"])return Lp(t)}(t)||Mp(t)||function(){throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var zp=r(zc),Up=Hf("Array").concat,qp=st,Yp=Up,Wp=Array.prototype,Gp=r((function(t){var e=t.concat;return t===Wp||qp(Wp,t)&&e===Wp.concat?Yp:e})),Xp=r(Ip);jr({target:"Reflect",stat:!0},{ownKeys:Kh});var Vp=r(rt.Reflect.ownKeys),Bp=r(lp),Hp=$t,$p=wi;jr({target:"Object",stat:!0,forced:a((function(){$p(1)}))},{keys:function(t){return $p(Hp(t))}});var Jp=r(rt.Object.keys),Kp=ua.forEach,Qp=cl("forEach")?[].forEach:function(t){return Kp(this,t,arguments.length>1?arguments[1]:void 0)};jr({target:"Array",proto:!0,forced:[].forEach!=Qp},{forEach:Qp});var Zp=Hf("Array").forEach,tv=sn,ev=Qt,rv=st,nv=Zp,iv=Array.prototype,ov={DOMTokenList:!0,NodeList:!0},av=function(t){var e=t.forEach;return t===iv||rv(iv,t)&&e===iv.forEach||ev(ov,tv(t))?nv:e},uv=r(av),sv=jr,cv=Fr,fv=g([].reverse),lv=[1,2];sv({target:"Array",proto:!0,forced:String(lv)===String(lv.reverse())},{reverse:function(){return cv(this)&&(this.length=this.length),fv(this)}});var hv=Hf("Array").reverse,pv=st,vv=hv,dv=Array.prototype,yv=function(t){var e=t.reverse;return t===dv||pv(dv,t)&&e===dv.reverse?vv:e},gv=r(yv),mv=P,bv=Fr,_v=TypeError,wv=Object.getOwnPropertyDescriptor,Ev=mv&&!function(){if(void 0!==this)return!0;try{Object.defineProperty([],"length",{writable:!1}).length=1}catch(t){return t instanceof TypeError}}(),Tv=St,Ov=TypeError,xv=function(t,e){if(!delete t[e])throw Ov("Cannot delete property "+Tv(e)+" of "+Tv(t))},kv=jr,Sv=$t,jv=oi,Av=Yr,Pv=Vr,Iv=Ev?function(t,e){if(bv(t)&&!wv(t,"length").writable)throw _v("Cannot set read only .length");return t.length=e}:function(t,e){return t.length=e},Dv=Hr,Cv=Cn,Lv=Qr,Rv=xv,Mv=Nn("splice"),Nv=Math.max,Fv=Math.min;kv({target:"Array",proto:!0,forced:!Mv},{splice:function(t,e){var r,n,i,o,a,u,s=Sv(this),c=Pv(s),f=jv(t,c),l=arguments.length;for(0===l?r=n=0:1===l?(r=0,n=c-f):(r=l-2,n=Fv(Nv(Av(e),0),c-f)),Dv(c+r-n),i=Cv(s,n),o=0;o<n;o++)(a=f+o)in s&&Lv(i,o,s[a]);if(i.length=n,r<n){for(o=f;o<c-n;o++)u=o+r,(a=o+n)in s?s[u]=s[a]:Rv(s,u);for(o=c;o>c-n+r;o--)Rv(s,o-1)}else if(r>n)for(o=c-n;o>f;o--)u=o+r-1,(a=o+n-1)in s?s[u]=s[a]:Rv(s,u);for(o=0;o<r;o++)s[o+f]=arguments[o+2];return Iv(s,c-n+r),i}});var zv=Hf("Array").splice,Uv=st,qv=zv,Yv=Array.prototype,Wv=r((function(t){var e=t.splice;return t===Yv||Uv(Yv,t)&&e===Yv.splice?qv:e})),Gv=P,Xv=g,Vv=C,Bv=a,Hv=wi,$v=so,Jv=L,Kv=$t,Qv=X,Zv=Object.assign,td=Object.defineProperty,ed=Xv([].concat),rd=!Zv||Bv((function(){if(Gv&&1!==Zv({b:1},Zv(td({},"a",{enumerable:!0,get:function(){td(this,"b",{value:3,enumerable:!1})}}),{b:2})).b)return!0;var t={},e={},r=Symbol(),n="abcdefghijklmnopqrst";return t[r]=7,n.split("").forEach((function(t){e[t]=t})),7!=Zv({},t)[r]||Hv(Zv({},e)).join("")!=n}))?function(t,e){for(var r=Kv(t),n=arguments.length,i=1,o=$v.f,a=Jv.f;n>i;)for(var u,s=Qv(arguments[i++]),c=o?ed(Hv(s),o(s)):Hv(s),f=c.length,l=0;f>l;)u=c[l++],Gv&&!Vv(a,s,u)||(r[u]=s[u]);return r}:Zv,nd=rd;jr({target:"Object",stat:!0,arity:2,forced:Object.assign!==nd},{assign:nd});var id=r(rt.Object.assign),od=$t,ad=Ds,ud=Os;jr({target:"Object",stat:!0,forced:a((function(){ad(1)})),sham:!ud},{getPrototypeOf:function(t){return ad(od(t))}});var sd=rt.Object.getPrototypeOf;jr({target:"Object",stat:!0,sham:!P},{create:Vi});var cd=rt.Object,fd=function(t,e){return cd.create(t,e)},ld=r(fd),hd=rt,pd=h;hd.JSON||(hd.JSON={stringify:JSON.stringify});var vd=r((function(t,e,r){return pd(hd.JSON.stringify,null,arguments)})),dd="function"==typeof Bun&&Bun&&"string"==typeof Bun.version,yd=TypeError,gd=function(t,e){if(t<e)throw yd("Not enough arguments");return t},md=o,bd=h,_d=j,wd=dd,Ed=ct,Td=Iu,Od=gd,xd=md.Function,kd=/MSIE .\./.test(Ed)||wd&&function(){var t=md.Bun.version.split(".");return t.length<3||0==t[0]&&(t[1]<3||3==t[1]&&0==t[2])}(),Sd=function(t,e){var r=e?2:1;return kd?function(n,i){var o=Od(arguments.length,1)>r,a=_d(n)?n:xd(n),u=o?Td(arguments,r):[],s=o?function(){bd(a,this,u)}:a;return e?t(s,i):t(s)}:t},jd=jr,Ad=o,Pd=Sd(Ad.setInterval,!0);jd({global:!0,bind:!0,forced:Ad.setInterval!==Pd},{setInterval:Pd});var Id=jr,Dd=o,Cd=Sd(Dd.setTimeout,!0);Id({global:!0,bind:!0,forced:Dd.setTimeout!==Cd},{setTimeout:Cd});var Ld=r(rt.setTimeout),Rd={exports:{}};!function(t){function e(t){if(t)return function(t){for(var r in e.prototype)t[r]=e.prototype[r];return t}(t)}Rd.exports=e,e.prototype.on=e.prototype.addEventListener=function(t,e){return this._callbacks=this._callbacks||{},(this._callbacks["$"+t]=this._callbacks["$"+t]||[]).push(e),this},e.prototype.once=function(t,e){function r(){this.off(t,r),e.apply(this,arguments)}return r.fn=e,this.on(t,r),this},e.prototype.off=e.prototype.removeListener=e.prototype.removeAllListeners=e.prototype.removeEventListener=function(t,e){if(this._callbacks=this._callbacks||{},0==arguments.length)return this._callbacks={},this;var r,n=this._callbacks["$"+t];if(!n)return this;if(1==arguments.length)return delete this._callbacks["$"+t],this;for(var i=0;i<n.length;i++)if((r=n[i])===e||r.fn===e){n.splice(i,1);break}return 0===n.length&&delete this._callbacks["$"+t],this},e.prototype.emit=function(t){this._callbacks=this._callbacks||{};for(var e=new Array(arguments.length-1),r=this._callbacks["$"+t],n=1;n<arguments.length;n++)e[n-1]=arguments[n];if(r){n=0;for(var i=(r=r.slice(0)).length;n<i;++n)r[n].apply(this,e)}return this},e.prototype.listeners=function(t){return this._callbacks=this._callbacks||{},this._callbacks["$"+t]||[]},e.prototype.hasListeners=function(t){return!!this.listeners(t).length}}();var Md=r(Rd.exports);
/*! Hammer.JS - v2.0.17-rc - 2019-12-16
 * http://naver.github.io/egjs
 *
 * Forked By Naver egjs
 * Copyright (c) hammerjs
 * Licensed under the MIT license */
function Nd(){return Nd=Object.assign||function(t){for(var e=1;e<arguments.length;e++){var r=arguments[e];for(var n in r)Object.prototype.hasOwnProperty.call(r,n)&&(t[n]=r[n])}return t},Nd.apply(this,arguments)}function Fd(t,e){t.prototype=Object.create(e.prototype),t.prototype.constructor=t,t.__proto__=e}function zd(t){if(void 0===t)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return t}var Ud,qd="function"!=typeof Object.assign?function(t){if(null==t)throw new TypeError("Cannot convert undefined or null to object");for(var e=Object(t),r=1;r<arguments.length;r++){var n=arguments[r];if(null!=n)for(var i in n)n.hasOwnProperty(i)&&(e[i]=n[i])}return e}:Object.assign,Yd=["","webkit","Moz","MS","ms","o"],Wd="undefined"==typeof document?{style:{}}:document.createElement("div"),Gd=Math.round,Xd=Math.abs,Vd=Date.now;function Bd(t,e){for(var r,n,i=e[0].toUpperCase()+e.slice(1),o=0;o<Yd.length;){if((n=(r=Yd[o])?r+i:e)in t)return n;o++}}Ud="undefined"==typeof window?{}:window;var Hd=Bd(Wd.style,"touchAction"),$d=void 0!==Hd;var Jd="compute",Kd="auto",Qd="manipulation",Zd="none",ty="pan-x",ey="pan-y",ry=function(){if(!$d)return!1;var t={},e=Ud.CSS&&Ud.CSS.supports;return["auto","manipulation","pan-y","pan-x","pan-x pan-y","none"].forEach((function(r){return t[r]=!e||Ud.CSS.supports("touch-action",r)})),t}(),ny="ontouchstart"in Ud,iy=void 0!==Bd(Ud,"PointerEvent"),oy=ny&&/mobile|tablet|ip(ad|hone|od)|android/i.test(navigator.userAgent),ay="touch",uy="mouse",sy=25,cy=1,fy=4,ly=8,hy=1,py=2,vy=4,dy=8,yy=16,gy=py|vy,my=dy|yy,by=gy|my,_y=["x","y"],wy=["clientX","clientY"];function Ey(t,e,r){var n;if(t)if(t.forEach)t.forEach(e,r);else if(void 0!==t.length)for(n=0;n<t.length;)e.call(r,t[n],n,t),n++;else for(n in t)t.hasOwnProperty(n)&&e.call(r,t[n],n,t)}function Ty(t,e){return"function"==typeof t?t.apply(e&&e[0]||void 0,e):t}function Oy(t,e){return t.indexOf(e)>-1}var xy=function(){function t(t,e){this.manager=t,this.set(e)}var e=t.prototype;return e.set=function(t){t===Jd&&(t=this.compute()),$d&&this.manager.element.style&&ry[t]&&(this.manager.element.style[Hd]=t),this.actions=t.toLowerCase().trim()},e.update=function(){this.set(this.manager.options.touchAction)},e.compute=function(){var t=[];return Ey(this.manager.recognizers,(function(e){Ty(e.options.enable,[e])&&(t=t.concat(e.getTouchAction()))})),function(t){if(Oy(t,Zd))return Zd;var e=Oy(t,ty),r=Oy(t,ey);return e&&r?Zd:e||r?e?ty:ey:Oy(t,Qd)?Qd:Kd}(t.join(" "))},e.preventDefaults=function(t){var e=t.srcEvent,r=t.offsetDirection;if(this.manager.session.prevented)e.preventDefault();else{var n=this.actions,i=Oy(n,Zd)&&!ry[Zd],o=Oy(n,ey)&&!ry[ey],a=Oy(n,ty)&&!ry[ty];if(i){var u=1===t.pointers.length,s=t.distance<2,c=t.deltaTime<250;if(u&&s&&c)return}if(!a||!o)return i||o&&r&gy||a&&r&my?this.preventSrc(e):void 0}},e.preventSrc=function(t){this.manager.session.prevented=!0,t.preventDefault()},t}();function ky(t,e){for(;t;){if(t===e)return!0;t=t.parentNode}return!1}function Sy(t){var e=t.length;if(1===e)return{x:Gd(t[0].clientX),y:Gd(t[0].clientY)};for(var r=0,n=0,i=0;i<e;)r+=t[i].clientX,n+=t[i].clientY,i++;return{x:Gd(r/e),y:Gd(n/e)}}function jy(t){for(var e=[],r=0;r<t.pointers.length;)e[r]={clientX:Gd(t.pointers[r].clientX),clientY:Gd(t.pointers[r].clientY)},r++;return{timeStamp:Vd(),pointers:e,center:Sy(e),deltaX:t.deltaX,deltaY:t.deltaY}}function Ay(t,e,r){r||(r=_y);var n=e[r[0]]-t[r[0]],i=e[r[1]]-t[r[1]];return Math.sqrt(n*n+i*i)}function Py(t,e,r){r||(r=_y);var n=e[r[0]]-t[r[0]],i=e[r[1]]-t[r[1]];return 180*Math.atan2(i,n)/Math.PI}function Iy(t,e){return t===e?hy:Xd(t)>=Xd(e)?t<0?py:vy:e<0?dy:yy}function Dy(t,e,r){return{x:e/t||0,y:r/t||0}}function Cy(t,e){var r=t.session,n=e.pointers,i=n.length;r.firstInput||(r.firstInput=jy(e)),i>1&&!r.firstMultiple?r.firstMultiple=jy(e):1===i&&(r.firstMultiple=!1);var o=r.firstInput,a=r.firstMultiple,u=a?a.center:o.center,s=e.center=Sy(n);e.timeStamp=Vd(),e.deltaTime=e.timeStamp-o.timeStamp,e.angle=Py(u,s),e.distance=Ay(u,s),function(t,e){var r=e.center,n=t.offsetDelta||{},i=t.prevDelta||{},o=t.prevInput||{};e.eventType!==cy&&o.eventType!==fy||(i=t.prevDelta={x:o.deltaX||0,y:o.deltaY||0},n=t.offsetDelta={x:r.x,y:r.y}),e.deltaX=i.x+(r.x-n.x),e.deltaY=i.y+(r.y-n.y)}(r,e),e.offsetDirection=Iy(e.deltaX,e.deltaY);var c,f,l=Dy(e.deltaTime,e.deltaX,e.deltaY);e.overallVelocityX=l.x,e.overallVelocityY=l.y,e.overallVelocity=Xd(l.x)>Xd(l.y)?l.x:l.y,e.scale=a?(c=a.pointers,Ay((f=n)[0],f[1],wy)/Ay(c[0],c[1],wy)):1,e.rotation=a?function(t,e){return Py(e[1],e[0],wy)+Py(t[1],t[0],wy)}(a.pointers,n):0,e.maxPointers=r.prevInput?e.pointers.length>r.prevInput.maxPointers?e.pointers.length:r.prevInput.maxPointers:e.pointers.length,function(t,e){var r,n,i,o,a=t.lastInterval||e,u=e.timeStamp-a.timeStamp;if(e.eventType!==ly&&(u>sy||void 0===a.velocity)){var s=e.deltaX-a.deltaX,c=e.deltaY-a.deltaY,f=Dy(u,s,c);n=f.x,i=f.y,r=Xd(f.x)>Xd(f.y)?f.x:f.y,o=Iy(s,c),t.lastInterval=e}else r=a.velocity,n=a.velocityX,i=a.velocityY,o=a.direction;e.velocity=r,e.velocityX=n,e.velocityY=i,e.direction=o}(r,e);var h,p=t.element,v=e.srcEvent;ky(h=v.composedPath?v.composedPath()[0]:v.path?v.path[0]:v.target,p)&&(p=h),e.target=p}function Ly(t,e,r){var n=r.pointers.length,i=r.changedPointers.length,o=e&cy&&n-i==0,a=e&(fy|ly)&&n-i==0;r.isFirst=!!o,r.isFinal=!!a,o&&(t.session={}),r.eventType=e,Cy(t,r),t.emit("hammer.input",r),t.recognize(r),t.session.prevInput=r}function Ry(t){return t.trim().split(/\s+/g)}function My(t,e,r){Ey(Ry(e),(function(e){t.addEventListener(e,r,!1)}))}function Ny(t,e,r){Ey(Ry(e),(function(e){t.removeEventListener(e,r,!1)}))}function Fy(t){var e=t.ownerDocument||t;return e.defaultView||e.parentWindow||window}var zy=function(){function t(t,e){var r=this;this.manager=t,this.callback=e,this.element=t.element,this.target=t.options.inputTarget,this.domHandler=function(e){Ty(t.options.enable,[t])&&r.handler(e)},this.init()}var e=t.prototype;return e.handler=function(){},e.init=function(){this.evEl&&My(this.element,this.evEl,this.domHandler),this.evTarget&&My(this.target,this.evTarget,this.domHandler),this.evWin&&My(Fy(this.element),this.evWin,this.domHandler)},e.destroy=function(){this.evEl&&Ny(this.element,this.evEl,this.domHandler),this.evTarget&&Ny(this.target,this.evTarget,this.domHandler),this.evWin&&Ny(Fy(this.element),this.evWin,this.domHandler)},t}();function Uy(t,e,r){if(t.indexOf&&!r)return t.indexOf(e);for(var n=0;n<t.length;){if(r&&t[n][r]==e||!r&&t[n]===e)return n;n++}return-1}var qy={pointerdown:cy,pointermove:2,pointerup:fy,pointercancel:ly,pointerout:ly},Yy={2:ay,3:"pen",4:uy,5:"kinect"},Wy="pointerdown",Gy="pointermove pointerup pointercancel";Ud.MSPointerEvent&&!Ud.PointerEvent&&(Wy="MSPointerDown",Gy="MSPointerMove MSPointerUp MSPointerCancel");var Xy=function(t){function e(){var r,n=e.prototype;return n.evEl=Wy,n.evWin=Gy,(r=t.apply(this,arguments)||this).store=r.manager.session.pointerEvents=[],r}return Fd(e,t),e.prototype.handler=function(t){var e=this.store,r=!1,n=t.type.toLowerCase().replace("ms",""),i=qy[n],o=Yy[t.pointerType]||t.pointerType,a=o===ay,u=Uy(e,t.pointerId,"pointerId");i&cy&&(0===t.button||a)?u<0&&(e.push(t),u=e.length-1):i&(fy|ly)&&(r=!0),u<0||(e[u]=t,this.callback(this.manager,i,{pointers:e,changedPointers:[t],pointerType:o,srcEvent:t}),r&&e.splice(u,1))},e}(zy);function Vy(t){return Array.prototype.slice.call(t,0)}function By(t,e,r){for(var n=[],i=[],o=0;o<t.length;){var a=e?t[o][e]:t[o];Uy(i,a)<0&&n.push(t[o]),i[o]=a,o++}return r&&(n=e?n.sort((function(t,r){return t[e]>r[e]})):n.sort()),n}var Hy={touchstart:cy,touchmove:2,touchend:fy,touchcancel:ly},$y=function(t){function e(){var r;return e.prototype.evTarget="touchstart touchmove touchend touchcancel",(r=t.apply(this,arguments)||this).targetIds={},r}return Fd(e,t),e.prototype.handler=function(t){var e=Hy[t.type],r=Jy.call(this,t,e);r&&this.callback(this.manager,e,{pointers:r[0],changedPointers:r[1],pointerType:ay,srcEvent:t})},e}(zy);function Jy(t,e){var r,n,i=Vy(t.touches),o=this.targetIds;if(e&(2|cy)&&1===i.length)return o[i[0].identifier]=!0,[i,i];var a=Vy(t.changedTouches),u=[],s=this.target;if(n=i.filter((function(t){return ky(t.target,s)})),e===cy)for(r=0;r<n.length;)o[n[r].identifier]=!0,r++;for(r=0;r<a.length;)o[a[r].identifier]&&u.push(a[r]),e&(fy|ly)&&delete o[a[r].identifier],r++;return u.length?[By(n.concat(u),"identifier",!0),u]:void 0}var Ky={mousedown:cy,mousemove:2,mouseup:fy},Qy=function(t){function e(){var r,n=e.prototype;return n.evEl="mousedown",n.evWin="mousemove mouseup",(r=t.apply(this,arguments)||this).pressed=!1,r}return Fd(e,t),e.prototype.handler=function(t){var e=Ky[t.type];e&cy&&0===t.button&&(this.pressed=!0),2&e&&1!==t.which&&(e=fy),this.pressed&&(e&fy&&(this.pressed=!1),this.callback(this.manager,e,{pointers:[t],changedPointers:[t],pointerType:uy,srcEvent:t}))},e}(zy),Zy=2500;function tg(t){var e=t.changedPointers[0];if(e.identifier===this.primaryTouch){var r={x:e.clientX,y:e.clientY},n=this.lastTouches;this.lastTouches.push(r);setTimeout((function(){var t=n.indexOf(r);t>-1&&n.splice(t,1)}),Zy)}}function eg(t,e){t&cy?(this.primaryTouch=e.changedPointers[0].identifier,tg.call(this,e)):t&(fy|ly)&&tg.call(this,e)}function rg(t){for(var e=t.srcEvent.clientX,r=t.srcEvent.clientY,n=0;n<this.lastTouches.length;n++){var i=this.lastTouches[n],o=Math.abs(e-i.x),a=Math.abs(r-i.y);if(o<=25&&a<=25)return!0}return!1}var ng=function(){return function(t){function e(e,r){var n;return(n=t.call(this,e,r)||this).handler=function(t,e,r){var i=r.pointerType===ay,o=r.pointerType===uy;if(!(o&&r.sourceCapabilities&&r.sourceCapabilities.firesTouchEvents)){if(i)eg.call(zd(zd(n)),e,r);else if(o&&rg.call(zd(zd(n)),r))return;n.callback(t,e,r)}},n.touch=new $y(n.manager,n.handler),n.mouse=new Qy(n.manager,n.handler),n.primaryTouch=null,n.lastTouches=[],n}return Fd(e,t),e.prototype.destroy=function(){this.touch.destroy(),this.mouse.destroy()},e}(zy)}();function ig(t,e,r){return!!Array.isArray(t)&&(Ey(t,r[e],r),!0)}var og=32,ag=1;function ug(t,e){var r=e.manager;return r?r.get(t):t}function sg(t){return 16&t?"cancel":8&t?"end":4&t?"move":2&t?"start":""}var cg=function(){function t(t){void 0===t&&(t={}),this.options=Nd({enable:!0},t),this.id=ag++,this.manager=null,this.state=1,this.simultaneous={},this.requireFail=[]}var e=t.prototype;return e.set=function(t){return qd(this.options,t),this.manager&&this.manager.touchAction.update(),this},e.recognizeWith=function(t){if(ig(t,"recognizeWith",this))return this;var e=this.simultaneous;return e[(t=ug(t,this)).id]||(e[t.id]=t,t.recognizeWith(this)),this},e.dropRecognizeWith=function(t){return ig(t,"dropRecognizeWith",this)||(t=ug(t,this),delete this.simultaneous[t.id]),this},e.requireFailure=function(t){if(ig(t,"requireFailure",this))return this;var e=this.requireFail;return-1===Uy(e,t=ug(t,this))&&(e.push(t),t.requireFailure(this)),this},e.dropRequireFailure=function(t){if(ig(t,"dropRequireFailure",this))return this;t=ug(t,this);var e=Uy(this.requireFail,t);return e>-1&&this.requireFail.splice(e,1),this},e.hasRequireFailures=function(){return this.requireFail.length>0},e.canRecognizeWith=function(t){return!!this.simultaneous[t.id]},e.emit=function(t){var e=this,r=this.state;function n(r){e.manager.emit(r,t)}r<8&&n(e.options.event+sg(r)),n(e.options.event),t.additionalEvent&&n(t.additionalEvent),r>=8&&n(e.options.event+sg(r))},e.tryEmit=function(t){if(this.canEmit())return this.emit(t);this.state=og},e.canEmit=function(){for(var t=0;t<this.requireFail.length;){if(!(33&this.requireFail[t].state))return!1;t++}return!0},e.recognize=function(t){var e=qd({},t);if(!Ty(this.options.enable,[this,e]))return this.reset(),void(this.state=og);56&this.state&&(this.state=1),this.state=this.process(e),30&this.state&&this.tryEmit(e)},e.process=function(t){},e.getTouchAction=function(){},e.reset=function(){},t}(),fg=function(t){function e(e){var r;return void 0===e&&(e={}),(r=t.call(this,Nd({event:"tap",pointers:1,taps:1,interval:300,time:250,threshold:9,posThreshold:10},e))||this).pTime=!1,r.pCenter=!1,r._timer=null,r._input=null,r.count=0,r}Fd(e,t);var r=e.prototype;return r.getTouchAction=function(){return[Qd]},r.process=function(t){var e=this,r=this.options,n=t.pointers.length===r.pointers,i=t.distance<r.threshold,o=t.deltaTime<r.time;if(this.reset(),t.eventType&cy&&0===this.count)return this.failTimeout();if(i&&o&&n){if(t.eventType!==fy)return this.failTimeout();var a=!this.pTime||t.timeStamp-this.pTime<r.interval,u=!this.pCenter||Ay(this.pCenter,t.center)<r.posThreshold;if(this.pTime=t.timeStamp,this.pCenter=t.center,u&&a?this.count+=1:this.count=1,this._input=t,0===this.count%r.taps)return this.hasRequireFailures()?(this._timer=setTimeout((function(){e.state=8,e.tryEmit()}),r.interval),2):8}return og},r.failTimeout=function(){var t=this;return this._timer=setTimeout((function(){t.state=og}),this.options.interval),og},r.reset=function(){clearTimeout(this._timer)},r.emit=function(){8===this.state&&(this._input.tapCount=this.count,this.manager.emit(this.options.event,this._input))},e}(cg),lg=function(t){function e(e){return void 0===e&&(e={}),t.call(this,Nd({pointers:1},e))||this}Fd(e,t);var r=e.prototype;return r.attrTest=function(t){var e=this.options.pointers;return 0===e||t.pointers.length===e},r.process=function(t){var e=this.state,r=t.eventType,n=6&e,i=this.attrTest(t);return n&&(r&ly||!i)?16|e:n||i?r&fy?8|e:2&e?4|e:2:og},e}(cg);function hg(t){return t===yy?"down":t===dy?"up":t===py?"left":t===vy?"right":""}var pg=function(t){function e(e){var r;return void 0===e&&(e={}),(r=t.call(this,Nd({event:"pan",threshold:10,pointers:1,direction:by},e))||this).pX=null,r.pY=null,r}Fd(e,t);var r=e.prototype;return r.getTouchAction=function(){var t=this.options.direction,e=[];return t&gy&&e.push(ey),t&my&&e.push(ty),e},r.directionTest=function(t){var e=this.options,r=!0,n=t.distance,i=t.direction,o=t.deltaX,a=t.deltaY;return i&e.direction||(e.direction&gy?(i=0===o?hy:o<0?py:vy,r=o!==this.pX,n=Math.abs(t.deltaX)):(i=0===a?hy:a<0?dy:yy,r=a!==this.pY,n=Math.abs(t.deltaY))),t.direction=i,r&&n>e.threshold&&i&e.direction},r.attrTest=function(t){return lg.prototype.attrTest.call(this,t)&&(2&this.state||!(2&this.state)&&this.directionTest(t))},r.emit=function(e){this.pX=e.deltaX,this.pY=e.deltaY;var r=hg(e.direction);r&&(e.additionalEvent=this.options.event+r),t.prototype.emit.call(this,e)},e}(lg),vg=function(t){function e(e){return void 0===e&&(e={}),t.call(this,Nd({event:"swipe",threshold:10,velocity:.3,direction:gy|my,pointers:1},e))||this}Fd(e,t);var r=e.prototype;return r.getTouchAction=function(){return pg.prototype.getTouchAction.call(this)},r.attrTest=function(e){var r,n=this.options.direction;return n&(gy|my)?r=e.overallVelocity:n&gy?r=e.overallVelocityX:n&my&&(r=e.overallVelocityY),t.prototype.attrTest.call(this,e)&&n&e.offsetDirection&&e.distance>this.options.threshold&&e.maxPointers===this.options.pointers&&Xd(r)>this.options.velocity&&e.eventType&fy},r.emit=function(t){var e=hg(t.offsetDirection);e&&this.manager.emit(this.options.event+e,t),this.manager.emit(this.options.event,t)},e}(lg),dg=function(t){function e(e){return void 0===e&&(e={}),t.call(this,Nd({event:"pinch",threshold:0,pointers:2},e))||this}Fd(e,t);var r=e.prototype;return r.getTouchAction=function(){return[Zd]},r.attrTest=function(e){return t.prototype.attrTest.call(this,e)&&(Math.abs(e.scale-1)>this.options.threshold||2&this.state)},r.emit=function(e){if(1!==e.scale){var r=e.scale<1?"in":"out";e.additionalEvent=this.options.event+r}t.prototype.emit.call(this,e)},e}(lg),yg=function(t){function e(e){return void 0===e&&(e={}),t.call(this,Nd({event:"rotate",threshold:0,pointers:2},e))||this}Fd(e,t);var r=e.prototype;return r.getTouchAction=function(){return[Zd]},r.attrTest=function(e){return t.prototype.attrTest.call(this,e)&&(Math.abs(e.rotation)>this.options.threshold||2&this.state)},e}(lg),gg=function(t){function e(e){var r;return void 0===e&&(e={}),(r=t.call(this,Nd({event:"press",pointers:1,time:251,threshold:9},e))||this)._timer=null,r._input=null,r}Fd(e,t);var r=e.prototype;return r.getTouchAction=function(){return[Kd]},r.process=function(t){var e=this,r=this.options,n=t.pointers.length===r.pointers,i=t.distance<r.threshold,o=t.deltaTime>r.time;if(this._input=t,!i||!n||t.eventType&(fy|ly)&&!o)this.reset();else if(t.eventType&cy)this.reset(),this._timer=setTimeout((function(){e.state=8,e.tryEmit()}),r.time);else if(t.eventType&fy)return 8;return og},r.reset=function(){clearTimeout(this._timer)},r.emit=function(t){8===this.state&&(t&&t.eventType&fy?this.manager.emit(this.options.event+"up",t):(this._input.timeStamp=Vd(),this.manager.emit(this.options.event,this._input)))},e}(cg),mg={domEvents:!1,touchAction:Jd,enable:!0,inputTarget:null,inputClass:null,cssProps:{userSelect:"none",touchSelect:"none",touchCallout:"none",contentZooming:"none",userDrag:"none",tapHighlightColor:"rgba(0,0,0,0)"}},bg=[[yg,{enable:!1}],[dg,{enable:!1},["rotate"]],[vg,{direction:gy}],[pg,{direction:gy},["swipe"]],[fg],[fg,{event:"doubletap",taps:2},["tap"]],[gg]];function _g(t,e){var r,n=t.element;n.style&&(Ey(t.options.cssProps,(function(i,o){r=Bd(n.style,o),e?(t.oldCssProps[r]=n.style[r],n.style[r]=i):n.style[r]=t.oldCssProps[r]||""})),e||(t.oldCssProps={}))}var wg=function(){function t(t,e){var r,n=this;this.options=qd({},mg,e||{}),this.options.inputTarget=this.options.inputTarget||t,this.handlers={},this.session={},this.recognizers=[],this.oldCssProps={},this.element=t,this.input=new((r=this).options.inputClass||(iy?Xy:oy?$y:ny?ng:Qy))(r,Ly),this.touchAction=new xy(this,this.options.touchAction),_g(this,!0),Ey(this.options.recognizers,(function(t){var e=n.add(new t[0](t[1]));t[2]&&e.recognizeWith(t[2]),t[3]&&e.requireFailure(t[3])}),this)}var e=t.prototype;return e.set=function(t){return qd(this.options,t),t.touchAction&&this.touchAction.update(),t.inputTarget&&(this.input.destroy(),this.input.target=t.inputTarget,this.input.init()),this},e.stop=function(t){this.session.stopped=t?2:1},e.recognize=function(t){var e=this.session;if(!e.stopped){var r;this.touchAction.preventDefaults(t);var n=this.recognizers,i=e.curRecognizer;(!i||i&&8&i.state)&&(e.curRecognizer=null,i=null);for(var o=0;o<n.length;)r=n[o],2===e.stopped||i&&r!==i&&!r.canRecognizeWith(i)?r.reset():r.recognize(t),!i&&14&r.state&&(e.curRecognizer=r,i=r),o++}},e.get=function(t){if(t instanceof cg)return t;for(var e=this.recognizers,r=0;r<e.length;r++)if(e[r].options.event===t)return e[r];return null},e.add=function(t){if(ig(t,"add",this))return this;var e=this.get(t.options.event);return e&&this.remove(e),this.recognizers.push(t),t.manager=this,this.touchAction.update(),t},e.remove=function(t){if(ig(t,"remove",this))return this;var e=this.get(t);if(t){var r=this.recognizers,n=Uy(r,e);-1!==n&&(r.splice(n,1),this.touchAction.update())}return this},e.on=function(t,e){if(void 0===t||void 0===e)return this;var r=this.handlers;return Ey(Ry(t),(function(t){r[t]=r[t]||[],r[t].push(e)})),this},e.off=function(t,e){if(void 0===t)return this;var r=this.handlers;return Ey(Ry(t),(function(t){e?r[t]&&r[t].splice(Uy(r[t],e),1):delete r[t]})),this},e.emit=function(t,e){this.options.domEvents&&function(t,e){var r=document.createEvent("Event");r.initEvent(t,!0,!0),r.gesture=e,e.target.dispatchEvent(r)}(t,e);var r=this.handlers[t]&&this.handlers[t].slice();if(r&&r.length){e.type=t,e.preventDefault=function(){e.srcEvent.preventDefault()};for(var n=0;n<r.length;)r[n](e),n++}},e.destroy=function(){this.element&&_g(this,!1),this.handlers={},this.session={},this.input.destroy(),this.element=null},t}(),Eg={touchstart:cy,touchmove:2,touchend:fy,touchcancel:ly},Tg=function(t){function e(){var r,n=e.prototype;return n.evTarget="touchstart",n.evWin="touchstart touchmove touchend touchcancel",(r=t.apply(this,arguments)||this).started=!1,r}return Fd(e,t),e.prototype.handler=function(t){var e=Eg[t.type];if(e===cy&&(this.started=!0),this.started){var r=Og.call(this,t,e);e&(fy|ly)&&r[0].length-r[1].length==0&&(this.started=!1),this.callback(this.manager,e,{pointers:r[0],changedPointers:r[1],pointerType:ay,srcEvent:t})}},e}(zy);function Og(t,e){var r=Vy(t.touches),n=Vy(t.changedTouches);return e&(fy|ly)&&(r=By(r.concat(n),"identifier",!0)),[r,n]}function xg(t,e,r){var n="DEPRECATED METHOD: "+e+"\n"+r+" AT \n";return function(){var e=new Error("get-stack-trace"),r=e&&e.stack?e.stack.replace(/^[^\(]+?[\n$]/gm,"").replace(/^\s+at\s+/gm,"").replace(/^Object.<anonymous>\s*\(/gm,"{anonymous}()@"):"Unknown Stack Trace",i=window.console&&(window.console.warn||window.console.log);return i&&i.call(window.console,n,r),t.apply(this,arguments)}}var kg=xg((function(t,e,r){for(var n=Object.keys(e),i=0;i<n.length;)(!r||r&&void 0===t[n[i]])&&(t[n[i]]=e[n[i]]),i++;return t}),"extend","Use `assign`."),Sg=xg((function(t,e){return kg(t,e,!0)}),"merge","Use `assign`.");function jg(t,e,r){var n,i=e.prototype;(n=t.prototype=Object.create(i)).constructor=t,n._super=i,r&&qd(n,r)}function Ag(t,e){return function(){return t.apply(e,arguments)}}var Pg=function(){var t=function(t,e){return void 0===e&&(e={}),new wg(t,Nd({recognizers:bg.concat()},e))};return t.VERSION="2.0.17-rc",t.DIRECTION_ALL=by,t.DIRECTION_DOWN=yy,t.DIRECTION_LEFT=py,t.DIRECTION_RIGHT=vy,t.DIRECTION_UP=dy,t.DIRECTION_HORIZONTAL=gy,t.DIRECTION_VERTICAL=my,t.DIRECTION_NONE=hy,t.DIRECTION_DOWN=yy,t.INPUT_START=cy,t.INPUT_MOVE=2,t.INPUT_END=fy,t.INPUT_CANCEL=ly,t.STATE_POSSIBLE=1,t.STATE_BEGAN=2,t.STATE_CHANGED=4,t.STATE_ENDED=8,t.STATE_RECOGNIZED=8,t.STATE_CANCELLED=16,t.STATE_FAILED=og,t.Manager=wg,t.Input=zy,t.TouchAction=xy,t.TouchInput=$y,t.MouseInput=Qy,t.PointerEventInput=Xy,t.TouchMouseInput=ng,t.SingleTouchInput=Tg,t.Recognizer=cg,t.AttrRecognizer=lg,t.Tap=fg,t.Pan=pg,t.Swipe=vg,t.Pinch=dg,t.Rotate=yg,t.Press=gg,t.on=My,t.off=Ny,t.each=Ey,t.merge=Sg,t.extend=kg,t.bindFn=Ag,t.assign=qd,t.inherit=jg,t.bindFn=Ag,t.prefixed=Bd,t.toArray=Vy,t.inArray=Uy,t.uniqueArray=By,t.splitStr=Ry,t.boolOrFn=Ty,t.hasParent=ky,t.addEventListeners=My,t.removeEventListeners=Ny,t.defaults=qd({},mg,{preset:bg}),t}();function Ig(t,e){var r=void 0!==zp&&Rh(t)||t["@@iterator"];if(!r){if(Bp(t)||(r=function(t,e){var r;if(!t)return;if("string"==typeof t)return Dg(t,e);var n=Xp(r=Object.prototype.toString.call(t)).call(r,8,-1);"Object"===n&&t.constructor&&(n=t.constructor.name);if("Map"===n||"Set"===n)return Lh(t);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return Dg(t,e)}(t))||e&&t&&"number"==typeof t.length){r&&(t=r);var n=0,i=function(){};return{s:i,n:function(){return n>=t.length?{done:!0}:{done:!1,value:t[n++]}},e:function(t){throw t},f:i}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var o,a=!0,u=!1;return{s:function(){r=r.call(t)},n:function(){var t=r.next();return a=t.done,t},e:function(t){u=!0,o=t},f:function(){try{a||null==r.return||r.return()}finally{if(u)throw o}}}}function Dg(t,e){(null==e||e>t.length)&&(e=t.length);for(var r=0,n=new Array(e);r<e;r++)n[r]=t[r];return n}var Cg=zp("DELETE");function Lg(){var t=Rg.apply(void 0,arguments);return Ng(t),t}function Rg(){for(var t=arguments.length,e=new Array(t),r=0;r<t;r++)e[r]=arguments[r];if(e.length<2)return e[0];var n;if(e.length>2)return Rg.apply(void 0,Gp(n=[Lg(e[0],e[1])]).call(n,Fp(Xp(e).call(e,2))));var i,o=e[0],a=e[1],u=Ig(Vp(a));try{for(u.s();!(i=u.n()).done;){var s=i.value;Object.prototype.propertyIsEnumerable.call(a,s)&&(a[s]===Cg?delete o[s]:null===o[s]||null===a[s]||"object"!==Af(o[s])||"object"!==Af(a[s])||Bp(o[s])||Bp(a[s])?o[s]=Mg(a[s]):o[s]=Rg(o[s],a[s]))}}catch(t){u.e(t)}finally{u.f()}return o}function Mg(t){return Bp(t)?jl(t).call(t,(function(t){return Mg(t)})):"object"===Af(t)&&null!==t?Rg({},t):t}function Ng(t){for(var e=0,r=Jp(t);e<r.length;e++){var n=r[e];t[n]===Cg?delete t[n]:"object"===Af(t[n])&&null!==t[n]&&Ng(t[n])}}var Fg="undefined"!=typeof window?window.Hammer||Pg:function(){return function(){var t=function(){};return{on:t,off:t,destroy:t,emit:t,get:function(){return{set:t}}}}()};function zg(t){var e,r=this;this._cleanupQueue=[],this.active=!1,this._dom={container:t,overlay:document.createElement("div")},this._dom.overlay.classList.add("vis-overlay"),this._dom.container.appendChild(this._dom.overlay),this._cleanupQueue.push((function(){r._dom.overlay.parentNode.removeChild(r._dom.overlay)}));var n=Fg(this._dom.overlay);n.on("tap",tl(e=this._onTapOverlay).call(e,this)),this._cleanupQueue.push((function(){n.destroy()}));var i=["tap","doubletap","press","pinch","pan","panstart","panmove","panend"];uv(i).call(i,(function(t){n.on(t,(function(t){t.srcEvent.stopPropagation()}))})),document&&document.body&&(this._onClick=function(e){(function(t,e){for(;t;){if(t===e)return!0;t=t.parentNode}return!1})(e.target,t)||r.deactivate()},document.body.addEventListener("click",this._onClick),this._cleanupQueue.push((function(){document.body.removeEventListener("click",r._onClick)}))),this._escListener=function(t){("key"in t?"Escape"===t.key:27===t.keyCode)&&r.deactivate()}}Md(zg.prototype),zg.current=null,zg.prototype.destroy=function(){var t,e;this.deactivate();var r,n=Ig(gv(t=Wv(e=this._cleanupQueue).call(e,0)).call(t));try{for(n.s();!(r=n.n()).done;){(0,r.value)()}}catch(t){n.e(t)}finally{n.f()}},zg.prototype.activate=function(){zg.current&&zg.current.deactivate(),zg.current=this,this.active=!0,this._dom.overlay.style.display="none",this._dom.container.classList.add("vis-active"),this.emit("change"),this.emit("activate"),document.body.addEventListener("keydown",this._escListener)},zg.prototype.deactivate=function(){this.active=!1,this._dom.overlay.style.display="block",this._dom.container.classList.remove("vis-active"),document.body.removeEventListener("keydown",this._escListener),this.emit("change"),this.emit("deactivate")},zg.prototype._onTapOverlay=function(t){this.activate(),t.srcEvent.stopPropagation()};var Ug=kn,qg=St,Yg=TypeError,Wg=function(t){if(Ug(t))return t;throw Yg(qg(t)+" is not a constructor")},Gg=jr,Xg=h,Vg=Xf,Bg=Wg,Hg=rr,$g=et,Jg=Vi,Kg=a,Qg=ut("Reflect","construct"),Zg=Object.prototype,tm=[].push,em=Kg((function(){function t(){}return!(Qg((function(){}),[],t)instanceof t)})),rm=!Kg((function(){Qg((function(){}))})),nm=em||rm;Gg({target:"Reflect",stat:!0,forced:nm,sham:nm},{construct:function(t,e){Bg(t),Hg(e);var r=arguments.length<3?t:Bg(arguments[2]);if(rm&&!em)return Qg(t,e,r);if(t==r){switch(e.length){case 0:return new t;case 1:return new t(e[0]);case 2:return new t(e[0],e[1]);case 3:return new t(e[0],e[1],e[2]);case 4:return new t(e[0],e[1],e[2],e[3])}var n=[null];return Xg(tm,n,e),new(Xg(Vg,t,n))}var i=r.prototype,o=Jg($g(i)?i:Zg),a=Xg(t,o,e);return $g(a)?a:o}});var im=r(rt.Reflect.construct);function om(t){if(void 0===t)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return t}var am=fd,um=r(am);jr({target:"Object",stat:!0},{setPrototypeOf:nc});var sm=rt.Object.setPrototypeOf,cm=r(sm),fm=r(Zf);function lm(t,e){var r;return lm=cm?fm(r=cm).call(r):function(t,e){return t.__proto__=e,t},lm(t,e)}function hm(t,e){if("function"!=typeof e&&null!==e)throw new TypeError("Super expression must either be null or a function");t.prototype=um(e&&e.prototype,{constructor:{value:t,writable:!0,configurable:!0}}),Mr(t,"prototype",{writable:!1}),e&&lm(t,e)}function pm(t,e){if(e&&("object"===Af(e)||"function"==typeof e))return e;if(void 0!==e)throw new TypeError("Derived constructors may only return object or undefined");return om(t)}var vm=sd,dm=r(vm);function ym(t){var e;return ym=cm?fm(e=dm).call(e):function(t){return t.__proto__||dm(t)},ym(t)}var gm={exports:{}},mm={exports:{}};!function(t){var e=sf,r=Sf;function n(i){return t.exports=n="function"==typeof e&&"symbol"==typeof r?function(t){return typeof t}:function(t){return t&&"function"==typeof e&&t.constructor===e&&t!==e.prototype?"symbol":typeof t},t.exports.__esModule=!0,t.exports.default=t.exports,n(i)}t.exports=n,t.exports.__esModule=!0,t.exports.default=t.exports}(mm);var bm=mm.exports,_m=av,wm=Qt,Em=Kh,Tm=A,Om=Ke,xm=et,km=yr,Sm=Error,jm=g("".replace),Am=String(Sm("zxcasd").stack),Pm=/\n\s*at [^:]*:[^\n]*/,Im=Pm.test(Am),Dm=U,Cm=!a((function(){var t=Error("a");return!("stack"in t)||(Object.defineProperty(t,"stack",Dm(1,7)),7!==t.stack)})),Lm=yr,Rm=function(t,e){if(Im&&"string"==typeof t&&!Sm.prepareStackTrace)for(;e--;)t=jm(t,Pm,"");return t},Mm=Cm,Nm=Error.captureStackTrace,Fm=Je,zm=C,Um=rr,qm=St,Ym=rh,Wm=Vr,Gm=st,Xm=dh,Vm=sh,Bm=Jl,Hm=TypeError,$m=function(t,e){this.stopped=t,this.result=e},Jm=$m.prototype,Km=function(t,e,r){var n,i,o,a,u,s,c,f=r&&r.that,l=!(!r||!r.AS_ENTRIES),h=!(!r||!r.IS_RECORD),p=!(!r||!r.IS_ITERATOR),v=!(!r||!r.INTERRUPTED),d=Fm(e,f),y=function(t){return n&&Bm(n,"normal",t),new $m(!0,t)},g=function(t){return l?(Um(t),v?d(t[0],t[1],y):d(t[0],t[1])):v?d(t,y):d(t)};if(h)n=t.iterator;else if(p)n=t;else{if(!(i=Vm(t)))throw Hm(qm(t)+" is not iterable");if(Ym(i)){for(o=0,a=Wm(t);a>o;o++)if((u=g(t[o]))&&Gm(Jm,u))return u;return new $m(!1)}n=Xm(t,i)}for(s=h?t.next:n.next;!(c=zm(s,n)).done;){try{u=g(c.value)}catch(t){Bm(n,"throw",t)}if("object"==typeof u&&u&&Gm(Jm,u))return u}return new $m(!1)},Qm=ti,Zm=jr,tb=st,eb=Ds,rb=nc,nb=function(t,e,r){for(var n=Em(e),i=Om.f,o=Tm.f,a=0;a<n.length;a++){var u=n[a];wm(t,u)||r&&wm(r,u)||i(t,u,o(e,u))}},ib=Vi,ob=yr,ab=U,ub=function(t,e){xm(e)&&"cause"in e&&km(t,"cause",e.cause)},sb=function(t,e,r,n){Mm&&(Nm?Nm(t,e):Lm(t,"stack",Rm(r,n)))},cb=Km,fb=function(t,e){return void 0===t?arguments.length<2?"":e:Qm(t)},lb=he("toStringTag"),hb=Error,pb=[].push,vb=function(t,e){var r,n=tb(db,this);rb?r=rb(hb(),n?eb(this):db):(r=n?this:ib(db),ob(r,lb,"Error")),void 0!==e&&ob(r,"message",fb(e)),sb(r,vb,r.stack,1),arguments.length>2&&ub(r,arguments[2]);var i=[];return cb(t,pb,{that:i}),ob(r,"errors",i),r};rb?rb(vb,hb):nb(vb,hb,{name:!0});var db=vb.prototype=ib(hb.prototype,{constructor:ab(1,vb),message:ab(1,""),name:ab(1,"AggregateError")});Zm({global:!0,constructor:!0,arity:2},{AggregateError:vb});var yb,gb,mb,bb,_b=ut,wb=ho,Eb=P,Tb=he("species"),Ob=function(t){var e=_b(t);Eb&&e&&!e[Tb]&&wb(e,Tb,{configurable:!0,get:function(){return this}})},xb=st,kb=TypeError,Sb=function(t,e){if(xb(e,t))return t;throw kb("Incorrect invocation")},jb=rr,Ab=Wg,Pb=V,Ib=he("species"),Db=function(t,e){var r,n=jb(t).constructor;return void 0===n||Pb(r=jb(n)[Ib])?e:Ab(r)},Cb=/(?:ipad|iphone|ipod).*applewebkit/i.test(ct),Lb=o,Rb=h,Mb=Je,Nb=j,Fb=Qt,zb=a,Ub=Ai,qb=Iu,Yb=ke,Wb=gd,Gb=Cb,Xb=fl,Vb=Lb.setImmediate,Bb=Lb.clearImmediate,Hb=Lb.process,$b=Lb.Dispatch,Jb=Lb.Function,Kb=Lb.MessageChannel,Qb=Lb.String,Zb=0,t_={},e_="onreadystatechange";zb((function(){yb=Lb.location}));var r_=function(t){if(Fb(t_,t)){var e=t_[t];delete t_[t],e()}},n_=function(t){return function(){r_(t)}},i_=function(t){r_(t.data)},o_=function(t){Lb.postMessage(Qb(t),yb.protocol+"//"+yb.host)};Vb&&Bb||(Vb=function(t){Wb(arguments.length,1);var e=Nb(t)?t:Jb(t),r=qb(arguments,1);return t_[++Zb]=function(){Rb(e,void 0,r)},gb(Zb),Zb},Bb=function(t){delete t_[t]},Xb?gb=function(t){Hb.nextTick(n_(t))}:$b&&$b.now?gb=function(t){$b.now(n_(t))}:Kb&&!Gb?(bb=(mb=new Kb).port2,mb.port1.onmessage=i_,gb=Mb(bb.postMessage,bb)):Lb.addEventListener&&Nb(Lb.postMessage)&&!Lb.importScripts&&yb&&"file:"!==yb.protocol&&!zb(o_)?(gb=o_,Lb.addEventListener("message",i_,!1)):gb=e_ in Yb("script")?function(t){Ub.appendChild(Yb("script"))[e_]=function(){Ub.removeChild(this),r_(t)}}:function(t){setTimeout(n_(t),0)});var a_={set:Vb,clear:Bb},u_=function(){this.head=null,this.tail=null};u_.prototype={add:function(t){var e={item:t,next:null},r=this.tail;r?r.next=e:this.head=e,this.tail=e},get:function(){var t=this.head;if(t)return null===(this.head=t.next)&&(this.tail=null),t.item}};var s_,c_,f_,l_,h_,p_=u_,v_=/ipad|iphone|ipod/i.test(ct)&&"undefined"!=typeof Pebble,d_=/web0s(?!.*chrome)/i.test(ct),y_=o,g_=Je,m_=A.f,b_=a_.set,__=p_,w_=Cb,E_=v_,T_=d_,O_=fl,x_=y_.MutationObserver||y_.WebKitMutationObserver,k_=y_.document,S_=y_.process,j_=y_.Promise,A_=m_(y_,"queueMicrotask"),P_=A_&&A_.value;if(!P_){var I_=new __,D_=function(){var t,e;for(O_&&(t=S_.domain)&&t.exit();e=I_.get();)try{e()}catch(t){throw I_.head&&s_(),t}t&&t.enter()};w_||O_||T_||!x_||!k_?!E_&&j_&&j_.resolve?((l_=j_.resolve(void 0)).constructor=j_,h_=g_(l_.then,l_),s_=function(){h_(D_)}):O_?s_=function(){S_.nextTick(D_)}:(b_=g_(b_,y_),s_=function(){b_(D_)}):(c_=!0,f_=k_.createTextNode(""),new x_(D_).observe(f_,{characterData:!0}),s_=function(){f_.data=c_=!c_}),P_=function(t){I_.head||s_(),I_.add(t)}}var C_=P_,L_=function(t){try{return{error:!1,value:t()}}catch(t){return{error:!0,value:t}}},R_=o.Promise,M_="object"==typeof Deno&&Deno&&"object"==typeof Deno.version,N_=!M_&&!fl&&"object"==typeof window&&"object"==typeof document,F_=o,z_=R_,U_=j,q_=Ve,Y_=hn,W_=he,G_=N_,X_=M_,V_=yt,B_=z_&&z_.prototype,H_=W_("species"),$_=!1,J_=U_(F_.PromiseRejectionEvent),K_=q_("Promise",(function(){var t=Y_(z_),e=t!==String(z_);if(!e&&66===V_)return!0;if(!B_.catch||!B_.finally)return!0;if(!V_||V_<51||!/native code/.test(t)){var r=new z_((function(t){t(1)})),n=function(t){t((function(){}),(function(){}))};if((r.constructor={})[H_]=n,!($_=r.then((function(){}))instanceof n))return!0}return!e&&(G_||X_)&&!J_})),Q_={CONSTRUCTOR:K_,REJECTION_EVENT:J_,SUBCLASSING:$_},Z_={},tw=It,ew=TypeError,rw=function(t){var e,r;this.promise=new t((function(t,n){if(void 0!==e||void 0!==r)throw ew("Bad Promise constructor");e=t,r=n})),this.resolve=tw(e),this.reject=tw(r)};Z_.f=function(t){return new rw(t)};var nw,iw,ow=jr,aw=fl,uw=o,sw=C,cw=fo,fw=No,lw=Ob,hw=It,pw=j,vw=et,dw=Sb,yw=Db,gw=a_.set,mw=C_,bw=function(t,e){try{1==arguments.length?console.error(t):console.error(t,e)}catch(t){}},_w=L_,ww=p_,Ew=Zo,Tw=R_,Ow=Q_,xw=Z_,kw="Promise",Sw=Ow.CONSTRUCTOR,jw=Ow.REJECTION_EVENT,Aw=Ew.getterFor(kw),Pw=Ew.set,Iw=Tw&&Tw.prototype,Dw=Tw,Cw=Iw,Lw=uw.TypeError,Rw=uw.document,Mw=uw.process,Nw=xw.f,Fw=Nw,zw=!!(Rw&&Rw.createEvent&&uw.dispatchEvent),Uw="unhandledrejection",qw=function(t){var e;return!(!vw(t)||!pw(e=t.then))&&e},Yw=function(t,e){var r,n,i,o=e.value,a=1==e.state,u=a?t.ok:t.fail,s=t.resolve,c=t.reject,f=t.domain;try{u?(a||(2===e.rejection&&Bw(e),e.rejection=1),!0===u?r=o:(f&&f.enter(),r=u(o),f&&(f.exit(),i=!0)),r===t.promise?c(Lw("Promise-chain cycle")):(n=qw(r))?sw(n,r,s,c):s(r)):c(o)}catch(t){f&&!i&&f.exit(),c(t)}},Ww=function(t,e){t.notified||(t.notified=!0,mw((function(){for(var r,n=t.reactions;r=n.get();)Yw(r,t);t.notified=!1,e&&!t.rejection&&Xw(t)})))},Gw=function(t,e,r){var n,i;zw?((n=Rw.createEvent("Event")).promise=e,n.reason=r,n.initEvent(t,!1,!0),uw.dispatchEvent(n)):n={promise:e,reason:r},!jw&&(i=uw["on"+t])?i(n):t===Uw&&bw("Unhandled promise rejection",r)},Xw=function(t){sw(gw,uw,(function(){var e,r=t.facade,n=t.value;if(Vw(t)&&(e=_w((function(){aw?Mw.emit("unhandledRejection",n,r):Gw(Uw,r,n)})),t.rejection=aw||Vw(t)?2:1,e.error))throw e.value}))},Vw=function(t){return 1!==t.rejection&&!t.parent},Bw=function(t){sw(gw,uw,(function(){var e=t.facade;aw?Mw.emit("rejectionHandled",e):Gw("rejectionhandled",e,t.value)}))},Hw=function(t,e,r){return function(n){t(e,n,r)}},$w=function(t,e,r){t.done||(t.done=!0,r&&(t=r),t.value=e,t.state=2,Ww(t,!0))},Jw=function(t,e,r){if(!t.done){t.done=!0,r&&(t=r);try{if(t.facade===e)throw Lw("Promise can't be resolved itself");var n=qw(e);n?mw((function(){var r={done:!1};try{sw(n,e,Hw(Jw,r,t),Hw($w,r,t))}catch(e){$w(r,e,t)}})):(t.value=e,t.state=1,Ww(t,!1))}catch(e){$w({done:!1},e,t)}}};Sw&&(Cw=(Dw=function(t){dw(this,Cw),hw(t),sw(nw,this);var e=Aw(this);try{t(Hw(Jw,e),Hw($w,e))}catch(t){$w(e,t)}}).prototype,(nw=function(t){Pw(this,{type:kw,done:!1,notified:!1,parent:!1,reactions:new ww,rejection:!1,state:0,value:void 0})}).prototype=cw(Cw,"then",(function(t,e){var r=Aw(this),n=Nw(yw(this,Dw));return r.parent=!0,n.ok=!pw(t)||t,n.fail=pw(e)&&e,n.domain=aw?Mw.domain:void 0,0==r.state?r.reactions.add(n):mw((function(){Yw(n,r)})),n.promise})),iw=function(){var t=new nw,e=Aw(t);this.promise=t,this.resolve=Hw(Jw,e),this.reject=Hw($w,e)},xw.f=Nw=function(t){return t===Dw||undefined===t?new iw(t):Fw(t)}),ow({global:!0,constructor:!0,wrap:!0,forced:Sw},{Promise:Dw}),fw(Dw,kw,!1,!0),lw(kw);var Kw=R_,Qw=Q_.CONSTRUCTOR||!Ih((function(t){Kw.all(t).then(void 0,(function(){}))})),Zw=C,tE=It,eE=Z_,rE=L_,nE=Km;jr({target:"Promise",stat:!0,forced:Qw},{all:function(t){var e=this,r=eE.f(e),n=r.resolve,i=r.reject,o=rE((function(){var r=tE(e.resolve),o=[],a=0,u=1;nE(t,(function(t){var s=a++,c=!1;u++,Zw(r,e,t).then((function(t){c||(c=!0,o[s]=t,--u||n(o))}),i)})),--u||n(o)}));return o.error&&i(o.value),r.promise}});var iE=jr,oE=Q_.CONSTRUCTOR;R_&&R_.prototype,iE({target:"Promise",proto:!0,forced:oE,real:!0},{catch:function(t){return this.then(void 0,t)}});var aE=C,uE=It,sE=Z_,cE=L_,fE=Km;jr({target:"Promise",stat:!0,forced:Qw},{race:function(t){var e=this,r=sE.f(e),n=r.reject,i=cE((function(){var i=uE(e.resolve);fE(t,(function(t){aE(i,e,t).then(r.resolve,n)}))}));return i.error&&n(i.value),r.promise}});var lE=C,hE=Z_;jr({target:"Promise",stat:!0,forced:Q_.CONSTRUCTOR},{reject:function(t){var e=hE.f(this);return lE(e.reject,void 0,t),e.promise}});var pE=rr,vE=et,dE=Z_,yE=function(t,e){if(pE(t),vE(e)&&e.constructor===t)return e;var r=dE.f(t);return(0,r.resolve)(e),r.promise},gE=jr,mE=R_,bE=Q_.CONSTRUCTOR,_E=yE,wE=ut("Promise"),EE=!bE;gE({target:"Promise",stat:!0,forced:true},{resolve:function(t){return _E(EE&&this===wE?mE:this,t)}});var TE=C,OE=It,xE=Z_,kE=L_,SE=Km;jr({target:"Promise",stat:!0,forced:Qw},{allSettled:function(t){var e=this,r=xE.f(e),n=r.resolve,i=r.reject,o=kE((function(){var r=OE(e.resolve),i=[],o=0,a=1;SE(t,(function(t){var u=o++,s=!1;a++,TE(r,e,t).then((function(t){s||(s=!0,i[u]={status:"fulfilled",value:t},--a||n(i))}),(function(t){s||(s=!0,i[u]={status:"rejected",reason:t},--a||n(i))}))})),--a||n(i)}));return o.error&&i(o.value),r.promise}});var jE=C,AE=It,PE=ut,IE=Z_,DE=L_,CE=Km,LE="No one promise resolved";jr({target:"Promise",stat:!0,forced:Qw},{any:function(t){var e=this,r=PE("AggregateError"),n=IE.f(e),i=n.resolve,o=n.reject,a=DE((function(){var n=AE(e.resolve),a=[],u=0,s=1,c=!1;CE(t,(function(t){var f=u++,l=!1;s++,jE(n,e,t).then((function(t){l||c||(c=!0,i(t))}),(function(t){l||c||(l=!0,a[f]=t,--s||o(new r(a,LE)))}))})),--s||o(new r(a,LE))}));return a.error&&o(a.value),n.promise}});var RE=jr,ME=R_,NE=a,FE=ut,zE=j,UE=Db,qE=yE,YE=ME&&ME.prototype;RE({target:"Promise",proto:!0,real:!0,forced:!!ME&&NE((function(){YE.finally.call({then:function(){}},(function(){}))}))},{finally:function(t){var e=UE(this,FE("Promise")),r=zE(t);return this.then(r?function(r){return qE(e,t()).then((function(){return r}))}:t,r?function(r){return qE(e,t()).then((function(){throw r}))}:t)}});var WE=rt.Promise,GE=Z_,XE=L_;jr({target:"Promise",stat:!0,forced:!0},{try:function(t){var e=GE.f(this),r=XE(t);return(r.error?e.reject:e.resolve)(r.value),e.promise}});var VE=WE,BE=yv;!function(t){var e=bm.default,r=Rr,n=sf,i=am,o=vm,a=_m,u=sm,s=VE,c=BE,f=Dp;function l(){t.exports=l=function(){return h},t.exports.__esModule=!0,t.exports.default=t.exports;var h={},p=Object.prototype,v=p.hasOwnProperty,d=r||function(t,e,r){t[e]=r.value},y="function"==typeof n?n:{},g=y.iterator||"@@iterator",m=y.asyncIterator||"@@asyncIterator",b=y.toStringTag||"@@toStringTag";function _(t,e,n){return r(t,e,{value:n,enumerable:!0,configurable:!0,writable:!0}),t[e]}try{_({},"")}catch(t){_=function(t,e,r){return t[e]=r}}function w(t,e,r,n){var o=e&&e.prototype instanceof O?e:O,a=i(o.prototype),u=new M(n||[]);return d(a,"_invoke",{value:D(t,r,u)}),a}function E(t,e,r){try{return{type:"normal",arg:t.call(e,r)}}catch(t){return{type:"throw",arg:t}}}h.wrap=w;var T={};function O(){}function x(){}function k(){}var S={};_(S,g,(function(){return this}));var j=o&&o(o(N([])));j&&j!==p&&v.call(j,g)&&(S=j);var A=k.prototype=O.prototype=i(S);function P(t){var e;a(e=["next","throw","return"]).call(e,(function(e){_(t,e,(function(t){return this._invoke(e,t)}))}))}function I(t,r){function n(i,o,a,u){var s=E(t[i],t,o);if("throw"!==s.type){var c=s.arg,f=c.value;return f&&"object"==e(f)&&v.call(f,"__await")?r.resolve(f.__await).then((function(t){n("next",t,a,u)}),(function(t){n("throw",t,a,u)})):r.resolve(f).then((function(t){c.value=t,a(c)}),(function(t){return n("throw",t,a,u)}))}u(s.arg)}var i;d(this,"_invoke",{value:function(t,e){function o(){return new r((function(r,i){n(t,e,r,i)}))}return i=i?i.then(o,o):o()}})}function D(t,e,r){var n="suspendedStart";return function(i,o){if("executing"===n)throw new Error("Generator is already running");if("completed"===n){if("throw"===i)throw o;return F()}for(r.method=i,r.arg=o;;){var a=r.delegate;if(a){var u=C(a,r);if(u){if(u===T)continue;return u}}if("next"===r.method)r.sent=r._sent=r.arg;else if("throw"===r.method){if("suspendedStart"===n)throw n="completed",r.arg;r.dispatchException(r.arg)}else"return"===r.method&&r.abrupt("return",r.arg);n="executing";var s=E(t,e,r);if("normal"===s.type){if(n=r.done?"completed":"suspendedYield",s.arg===T)continue;return{value:s.arg,done:r.done}}"throw"===s.type&&(n="completed",r.method="throw",r.arg=s.arg)}}}function C(t,e){var r=e.method,n=t.iterator[r];if(void 0===n)return e.delegate=null,"throw"===r&&t.iterator.return&&(e.method="return",e.arg=void 0,C(t,e),"throw"===e.method)||"return"!==r&&(e.method="throw",e.arg=new TypeError("The iterator does not provide a '"+r+"' method")),T;var i=E(n,t.iterator,e.arg);if("throw"===i.type)return e.method="throw",e.arg=i.arg,e.delegate=null,T;var o=i.arg;return o?o.done?(e[t.resultName]=o.value,e.next=t.nextLoc,"return"!==e.method&&(e.method="next",e.arg=void 0),e.delegate=null,T):o:(e.method="throw",e.arg=new TypeError("iterator result is not an object"),e.delegate=null,T)}function L(t){var e={tryLoc:t[0]};1 in t&&(e.catchLoc=t[1]),2 in t&&(e.finallyLoc=t[2],e.afterLoc=t[3]),this.tryEntries.push(e)}function R(t){var e=t.completion||{};e.type="normal",delete e.arg,t.completion=e}function M(t){this.tryEntries=[{tryLoc:"root"}],a(t).call(t,L,this),this.reset(!0)}function N(t){if(t){var e=t[g];if(e)return e.call(t);if("function"==typeof t.next)return t;if(!isNaN(t.length)){var r=-1,n=function e(){for(;++r<t.length;)if(v.call(t,r))return e.value=t[r],e.done=!1,e;return e.value=void 0,e.done=!0,e};return n.next=n}}return{next:F}}function F(){return{value:void 0,done:!0}}return x.prototype=k,d(A,"constructor",{value:k,configurable:!0}),d(k,"constructor",{value:x,configurable:!0}),x.displayName=_(k,b,"GeneratorFunction"),h.isGeneratorFunction=function(t){var e="function"==typeof t&&t.constructor;return!!e&&(e===x||"GeneratorFunction"===(e.displayName||e.name))},h.mark=function(t){return u?u(t,k):(t.__proto__=k,_(t,b,"GeneratorFunction")),t.prototype=i(A),t},h.awrap=function(t){return{__await:t}},P(I.prototype),_(I.prototype,m,(function(){return this})),h.AsyncIterator=I,h.async=function(t,e,r,n,i){void 0===i&&(i=s);var o=new I(w(t,e,r,n),i);return h.isGeneratorFunction(e)?o:o.next().then((function(t){return t.done?t.value:o.next()}))},P(A),_(A,b,"Generator"),_(A,g,(function(){return this})),_(A,"toString",(function(){return"[object Generator]"})),h.keys=function(t){var e=Object(t),r=[];for(var n in e)r.push(n);return c(r).call(r),function t(){for(;r.length;){var n=r.pop();if(n in e)return t.value=n,t.done=!1,t}return t.done=!0,t}},h.values=N,M.prototype={constructor:M,reset:function(t){var e;if(this.prev=0,this.next=0,this.sent=this._sent=void 0,this.done=!1,this.delegate=null,this.method="next",this.arg=void 0,a(e=this.tryEntries).call(e,R),!t)for(var r in this)"t"===r.charAt(0)&&v.call(this,r)&&!isNaN(+f(r).call(r,1))&&(this[r]=void 0)},stop:function(){this.done=!0;var t=this.tryEntries[0].completion;if("throw"===t.type)throw t.arg;return this.rval},dispatchException:function(t){if(this.done)throw t;var e=this;function r(r,n){return o.type="throw",o.arg=t,e.next=r,n&&(e.method="next",e.arg=void 0),!!n}for(var n=this.tryEntries.length-1;n>=0;--n){var i=this.tryEntries[n],o=i.completion;if("root"===i.tryLoc)return r("end");if(i.tryLoc<=this.prev){var a=v.call(i,"catchLoc"),u=v.call(i,"finallyLoc");if(a&&u){if(this.prev<i.catchLoc)return r(i.catchLoc,!0);if(this.prev<i.finallyLoc)return r(i.finallyLoc)}else if(a){if(this.prev<i.catchLoc)return r(i.catchLoc,!0)}else{if(!u)throw new Error("try statement without catch or finally");if(this.prev<i.finallyLoc)return r(i.finallyLoc)}}}},abrupt:function(t,e){for(var r=this.tryEntries.length-1;r>=0;--r){var n=this.tryEntries[r];if(n.tryLoc<=this.prev&&v.call(n,"finallyLoc")&&this.prev<n.finallyLoc){var i=n;break}}i&&("break"===t||"continue"===t)&&i.tryLoc<=e&&e<=i.finallyLoc&&(i=null);var o=i?i.completion:{};return o.type=t,o.arg=e,i?(this.method="next",this.next=i.finallyLoc,T):this.complete(o)},complete:function(t,e){if("throw"===t.type)throw t.arg;return"break"===t.type||"continue"===t.type?this.next=t.arg:"return"===t.type?(this.rval=this.arg=t.arg,this.method="return",this.next="end"):"normal"===t.type&&e&&(this.next=e),T},finish:function(t){for(var e=this.tryEntries.length-1;e>=0;--e){var r=this.tryEntries[e];if(r.finallyLoc===t)return this.complete(r.completion,r.afterLoc),R(r),T}},catch:function(t){for(var e=this.tryEntries.length-1;e>=0;--e){var r=this.tryEntries[e];if(r.tryLoc===t){var n=r.completion;if("throw"===n.type){var i=n.arg;R(r)}return i}}throw new Error("illegal catch attempt")},delegateYield:function(t,e,r){return this.delegate={iterator:N(t),resultName:e,nextLoc:r},"next"===this.method&&(this.arg=void 0),T}},h}t.exports=l,t.exports.__esModule=!0,t.exports.default=t.exports}(gm);var HE=(0,gm.exports)(),$E=HE;try{regeneratorRuntime=HE}catch(t){"object"==typeof globalThis?globalThis.regeneratorRuntime=HE:Function("r","regeneratorRuntime = r")(HE)}var JE=r($E),KE={exports:{}},QE=a((function(){if("function"==typeof ArrayBuffer){var t=new ArrayBuffer(8);Object.isExtensible(t)&&Object.defineProperty(t,"a",{value:8})}})),ZE=a,tT=et,eT=w,rT=QE,nT=Object.isExtensible,iT=ZE((function(){nT(1)}))||rT?function(t){return!!tT(t)&&((!rT||"ArrayBuffer"!=eT(t))&&(!nT||nT(t)))}:nT,oT=!a((function(){return Object.isExtensible(Object.preventExtensions({}))})),aT=jr,uT=g,sT=li,cT=et,fT=Qt,lT=Ke.f,hT=Bi,pT=Ji,vT=iT,dT=oT,yT=!1,gT=ne("meta"),mT=0,bT=function(t){lT(t,gT,{value:{objectID:"O"+mT++,weakData:{}}})},_T=KE.exports={enable:function(){_T.enable=function(){},yT=!0;var t=hT.f,e=uT([].splice),r={};r[gT]=1,t(r).length&&(hT.f=function(r){for(var n=t(r),i=0,o=n.length;i<o;i++)if(n[i]===gT){e(n,i,1);break}return n},aT({target:"Object",stat:!0,forced:!0},{getOwnPropertyNames:pT.f}))},fastKey:function(t,e){if(!cT(t))return"symbol"==typeof t?t:("string"==typeof t?"S":"P")+t;if(!fT(t,gT)){if(!vT(t))return"F";if(!e)return"E";bT(t)}return t[gT].objectID},getWeakData:function(t,e){if(!fT(t,gT)){if(!vT(t))return!0;if(!e)return!1;bT(t)}return t[gT].weakData},onFreeze:function(t){return dT&&yT&&vT(t)&&!fT(t,gT)&&bT(t),t}};sT[gT]=!0;var wT=KE.exports,ET=jr,TT=o,OT=wT,xT=a,kT=yr,ST=Km,jT=Sb,AT=j,PT=et,IT=No,DT=Ke.f,CT=ua.forEach,LT=P,RT=Zo.set,MT=Zo.getterFor,NT=function(t,e,r){var n,i=-1!==t.indexOf("Map"),o=-1!==t.indexOf("Weak"),a=i?"set":"add",u=TT[t],s=u&&u.prototype,c={};if(LT&&AT(u)&&(o||s.forEach&&!xT((function(){(new u).entries().next()})))){var f=(n=e((function(e,r){RT(jT(e,f),{type:t,collection:new u}),null!=r&&ST(r,e[a],{that:e,AS_ENTRIES:i})}))).prototype,l=MT(t);CT(["add","clear","delete","forEach","get","has","set","keys","values","entries"],(function(t){var e="add"==t||"set"==t;!(t in s)||o&&"clear"==t||kT(f,t,(function(r,n){var i=l(this).collection;if(!e&&o&&!PT(r))return"get"==t&&void 0;var a=i[t](0===r?0:r,n);return e?this:a}))})),o||DT(f,"size",{configurable:!0,get:function(){return l(this).collection.size}})}else n=r.getConstructor(e,t,i,a),OT.enable();return IT(n,t,!1,!0),c[t]=n,ET({global:!0,forced:!0},c),o||r.setStrong(n,t,i),n},FT=fo,zT=Vi,UT=ho,qT=function(t,e,r){for(var n in e)r&&r.unsafe&&t[n]?t[n]=e[n]:FT(t,n,e[n],r);return t},YT=Je,WT=Sb,GT=V,XT=Km,VT=_c,BT=wc,HT=Ob,$T=P,JT=wT.fastKey,KT=Zo.set,QT=Zo.getterFor,ZT={getConstructor:function(t,e,r,n){var i=t((function(t,i){WT(t,o),KT(t,{type:e,index:zT(null),first:void 0,last:void 0,size:0}),$T||(t.size=0),GT(i)||XT(i,t[n],{that:t,AS_ENTRIES:r})})),o=i.prototype,a=QT(e),u=function(t,e,r){var n,i,o=a(t),u=s(t,e);return u?u.value=r:(o.last=u={index:i=JT(e,!0),key:e,value:r,previous:n=o.last,next:void 0,removed:!1},o.first||(o.first=u),n&&(n.next=u),$T?o.size++:t.size++,"F"!==i&&(o.index[i]=u)),t},s=function(t,e){var r,n=a(t),i=JT(e);if("F"!==i)return n.index[i];for(r=n.first;r;r=r.next)if(r.key==e)return r};return qT(o,{clear:function(){for(var t=a(this),e=t.index,r=t.first;r;)r.removed=!0,r.previous&&(r.previous=r.previous.next=void 0),delete e[r.index],r=r.next;t.first=t.last=void 0,$T?t.size=0:this.size=0},delete:function(t){var e=this,r=a(e),n=s(e,t);if(n){var i=n.next,o=n.previous;delete r.index[n.index],n.removed=!0,o&&(o.next=i),i&&(i.previous=o),r.first==n&&(r.first=i),r.last==n&&(r.last=o),$T?r.size--:e.size--}return!!n},forEach:function(t){for(var e,r=a(this),n=YT(t,arguments.length>1?arguments[1]:void 0);e=e?e.next:r.first;)for(n(e.value,e.key,this);e&&e.removed;)e=e.previous},has:function(t){return!!s(this,t)}}),qT(o,r?{get:function(t){var e=s(this,t);return e&&e.value},set:function(t,e){return u(this,0===t?0:t,e)}}:{add:function(t){return u(this,t=0===t?0:t,t)}}),$T&&UT(o,"size",{configurable:!0,get:function(){return a(this).size}}),i},setStrong:function(t,e,r){var n=e+" Iterator",i=QT(e),o=QT(n);VT(t,e,(function(t,e){KT(this,{type:n,target:t,state:i(t),kind:e,last:void 0})}),(function(){for(var t=o(this),e=t.kind,r=t.last;r&&r.removed;)r=r.previous;return t.target&&(t.last=r=r?r.next:t.state.first)?BT("keys"==e?r.key:"values"==e?r.value:[r.key,r.value],!1):(t.target=void 0,BT(void 0,!0))}),r?"entries":"values",!r,!0),HT(e)}};NT("Map",(function(t){return function(){return t(this,arguments.length?arguments[0]:void 0)}}),ZT);var tO=r(rt.Map),eO=ua.some;jr({target:"Array",proto:!0,forced:!cl("some")},{some:function(t){return eO(this,t,arguments.length>1?arguments[1]:void 0)}});var rO=Hf("Array").some,nO=st,iO=rO,oO=Array.prototype,aO=r((function(t){var e=t.some;return t===oO||nO(oO,t)&&e===oO.some?iO:e})),uO=Hf("Array").keys,sO=sn,cO=Qt,fO=st,lO=uO,hO=Array.prototype,pO={DOMTokenList:!0,NodeList:!0},vO=r((function(t){var e=t.keys;return t===hO||fO(hO,t)&&e===hO.keys||cO(pO,sO(t))?lO:e})),dO=ro,yO=Math.floor,gO=function(t,e){var r=t.length,n=yO(r/2);return r<8?mO(t,e):bO(t,gO(dO(t,0,n),e),gO(dO(t,n),e),e)},mO=function(t,e){for(var r,n,i=t.length,o=1;o<i;){for(n=o,r=t[o];n&&e(t[n-1],r)>0;)t[n]=t[--n];n!==o++&&(t[n]=r)}return t},bO=function(t,e,r,n){for(var i=e.length,o=r.length,a=0,u=0;a<i||u<o;)t[a+u]=a<i&&u<o?n(e[a],r[u])<=0?e[a++]:r[u++]:a<i?e[a++]:r[u++];return t},_O=gO,wO=ct.match(/firefox\/(\d+)/i),EO=!!wO&&+wO[1],TO=/MSIE|Trident/.test(ct),OO=ct.match(/AppleWebKit\/(\d+)\./),xO=!!OO&&+OO[1],kO=jr,SO=g,jO=It,AO=$t,PO=Vr,IO=xv,DO=ti,CO=a,LO=_O,RO=cl,MO=EO,NO=TO,FO=yt,zO=xO,UO=[],qO=SO(UO.sort),YO=SO(UO.push),WO=CO((function(){UO.sort(void 0)})),GO=CO((function(){UO.sort(null)})),XO=RO("sort"),VO=!CO((function(){if(FO)return FO<70;if(!(MO&&MO>3)){if(NO)return!0;if(zO)return zO<603;var t,e,r,n,i="";for(t=65;t<76;t++){switch(e=String.fromCharCode(t),t){case 66:case 69:case 70:case 72:r=3;break;case 68:case 71:r=4;break;default:r=2}for(n=0;n<47;n++)UO.push({k:e+n,v:r})}for(UO.sort((function(t,e){return e.v-t.v})),n=0;n<UO.length;n++)e=UO[n].k.charAt(0),i.charAt(i.length-1)!==e&&(i+=e);return"DGBEFHACIJK"!==i}}));kO({target:"Array",proto:!0,forced:WO||!GO||!XO||!VO},{sort:function(t){void 0!==t&&jO(t);var e=AO(this);if(VO)return void 0===t?qO(e):qO(e,t);var r,n,i=[],o=PO(e);for(n=0;n<o;n++)n in e&&YO(i,e[n]);for(LO(i,function(t){return function(e,r){return void 0===r?-1:void 0===e?1:void 0!==t?+t(e,r)||0:DO(e)>DO(r)?1:-1}}(t)),r=PO(i),n=0;n<r;)e[n]=i[n++];for(;n<o;)IO(e,n++);return e}});var BO=Hf("Array").sort,HO=st,$O=BO,JO=Array.prototype,KO=r((function(t){var e=t.sort;return t===JO||HO(JO,t)&&e===JO.sort?$O:e})),QO=Hf("Array").values,ZO=sn,tx=Qt,ex=st,rx=QO,nx=Array.prototype,ix={DOMTokenList:!0,NodeList:!0},ox=r((function(t){var e=t.values;return t===nx||ex(nx,t)&&e===nx.values||tx(ix,ZO(t))?rx:e})),ax=r(kf),ux=Hf("Array").entries,sx=sn,cx=Qt,fx=st,lx=ux,hx=Array.prototype,px={DOMTokenList:!0,NodeList:!0},vx=r((function(t){var e=t.entries;return t===hx||fx(hx,t)&&e===hx.entries||cx(px,sx(t))?lx:e}));let dx;const yx=new Uint8Array(16);function gx(){if(!dx&&(dx="undefined"!=typeof crypto&&crypto.getRandomValues&&crypto.getRandomValues.bind(crypto),!dx))throw new Error("crypto.getRandomValues() not supported. See https://github.com/uuidjs/uuid#getrandomvalues-not-supported");return dx(yx)}const mx=[];for(let t=0;t<256;++t)mx.push((t+256).toString(16).slice(1));var bx={randomUUID:"undefined"!=typeof crypto&&crypto.randomUUID&&crypto.randomUUID.bind(crypto)};function _x(t,e,r){if(bx.randomUUID&&!e&&!t)return bx.randomUUID();const n=(t=t||{}).random||(t.rng||gx)();if(n[6]=15&n[6]|64,n[8]=63&n[8]|128,e){r=r||0;for(let t=0;t<16;++t)e[r+t]=n[t];return e}return function(t,e=0){return mx[t[e+0]]+mx[t[e+1]]+mx[t[e+2]]+mx[t[e+3]]+"-"+mx[t[e+4]]+mx[t[e+5]]+"-"+mx[t[e+6]]+mx[t[e+7]]+"-"+mx[t[e+8]]+mx[t[e+9]]+"-"+mx[t[e+10]]+mx[t[e+11]]+mx[t[e+12]]+mx[t[e+13]]+mx[t[e+14]]+mx[t[e+15]]}(n)}function wx(t){return"string"==typeof t||"number"==typeof t}var Ex=function(){function e(r){t(this,e),Lf(this,"delay",void 0),Lf(this,"max",void 0),Lf(this,"_queue",[]),Lf(this,"_timeout",null),Lf(this,"_extended",null),this.delay=null,this.max=1/0,this.setOptions(r)}return Cf(e,[{key:"setOptions",value:function(t){t&&void 0!==t.delay&&(this.delay=t.delay),t&&void 0!==t.max&&(this.max=t.max),this._flushIfNeeded()}},{key:"destroy",value:function(){if(this.flush(),this._extended){for(var t=this._extended.object,e=this._extended.methods,r=0;r<e.length;r++){var n=e[r];n.original?t[n.name]=n.original:delete t[n.name]}this._extended=null}}},{key:"replace",value:function(t,e){var r=this,n=t[e];if(!n)throw new Error("Method "+e+" undefined");t[e]=function(){for(var t=arguments.length,e=new Array(t),i=0;i<t;i++)e[i]=arguments[i];r.queue({args:e,fn:n,context:this})}}},{key:"queue",value:function(t){"function"==typeof t?this._queue.push({fn:t}):this._queue.push(t),this._flushIfNeeded()}},{key:"_flushIfNeeded",value:function(){var t=this;this._queue.length>this.max&&this.flush(),null!=this._timeout&&(clearTimeout(this._timeout),this._timeout=null),this.queue.length>0&&"number"==typeof this.delay&&(this._timeout=Ld((function(){t.flush()}),this.delay))}},{key:"flush",value:function(){var t,e;uv(t=Wv(e=this._queue).call(e,0)).call(t,(function(t){t.fn.apply(t.context||t.fn,t.args||[])}))}}],[{key:"extend",value:function(t,r){var n=new e(r);if(void 0!==t.flush)throw new Error("Target object already has a property flush");t.flush=function(){n.flush()};var i=[{name:"flush",original:void 0}];if(r&&r.replace)for(var o=0;o<r.replace.length;o++){var a=r.replace[o];i.push({name:a,original:t[a]}),n.replace(t,a)}return n._extended={object:t,methods:i},n}}]),e}(),Tx=function(){function e(){t(this,e),Lf(this,"_subscribers",{"*":[],add:[],remove:[],update:[]}),Lf(this,"subscribe",e.prototype.on),Lf(this,"unsubscribe",e.prototype.off)}return Cf(e,[{key:"_trigger",value:function(t,e,r){var n,i;if("*"===t)throw new Error("Cannot trigger event *");uv(n=Gp(i=[]).call(i,Fp(this._subscribers[t]),Fp(this._subscribers["*"]))).call(n,(function(n){n(t,e,null!=r?r:null)}))}},{key:"on",value:function(t,e){"function"==typeof e&&this._subscribers[t].push(e)}},{key:"off",value:function(t,e){var r;this._subscribers[t]=El(r=this._subscribers[t]).call(r,(function(t){return t!==e}))}}]),e}();NT("Set",(function(t){return function(){return t(this,arguments.length?arguments[0]:void 0)}}),ZT);var Ox,xx=r(rt.Set),kx=r(dh);function Sx(t,e){var r=void 0!==zp&&Rh(t)||t["@@iterator"];if(!r){if(Bp(t)||(r=function(t,e){var r;if(!t)return;if("string"==typeof t)return jx(t,e);var n=Xp(r=Object.prototype.toString.call(t)).call(r,8,-1);"Object"===n&&t.constructor&&(n=t.constructor.name);if("Map"===n||"Set"===n)return Lh(t);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return jx(t,e)}(t))||e&&t&&"number"==typeof t.length){r&&(t=r);var n=0,i=function(){};return{s:i,n:function(){return n>=t.length?{done:!0}:{done:!1,value:t[n++]}},e:function(t){throw t},f:i}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var o,a=!0,u=!1;return{s:function(){r=r.call(t)},n:function(){var t=r.next();return a=t.done,t},e:function(t){u=!0,o=t},f:function(){try{a||null==r.return||r.return()}finally{if(u)throw o}}}}function jx(t,e){(null==e||e>t.length)&&(e=t.length);for(var r=0,n=new Array(e);r<e;r++)n[r]=t[r];return n}Ox=ax;var Ax=function(){function e(r){t(this,e),Lf(this,"_pairs",void 0),this._pairs=r}return Cf(e,[{key:Ox,value:JE.mark((function t(){var e,r,n,i,o;return JE.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:e=Sx(this._pairs),t.prev=1,e.s();case 3:if((r=e.n()).done){t.next=9;break}return n=Np(r.value,2),i=n[0],o=n[1],t.next=7,[i,o];case 7:t.next=3;break;case 9:t.next=14;break;case 11:t.prev=11,t.t0=t.catch(1),e.e(t.t0);case 14:return t.prev=14,e.f(),t.finish(14);case 17:case"end":return t.stop()}}),t,this,[[1,11,14,17]])}))},{key:"entries",value:JE.mark((function t(){var e,r,n,i,o;return JE.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:e=Sx(this._pairs),t.prev=1,e.s();case 3:if((r=e.n()).done){t.next=9;break}return n=Np(r.value,2),i=n[0],o=n[1],t.next=7,[i,o];case 7:t.next=3;break;case 9:t.next=14;break;case 11:t.prev=11,t.t0=t.catch(1),e.e(t.t0);case 14:return t.prev=14,e.f(),t.finish(14);case 17:case"end":return t.stop()}}),t,this,[[1,11,14,17]])}))},{key:"keys",value:JE.mark((function t(){var e,r,n,i;return JE.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:e=Sx(this._pairs),t.prev=1,e.s();case 3:if((r=e.n()).done){t.next=9;break}return n=Np(r.value,1),i=n[0],t.next=7,i;case 7:t.next=3;break;case 9:t.next=14;break;case 11:t.prev=11,t.t0=t.catch(1),e.e(t.t0);case 14:return t.prev=14,e.f(),t.finish(14);case 17:case"end":return t.stop()}}),t,this,[[1,11,14,17]])}))},{key:"values",value:JE.mark((function t(){var e,r,n,i;return JE.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:e=Sx(this._pairs),t.prev=1,e.s();case 3:if((r=e.n()).done){t.next=9;break}return n=Np(r.value,2),i=n[1],t.next=7,i;case 7:t.next=3;break;case 9:t.next=14;break;case 11:t.prev=11,t.t0=t.catch(1),e.e(t.t0);case 14:return t.prev=14,e.f(),t.finish(14);case 17:case"end":return t.stop()}}),t,this,[[1,11,14,17]])}))},{key:"toIdArray",value:function(){var t;return jl(t=Fp(this._pairs)).call(t,(function(t){return t[0]}))}},{key:"toItemArray",value:function(){var t;return jl(t=Fp(this._pairs)).call(t,(function(t){return t[1]}))}},{key:"toEntryArray",value:function(){return Fp(this._pairs)}},{key:"toObjectMap",value:function(){var t,e=ld(null),r=Sx(this._pairs);try{for(r.s();!(t=r.n()).done;){var n=Np(t.value,2),i=n[0],o=n[1];e[i]=o}}catch(t){r.e(t)}finally{r.f()}return e}},{key:"toMap",value:function(){return new tO(this._pairs)}},{key:"toIdSet",value:function(){return new xx(this.toIdArray())}},{key:"toItemSet",value:function(){return new xx(this.toItemArray())}},{key:"cache",value:function(){return new e(Fp(this._pairs))}},{key:"distinct",value:function(t){var e,r=new xx,n=Sx(this._pairs);try{for(n.s();!(e=n.n()).done;){var i=Np(e.value,2),o=i[0],a=i[1];r.add(t(a,o))}}catch(t){n.e(t)}finally{n.f()}return r}},{key:"filter",value:function(t){var r=this._pairs;return new e(Lf({},ax,JE.mark((function e(){var n,i,o,a,u;return JE.wrap((function(e){for(;;)switch(e.prev=e.next){case 0:n=Sx(r),e.prev=1,n.s();case 3:if((i=n.n()).done){e.next=10;break}if(o=Np(i.value,2),a=o[0],u=o[1],!t(u,a)){e.next=8;break}return e.next=8,[a,u];case 8:e.next=3;break;case 10:e.next=15;break;case 12:e.prev=12,e.t0=e.catch(1),n.e(e.t0);case 15:return e.prev=15,n.f(),e.finish(15);case 18:case"end":return e.stop()}}),e,null,[[1,12,15,18]])}))))}},{key:"forEach",value:function(t){var e,r=Sx(this._pairs);try{for(r.s();!(e=r.n()).done;){var n=Np(e.value,2),i=n[0];t(n[1],i)}}catch(t){r.e(t)}finally{r.f()}}},{key:"map",value:function(t){var r=this._pairs;return new e(Lf({},ax,JE.mark((function e(){var n,i,o,a,u;return JE.wrap((function(e){for(;;)switch(e.prev=e.next){case 0:n=Sx(r),e.prev=1,n.s();case 3:if((i=n.n()).done){e.next=9;break}return o=Np(i.value,2),a=o[0],u=o[1],e.next=7,[a,t(u,a)];case 7:e.next=3;break;case 9:e.next=14;break;case 11:e.prev=11,e.t0=e.catch(1),n.e(e.t0);case 14:return e.prev=14,n.f(),e.finish(14);case 17:case"end":return e.stop()}}),e,null,[[1,11,14,17]])}))))}},{key:"max",value:function(t){var e=kx(this._pairs),r=e.next();if(r.done)return null;for(var n=r.value[1],i=t(r.value[1],r.value[0]);!(r=e.next()).done;){var o=Np(r.value,2),a=o[0],u=o[1],s=t(u,a);s>i&&(i=s,n=u)}return n}},{key:"min",value:function(t){var e=kx(this._pairs),r=e.next();if(r.done)return null;for(var n=r.value[1],i=t(r.value[1],r.value[0]);!(r=e.next()).done;){var o=Np(r.value,2),a=o[0],u=o[1],s=t(u,a);s<i&&(i=s,n=u)}return n}},{key:"reduce",value:function(t,e){var r,n=Sx(this._pairs);try{for(n.s();!(r=n.n()).done;){var i=Np(r.value,2),o=i[0];e=t(e,i[1],o)}}catch(t){n.e(t)}finally{n.f()}return e}},{key:"sort",value:function(t){var r=this;return new e(Lf({},ax,(function(){var e;return kx(KO(e=Fp(r._pairs)).call(e,(function(e,r){var n=Np(e,2),i=n[0],o=n[1],a=Np(r,2),u=a[0],s=a[1];return t(o,s,i,u)})))})))}}]),e}();function Px(t,e){var r=Jp(t);if(Mh){var n=Mh(t);e&&(n=El(n).call(n,(function(e){return Xh(t,e).enumerable}))),r.push.apply(r,n)}return r}function Ix(t){for(var e=1;e<arguments.length;e++){var r,n,i=null!=arguments[e]?arguments[e]:{};e%2?uv(r=Px(Object(i),!0)).call(r,(function(e){Lf(t,e,i[e])})):rp?cp(t,rp(i)):uv(n=Px(Object(i))).call(n,(function(e){fp(t,e,Xh(i,e))}))}return t}function Dx(t,e){var r=void 0!==zp&&Rh(t)||t["@@iterator"];if(!r){if(Bp(t)||(r=function(t,e){var r;if(!t)return;if("string"==typeof t)return Cx(t,e);var n=Xp(r=Object.prototype.toString.call(t)).call(r,8,-1);"Object"===n&&t.constructor&&(n=t.constructor.name);if("Map"===n||"Set"===n)return Lh(t);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return Cx(t,e)}(t))||e&&t&&"number"==typeof t.length){r&&(t=r);var n=0,i=function(){};return{s:i,n:function(){return n>=t.length?{done:!0}:{done:!1,value:t[n++]}},e:function(t){throw t},f:i}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var o,a=!0,u=!1;return{s:function(){r=r.call(t)},n:function(){var t=r.next();return a=t.done,t},e:function(t){u=!0,o=t},f:function(){try{a||null==r.return||r.return()}finally{if(u)throw o}}}}function Cx(t,e){(null==e||e>t.length)&&(e=t.length);for(var r=0,n=new Array(e);r<e;r++)n[r]=t[r];return n}function Lx(t){var e=function(){if("undefined"==typeof Reflect||!im)return!1;if(im.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(im(Boolean,[],(function(){}))),!0}catch(t){return!1}}();return function(){var r,n=ym(t);if(e){var i=ym(this).constructor;r=im(n,arguments,i)}else r=n.apply(this,arguments);return pm(this,r)}}var Rx=function(e){hm(n,Tx);var r=Lx(n);function n(e,i){var o;return t(this,n),Lf(om(o=r.call(this)),"flush",void 0),Lf(om(o),"length",void 0),Lf(om(o),"_options",void 0),Lf(om(o),"_data",void 0),Lf(om(o),"_idProp",void 0),Lf(om(o),"_queue",null),e&&!Bp(e)&&(i=e,e=[]),o._options=i||{},o._data=new tO,o.length=0,o._idProp=o._options.fieldId||"id",e&&e.length&&o.add(e),o.setOptions(i),o}return Cf(n,[{key:"idProp",get:function(){return this._idProp}},{key:"setOptions",value:function(t){t&&void 0!==t.queue&&(!1===t.queue?this._queue&&(this._queue.destroy(),this._queue=null):(this._queue||(this._queue=Ex.extend(this,{replace:["add","update","remove"]})),t.queue&&"object"===Af(t.queue)&&this._queue.setOptions(t.queue)))}},{key:"add",value:function(t,e){var r,n=this,i=[];if(Bp(t)){var o=jl(t).call(t,(function(t){return t[n._idProp]}));if(aO(o).call(o,(function(t){return n._data.has(t)})))throw new Error("A duplicate id was found in the parameter array.");for(var a=0,u=t.length;a<u;a++)r=this._addItem(t[a]),i.push(r)}else{if(!t||"object"!==Af(t))throw new Error("Unknown dataType");r=this._addItem(t),i.push(r)}return i.length&&this._trigger("add",{items:i},e),i}},{key:"update",value:function(t,e){var r=this,n=[],i=[],o=[],a=[],u=this._idProp,s=function(t){var e=t[u];if(null!=e&&r._data.has(e)){var s=t,c=id({},r._data.get(e)),f=r._updateItem(s);i.push(f),a.push(s),o.push(c)}else{var l=r._addItem(t);n.push(l)}};if(Bp(t))for(var c=0,f=t.length;c<f;c++)t[c]&&"object"===Af(t[c])?s(t[c]):console.warn("Ignoring input item, which is not an object at index "+c);else{if(!t||"object"!==Af(t))throw new Error("Unknown dataType");s(t)}if(n.length&&this._trigger("add",{items:n},e),i.length){var l={items:i,oldData:o,data:a};this._trigger("update",l,e)}return Gp(n).call(n,i)}},{key:"updateOnly",value:function(t,e){var r,n=this;Bp(t)||(t=[t]);var i=jl(r=jl(t).call(t,(function(t){var e=n._data.get(t[n._idProp]);if(null==e)throw new Error("Updating non-existent items is not allowed.");return{oldData:e,update:t}}))).call(r,(function(t){var e=t.oldData,r=t.update,i=e[n._idProp],o=function(t){for(var e,r=arguments.length,n=new Array(r>1?r-1:0),i=1;i<r;i++)n[i-1]=arguments[i];return Lg.apply(void 0,Gp(e=[{},t]).call(e,n))}(e,r);return n._data.set(i,o),{id:i,oldData:e,updatedData:o}}));if(i.length){var o={items:jl(i).call(i,(function(t){return t.id})),oldData:jl(i).call(i,(function(t){return t.oldData})),data:jl(i).call(i,(function(t){return t.updatedData}))};return this._trigger("update",o,e),o.items}return[]}},{key:"get",value:function(t,e){var r=void 0,n=void 0,i=void 0;wx(t)?(r=t,i=e):Bp(t)?(n=t,i=e):i=t;var o,a=i&&"Object"===i.returnType?"Object":"Array",u=i&&El(i),s=[],c=void 0,f=void 0,l=void 0;if(null!=r)(c=this._data.get(r))&&u&&!u(c)&&(c=void 0);else if(null!=n)for(var h=0,p=n.length;h<p;h++)null==(c=this._data.get(n[h]))||u&&!u(c)||s.push(c);else for(var v,d=0,y=(f=Fp(vO(v=this._data).call(v))).length;d<y;d++)l=f[d],null==(c=this._data.get(l))||u&&!u(c)||s.push(c);if(i&&i.order&&null==r&&this._sort(s,i.order),i&&i.fields){var g=i.fields;if(null!=r&&null!=c)c=this._filterFields(c,g);else for(var m=0,b=s.length;m<b;m++)s[m]=this._filterFields(s[m],g)}if("Object"==a){for(var _={},w=0,E=s.length;w<E;w++){var T=s[w];_[T[this._idProp]]=T}return _}return null!=r?null!==(o=c)&&void 0!==o?o:null:s}},{key:"getIds",value:function(t){var e=this._data,r=t&&El(t),n=t&&t.order,i=Fp(vO(e).call(e)),o=[];if(r)if(n){for(var a=[],u=0,s=i.length;u<s;u++){var c=i[u],f=this._data.get(c);null!=f&&r(f)&&a.push(f)}this._sort(a,n);for(var l=0,h=a.length;l<h;l++)o.push(a[l][this._idProp])}else for(var p=0,v=i.length;p<v;p++){var d=i[p],y=this._data.get(d);null!=y&&r(y)&&o.push(y[this._idProp])}else if(n){for(var g=[],m=0,b=i.length;m<b;m++){var _=i[m];g.push(e.get(_))}this._sort(g,n);for(var w=0,E=g.length;w<E;w++)o.push(g[w][this._idProp])}else for(var T=0,O=i.length;T<O;T++){var x=i[T],k=e.get(x);null!=k&&o.push(k[this._idProp])}return o}},{key:"getDataSet",value:function(){return this}},{key:"forEach",value:function(t,e){var r=e&&El(e),n=this._data,i=Fp(vO(n).call(n));if(e&&e.order)for(var o=this.get(e),a=0,u=o.length;a<u;a++){var s=o[a];t(s,s[this._idProp])}else for(var c=0,f=i.length;c<f;c++){var l=i[c],h=this._data.get(l);null==h||r&&!r(h)||t(h,l)}}},{key:"map",value:function(t,e){for(var r=e&&El(e),n=[],i=this._data,o=Fp(vO(i).call(i)),a=0,u=o.length;a<u;a++){var s=o[a],c=this._data.get(s);null==c||r&&!r(c)||n.push(t(c,s))}return e&&e.order&&this._sort(n,e.order),n}},{key:"_filterFields",value:function(t,e){var r;return t?yl(r=Bp(e)?e:Jp(e)).call(r,(function(e,r){return e[r]=t[r],e}),{}):t}},{key:"_sort",value:function(t,e){if("string"==typeof e){var r=e;KO(t).call(t,(function(t,e){var n=t[r],i=e[r];return n>i?1:n<i?-1:0}))}else{if("function"!=typeof e)throw new TypeError("Order must be a function or a string");KO(t).call(t,e)}}},{key:"remove",value:function(t,e){for(var r=[],n=[],i=Bp(t)?t:[t],o=0,a=i.length;o<a;o++){var u=this._remove(i[o]);if(u){var s=u[this._idProp];null!=s&&(r.push(s),n.push(u))}}return r.length&&this._trigger("remove",{items:r,oldData:n},e),r}},{key:"_remove",value:function(t){var e;if(wx(t)?e=t:t&&"object"===Af(t)&&(e=t[this._idProp]),null!=e&&this._data.has(e)){var r=this._data.get(e)||null;return this._data.delete(e),--this.length,r}return null}},{key:"clear",value:function(t){for(var e,r=Fp(vO(e=this._data).call(e)),n=[],i=0,o=r.length;i<o;i++)n.push(this._data.get(r[i]));return this._data.clear(),this.length=0,this._trigger("remove",{items:r,oldData:n},t),r}},{key:"max",value:function(t){var e,r,n=null,i=null,o=Dx(ox(e=this._data).call(e));try{for(o.s();!(r=o.n()).done;){var a=r.value,u=a[t];"number"==typeof u&&(null==i||u>i)&&(n=a,i=u)}}catch(t){o.e(t)}finally{o.f()}return n||null}},{key:"min",value:function(t){var e,r,n=null,i=null,o=Dx(ox(e=this._data).call(e));try{for(o.s();!(r=o.n()).done;){var a=r.value,u=a[t];"number"==typeof u&&(null==i||u<i)&&(n=a,i=u)}}catch(t){o.e(t)}finally{o.f()}return n||null}},{key:"distinct",value:function(t){for(var e=this._data,r=Fp(vO(e).call(e)),n=[],i=0,o=0,a=r.length;o<a;o++){for(var u=r[o],s=e.get(u)[t],c=!1,f=0;f<i;f++)if(n[f]==s){c=!0;break}c||void 0===s||(n[i]=s,i++)}return n}},{key:"_addItem",value:function(t){var e=function(t,e){return null==t[e]&&(t[e]=_x()),t}(t,this._idProp),r=e[this._idProp];if(this._data.has(r))throw new Error("Cannot add item: item with id "+r+" already exists");return this._data.set(r,e),++this.length,r}},{key:"_updateItem",value:function(t){var e=t[this._idProp];if(null==e)throw new Error("Cannot update item: item has no id (item: "+vd(t)+")");var r=this._data.get(e);if(!r)throw new Error("Cannot update item: no item with id "+e+" found");return this._data.set(e,Ix(Ix({},r),t)),e}},{key:"stream",value:function(t){if(t){var e=this._data;return new Ax(Lf({},ax,JE.mark((function r(){var n,i,o,a;return JE.wrap((function(r){for(;;)switch(r.prev=r.next){case 0:n=Dx(t),r.prev=1,n.s();case 3:if((i=n.n()).done){r.next=11;break}if(o=i.value,null==(a=e.get(o))){r.next=9;break}return r.next=9,[o,a];case 9:r.next=3;break;case 11:r.next=16;break;case 13:r.prev=13,r.t0=r.catch(1),n.e(r.t0);case 16:return r.prev=16,n.f(),r.finish(16);case 19:case"end":return r.stop()}}),r,null,[[1,13,16,19]])}))))}var r;return new Ax(Lf({},ax,tl(r=vx(this._data)).call(r,this._data)))}}]),n}();function Mx(t,e){var r=void 0!==zp&&Rh(t)||t["@@iterator"];if(!r){if(Bp(t)||(r=function(t,e){var r;if(!t)return;if("string"==typeof t)return Nx(t,e);var n=Xp(r=Object.prototype.toString.call(t)).call(r,8,-1);"Object"===n&&t.constructor&&(n=t.constructor.name);if("Map"===n||"Set"===n)return Lh(t);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return Nx(t,e)}(t))||e&&t&&"number"==typeof t.length){r&&(t=r);var n=0,i=function(){};return{s:i,n:function(){return n>=t.length?{done:!0}:{done:!1,value:t[n++]}},e:function(t){throw t},f:i}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var o,a=!0,u=!1;return{s:function(){r=r.call(t)},n:function(){var t=r.next();return a=t.done,t},e:function(t){u=!0,o=t},f:function(){try{a||null==r.return||r.return()}finally{if(u)throw o}}}}function Nx(t,e){(null==e||e>t.length)&&(e=t.length);for(var r=0,n=new Array(e);r<e;r++)n[r]=t[r];return n}function Fx(t){var e=function(){if("undefined"==typeof Reflect||!im)return!1;if(im.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(im(Boolean,[],(function(){}))),!0}catch(t){return!1}}();return function(){var r,n=ym(t);if(e){var i=ym(this).constructor;r=im(n,arguments,i)}else r=n.apply(this,arguments);return pm(this,r)}}var zx=function(e){hm(n,Tx);var r=Fx(n);function n(e,i){var o,a;return t(this,n),Lf(om(a=r.call(this)),"length",0),Lf(om(a),"_listener",void 0),Lf(om(a),"_data",void 0),Lf(om(a),"_ids",new xx),Lf(om(a),"_options",void 0),a._options=i||{},a._listener=tl(o=a._onEvent).call(o,om(a)),a.setData(e),a}return Cf(n,[{key:"idProp",get:function(){return this.getDataSet().idProp}},{key:"setData",value:function(t){if(this._data){this._data.off&&this._data.off("*",this._listener);var e=this._data.getIds({filter:El(this._options)}),r=this._data.get(e);this._ids.clear(),this.length=0,this._trigger("remove",{items:e,oldData:r})}if(null!=t){this._data=t;for(var n=this._data.getIds({filter:El(this._options)}),i=0,o=n.length;i<o;i++){var a=n[i];this._ids.add(a)}this.length=n.length,this._trigger("add",{items:n})}else this._data=new Rx;this._data.on&&this._data.on("*",this._listener)}},{key:"refresh",value:function(){for(var t=this._data.getIds({filter:El(this._options)}),e=Fp(this._ids),r={},n=[],i=[],o=[],a=0,u=t.length;a<u;a++){var s=t[a];r[s]=!0,this._ids.has(s)||(n.push(s),this._ids.add(s))}for(var c=0,f=e.length;c<f;c++){var l=e[c],h=this._data.get(l);null==h?console.error("If you see this, report it please."):r[l]||(i.push(l),o.push(h),this._ids.delete(l))}this.length+=n.length-i.length,n.length&&this._trigger("add",{items:n}),i.length&&this._trigger("remove",{items:i,oldData:o})}},{key:"get",value:function(t,e){if(null==this._data)return null;var r,n=null;wx(t)||Bp(t)?(n=t,r=e):r=t;var i=id({},this._options,r),o=El(this._options),a=r&&El(r);return o&&a&&(i.filter=function(t){return o(t)&&a(t)}),null==n?this._data.get(i):this._data.get(n,i)}},{key:"getIds",value:function(t){if(this._data.length){var e,r=El(this._options),n=null!=t?El(t):null;return e=n?r?function(t){return r(t)&&n(t)}:n:r,this._data.getIds({filter:e,order:t&&t.order})}return[]}},{key:"forEach",value:function(t,e){if(this._data){var r,n,i=El(this._options),o=e&&El(e);n=o?i?function(t){return i(t)&&o(t)}:o:i,uv(r=this._data).call(r,t,{filter:n,order:e&&e.order})}}},{key:"map",value:function(t,e){if(this._data){var r,n,i=El(this._options),o=e&&El(e);return n=o?i?function(t){return i(t)&&o(t)}:o:i,jl(r=this._data).call(r,t,{filter:n,order:e&&e.order})}return[]}},{key:"getDataSet",value:function(){return this._data.getDataSet()}},{key:"stream",value:function(t){var e;return this._data.stream(t||Lf({},ax,tl(e=vO(this._ids)).call(e,this._ids)))}},{key:"dispose",value:function(){var t;null!==(t=this._data)&&void 0!==t&&t.off&&this._data.off("*",this._listener);var e,r="This data view has already been disposed of.",i={get:function(){throw new Error(r)},set:function(){throw new Error(r)},configurable:!1},o=Mx(Vp(n.prototype));try{for(o.s();!(e=o.n()).done;){var a=e.value;fp(this,a,i)}}catch(t){o.e(t)}finally{o.f()}}},{key:"_onEvent",value:function(t,e,r){if(e&&e.items&&this._data){var n=e.items,i=[],o=[],a=[],u=[],s=[],c=[];switch(t){case"add":for(var f=0,l=n.length;f<l;f++){var h=n[f];this.get(h)&&(this._ids.add(h),i.push(h))}break;case"update":for(var p=0,v=n.length;p<v;p++){var d=n[p];this.get(d)?this._ids.has(d)?(o.push(d),s.push(e.data[p]),u.push(e.oldData[p])):(this._ids.add(d),i.push(d)):this._ids.has(d)&&(this._ids.delete(d),a.push(d),c.push(e.oldData[p]))}break;case"remove":for(var y=0,g=n.length;y<g;y++){var m=n[y];this._ids.has(m)&&(this._ids.delete(m),a.push(m),c.push(e.oldData[y]))}}this.length+=i.length-a.length,i.length&&this._trigger("add",{items:i},r),o.length&&this._trigger("update",{items:o,oldData:u,data:s},r),a.length&&this._trigger("remove",{items:a,oldData:c},r)}}}]),n}();function Ux(t,e){return"object"===Af(e)&&null!==e&&t===e.idProp&&"function"==typeof e.add&&"function"==typeof e.clear&&"function"==typeof e.distinct&&"function"==typeof uv(e)&&"function"==typeof e.get&&"function"==typeof e.getDataSet&&"function"==typeof e.getIds&&"number"==typeof e.length&&"function"==typeof jl(e)&&"function"==typeof e.max&&"function"==typeof e.min&&"function"==typeof e.off&&"function"==typeof e.on&&"function"==typeof e.remove&&"function"==typeof e.setOptions&&"function"==typeof e.stream&&"function"==typeof e.update&&"function"==typeof e.updateOnly}function qx(t,e){return"object"===Af(e)&&null!==e&&t===e.idProp&&"function"==typeof uv(e)&&"function"==typeof e.get&&"function"==typeof e.getDataSet&&"function"==typeof e.getIds&&"number"==typeof e.length&&"function"==typeof jl(e)&&"function"==typeof e.off&&"function"==typeof e.on&&"function"==typeof e.stream&&Ux(t,e.getDataSet())}export{Cg as DELETE,Rx as DataSet,Ax as DataStream,zx as DataView,Ex as Queue,Gl as createNewDataPipeFrom,Ux as isDataSetLike,qx as isDataViewLike};
//# sourceMappingURL=vis-data.min.js.map
