/**
 * vis-data
 * http://visjs.org/
 *
 * Manage unstructured data using DataSet. Add, update, and remove data, and listen for changes in the data.
 *
 * @version 7.1.7
 * @date    2023-09-13T18:13:28.258Z
 *
 * @copyright (c) 2011-2017 Almende B.V, http://almende.com
 * @copyright (c) 2017-2019 visjs contributors, https://github.com/visjs
 *
 * @license
 * vis.js is dual licensed under both
 *
 *   1. The Apache 2.0 License
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *   and
 *
 *   2. The MIT License
 *      http://opensource.org/licenses/MIT
 *
 * vis.js may be distributed under either license.
 */
!function(t,e){"object"==typeof exports&&"undefined"!=typeof module?e(exports):"function"==typeof define&&define.amd?define(["exports"],e):e((t="undefined"!=typeof globalThis?globalThis:t||self).vis=t.vis||{})}(this,(function(t){function e(t,e){if(!(t instanceof e))throw new TypeError("Cannot call a class as a function")}var r="undefined"!=typeof globalThis?globalThis:"undefined"!=typeof window?window:"undefined"!=typeof global?global:"undefined"!=typeof self?self:{};function n(t){return t&&t.__esModule&&Object.prototype.hasOwnProperty.call(t,"default")?t.default:t}var i={exports:{}},o=function(t){return t&&t.Math==Math&&t},a=o("object"==typeof globalThis&&globalThis)||o("object"==typeof window&&window)||o("object"==typeof self&&self)||o("object"==typeof r&&r)||function(){return this}()||Function("return this")(),u=function(t){try{return!!t()}catch(t){return!0}},s=!u((function(){var t=function(){}.bind();return"function"!=typeof t||t.hasOwnProperty("prototype")})),c=s,f=Function.prototype,l=f.apply,h=f.call,p="object"==typeof Reflect&&Reflect.apply||(c?h.bind(l):function(){return h.apply(l,arguments)}),v=s,d=Function.prototype,y=d.call,g=v&&d.bind.bind(y,y),m=v?g:function(t){return function(){return y.apply(t,arguments)}},b=m,_=b({}.toString),w=b("".slice),E=function(t){return w(_(t),8,-1)},T=E,O=m,x=function(t){if("Function"===T(t))return O(t)},k="object"==typeof document&&document.all,S={all:k,IS_HTMLDDA:void 0===k&&void 0!==k},j=S.all,A=S.IS_HTMLDDA?function(t){return"function"==typeof t||t===j}:function(t){return"function"==typeof t},P={},I=!u((function(){return 7!=Object.defineProperty({},1,{get:function(){return 7}})[1]})),D=s,L=Function.prototype.call,C=D?L.bind(L):function(){return L.apply(L,arguments)},R={},M={}.propertyIsEnumerable,N=Object.getOwnPropertyDescriptor,F=N&&!M.call({1:2},1);R.f=F?function(t){var e=N(this,t);return!!e&&e.enumerable}:M;var z,U,q=function(t,e){return{enumerable:!(1&t),configurable:!(2&t),writable:!(4&t),value:e}},Y=u,W=E,G=Object,X=m("".split),V=Y((function(){return!G("z").propertyIsEnumerable(0)}))?function(t){return"String"==W(t)?X(t,""):G(t)}:G,B=function(t){return null==t},H=B,$=TypeError,J=function(t){if(H(t))throw $("Can't call method on "+t);return t},K=V,Q=J,Z=function(t){return K(Q(t))},tt=A,et=S.all,rt=S.IS_HTMLDDA?function(t){return"object"==typeof t?null!==t:tt(t)||t===et}:function(t){return"object"==typeof t?null!==t:tt(t)},nt={},it=nt,ot=a,at=A,ut=function(t){return at(t)?t:void 0},st=function(t,e){return arguments.length<2?ut(it[t])||ut(ot[t]):it[t]&&it[t][e]||ot[t]&&ot[t][e]},ct=m({}.isPrototypeOf),ft="undefined"!=typeof navigator&&String(navigator.userAgent)||"",lt=a,ht=ft,pt=lt.process,vt=lt.Deno,dt=pt&&pt.versions||vt&&vt.version,yt=dt&&dt.v8;yt&&(U=(z=yt.split("."))[0]>0&&z[0]<4?1:+(z[0]+z[1])),!U&&ht&&(!(z=ht.match(/Edge\/(\d+)/))||z[1]>=74)&&(z=ht.match(/Chrome\/(\d+)/))&&(U=+z[1]);var gt=U,mt=gt,bt=u,_t=!!Object.getOwnPropertySymbols&&!bt((function(){var t=Symbol();return!String(t)||!(Object(t)instanceof Symbol)||!Symbol.sham&&mt&&mt<41})),wt=_t&&!Symbol.sham&&"symbol"==typeof Symbol.iterator,Et=st,Tt=A,Ot=ct,xt=Object,kt=wt?function(t){return"symbol"==typeof t}:function(t){var e=Et("Symbol");return Tt(e)&&Ot(e.prototype,xt(t))},St=String,jt=function(t){try{return St(t)}catch(t){return"Object"}},At=A,Pt=jt,It=TypeError,Dt=function(t){if(At(t))return t;throw It(Pt(t)+" is not a function")},Lt=Dt,Ct=B,Rt=function(t,e){var r=t[e];return Ct(r)?void 0:Lt(r)},Mt=C,Nt=A,Ft=rt,zt=TypeError,Ut={exports:{}},qt=a,Yt=Object.defineProperty,Wt=function(t,e){try{Yt(qt,t,{value:e,configurable:!0,writable:!0})}catch(r){qt[t]=e}return e},Gt="__core-js_shared__",Xt=a[Gt]||Wt(Gt,{}),Vt=Xt;(Ut.exports=function(t,e){return Vt[t]||(Vt[t]=void 0!==e?e:{})})("versions",[]).push({version:"3.29.0",mode:"pure",copyright:"© 2014-2023 Denis Pushkarev (zloirock.ru)",license:"https://github.com/zloirock/core-js/blob/v3.29.0/LICENSE",source:"https://github.com/zloirock/core-js"});var Bt=Ut.exports,Ht=J,$t=Object,Jt=function(t){return $t(Ht(t))},Kt=Jt,Qt=m({}.hasOwnProperty),Zt=Object.hasOwn||function(t,e){return Qt(Kt(t),e)},te=m,ee=0,re=Math.random(),ne=te(1..toString),ie=function(t){return"Symbol("+(void 0===t?"":t)+")_"+ne(++ee+re,36)},oe=Bt,ae=Zt,ue=ie,se=_t,ce=wt,fe=a.Symbol,le=oe("wks"),he=ce?fe.for||fe:fe&&fe.withoutSetter||ue,pe=function(t){return ae(le,t)||(le[t]=se&&ae(fe,t)?fe[t]:he("Symbol."+t)),le[t]},ve=C,de=rt,ye=kt,ge=Rt,me=function(t,e){var r,n;if("string"===e&&Nt(r=t.toString)&&!Ft(n=Mt(r,t)))return n;if(Nt(r=t.valueOf)&&!Ft(n=Mt(r,t)))return n;if("string"!==e&&Nt(r=t.toString)&&!Ft(n=Mt(r,t)))return n;throw zt("Can't convert object to primitive value")},be=TypeError,_e=pe("toPrimitive"),we=function(t,e){if(!de(t)||ye(t))return t;var r,n=ge(t,_e);if(n){if(void 0===e&&(e="default"),r=ve(n,t,e),!de(r)||ye(r))return r;throw be("Can't convert object to primitive value")}return void 0===e&&(e="number"),me(t,e)},Ee=kt,Te=function(t){var e=we(t,"string");return Ee(e)?e:e+""},Oe=rt,xe=a.document,ke=Oe(xe)&&Oe(xe.createElement),Se=function(t){return ke?xe.createElement(t):{}},je=Se,Ae=!I&&!u((function(){return 7!=Object.defineProperty(je("div"),"a",{get:function(){return 7}}).a})),Pe=I,Ie=C,De=R,Le=q,Ce=Z,Re=Te,Me=Zt,Ne=Ae,Fe=Object.getOwnPropertyDescriptor;P.f=Pe?Fe:function(t,e){if(t=Ce(t),e=Re(e),Ne)try{return Fe(t,e)}catch(t){}if(Me(t,e))return Le(!Ie(De.f,t,e),t[e])};var ze=u,Ue=A,qe=/#|\.prototype\./,Ye=function(t,e){var r=Ge[We(t)];return r==Ve||r!=Xe&&(Ue(e)?ze(e):!!e)},We=Ye.normalize=function(t){return String(t).replace(qe,".").toLowerCase()},Ge=Ye.data={},Xe=Ye.NATIVE="N",Ve=Ye.POLYFILL="P",Be=Ye,He=Dt,$e=s,Je=x(x.bind),Ke=function(t,e){return He(t),void 0===e?t:$e?Je(t,e):function(){return t.apply(e,arguments)}},Qe={},Ze=I&&u((function(){return 42!=Object.defineProperty((function(){}),"prototype",{value:42,writable:!1}).prototype})),tr=rt,er=String,rr=TypeError,nr=function(t){if(tr(t))return t;throw rr(er(t)+" is not an object")},ir=I,or=Ae,ar=Ze,ur=nr,sr=Te,cr=TypeError,fr=Object.defineProperty,lr=Object.getOwnPropertyDescriptor,hr="enumerable",pr="configurable",vr="writable";Qe.f=ir?ar?function(t,e,r){if(ur(t),e=sr(e),ur(r),"function"==typeof t&&"prototype"===e&&"value"in r&&vr in r&&!r[vr]){var n=lr(t,e);n&&n[vr]&&(t[e]=r.value,r={configurable:pr in r?r[pr]:n[pr],enumerable:hr in r?r[hr]:n[hr],writable:!1})}return fr(t,e,r)}:fr:function(t,e,r){if(ur(t),e=sr(e),ur(r),or)try{return fr(t,e,r)}catch(t){}if("get"in r||"set"in r)throw cr("Accessors not supported");return"value"in r&&(t[e]=r.value),t};var dr=Qe,yr=q,gr=I?function(t,e,r){return dr.f(t,e,yr(1,r))}:function(t,e,r){return t[e]=r,t},mr=a,br=p,_r=x,wr=A,Er=P.f,Tr=Be,Or=nt,xr=Ke,kr=gr,Sr=Zt,jr=function(t){var e=function(r,n,i){if(this instanceof e){switch(arguments.length){case 0:return new t;case 1:return new t(r);case 2:return new t(r,n)}return new t(r,n,i)}return br(t,this,arguments)};return e.prototype=t.prototype,e},Ar=function(t,e){var r,n,i,o,a,u,s,c,f,l=t.target,h=t.global,p=t.stat,v=t.proto,d=h?mr:p?mr[l]:(mr[l]||{}).prototype,y=h?Or:Or[l]||kr(Or,l,{})[l],g=y.prototype;for(o in e)n=!(r=Tr(h?o:l+(p?".":"#")+o,t.forced))&&d&&Sr(d,o),u=y[o],n&&(s=t.dontCallGetSet?(f=Er(d,o))&&f.value:d[o]),a=n&&s?s:e[o],n&&typeof u==typeof a||(c=t.bind&&n?xr(a,mr):t.wrap&&n?jr(a):v&&wr(a)?_r(a):a,(t.sham||a&&a.sham||u&&u.sham)&&kr(c,"sham",!0),kr(y,o,c),v&&(Sr(Or,i=l+"Prototype")||kr(Or,i,{}),kr(Or[i],o,a),t.real&&g&&(r||!g[o])&&kr(g,o,a)))},Pr=Ar,Ir=I,Dr=Qe.f;Pr({target:"Object",stat:!0,forced:Object.defineProperty!==Dr,sham:!Ir},{defineProperty:Dr});var Lr=nt.Object,Cr=i.exports=function(t,e,r){return Lr.defineProperty(t,e,r)};Lr.defineProperty.sham&&(Cr.sham=!0);var Rr=i.exports,Mr=Rr,Nr=n(Mr),Fr=E,zr=Array.isArray||function(t){return"Array"==Fr(t)},Ur=Math.ceil,qr=Math.floor,Yr=Math.trunc||function(t){var e=+t;return(e>0?qr:Ur)(e)},Wr=function(t){var e=+t;return e!=e||0===e?0:Yr(e)},Gr=Wr,Xr=Math.min,Vr=function(t){return t>0?Xr(Gr(t),9007199254740991):0},Br=function(t){return Vr(t.length)},Hr=TypeError,$r=function(t){if(t>9007199254740991)throw Hr("Maximum allowed index exceeded");return t},Jr=Te,Kr=Qe,Qr=q,Zr=function(t,e,r){var n=Jr(e);n in t?Kr.f(t,n,Qr(0,r)):t[n]=r},tn={};tn[pe("toStringTag")]="z";var en="[object z]"===String(tn),rn=en,nn=A,on=E,an=pe("toStringTag"),un=Object,sn="Arguments"==on(function(){return arguments}()),cn=rn?on:function(t){var e,r,n;return void 0===t?"Undefined":null===t?"Null":"string"==typeof(r=function(t,e){try{return t[e]}catch(t){}}(e=un(t),an))?r:sn?on(e):"Object"==(n=on(e))&&nn(e.callee)?"Arguments":n},fn=A,ln=Xt,hn=m(Function.toString);fn(ln.inspectSource)||(ln.inspectSource=function(t){return hn(t)});var pn=ln.inspectSource,vn=m,dn=u,yn=A,gn=cn,mn=pn,bn=function(){},_n=[],wn=st("Reflect","construct"),En=/^\s*(?:class|function)\b/,Tn=vn(En.exec),On=!En.exec(bn),xn=function(t){if(!yn(t))return!1;try{return wn(bn,_n,t),!0}catch(t){return!1}},kn=function(t){if(!yn(t))return!1;switch(gn(t)){case"AsyncFunction":case"GeneratorFunction":case"AsyncGeneratorFunction":return!1}try{return On||!!Tn(En,mn(t))}catch(t){return!0}};kn.sham=!0;var Sn=!wn||dn((function(){var t;return xn(xn.call)||!xn(Object)||!xn((function(){t=!0}))||t}))?kn:xn,jn=zr,An=Sn,Pn=rt,In=pe("species"),Dn=Array,Ln=function(t){var e;return jn(t)&&(e=t.constructor,(An(e)&&(e===Dn||jn(e.prototype))||Pn(e)&&null===(e=e[In]))&&(e=void 0)),void 0===e?Dn:e},Cn=function(t,e){return new(Ln(t))(0===e?0:e)},Rn=u,Mn=gt,Nn=pe("species"),Fn=function(t){return Mn>=51||!Rn((function(){var e=[];return(e.constructor={})[Nn]=function(){return{foo:1}},1!==e[t](Boolean).foo}))},zn=Ar,Un=u,qn=zr,Yn=rt,Wn=Jt,Gn=Br,Xn=$r,Vn=Zr,Bn=Cn,Hn=Fn,$n=gt,Jn=pe("isConcatSpreadable"),Kn=$n>=51||!Un((function(){var t=[];return t[Jn]=!1,t.concat()[0]!==t})),Qn=function(t){if(!Yn(t))return!1;var e=t[Jn];return void 0!==e?!!e:qn(t)};zn({target:"Array",proto:!0,arity:1,forced:!Kn||!Hn("concat")},{concat:function(t){var e,r,n,i,o,a=Wn(this),u=Bn(a,0),s=0;for(e=-1,n=arguments.length;e<n;e++)if(Qn(o=-1===e?a:arguments[e]))for(i=Gn(o),Xn(s+i),r=0;r<i;r++,s++)r in o&&Vn(u,s,o[r]);else Xn(s+1),Vn(u,s++,o);return u.length=s,u}});var Zn=cn,ti=String,ei=function(t){if("Symbol"===Zn(t))throw TypeError("Cannot convert a Symbol value to a string");return ti(t)},ri={},ni=Wr,ii=Math.max,oi=Math.min,ai=function(t,e){var r=ni(t);return r<0?ii(r+e,0):oi(r,e)},ui=Z,si=ai,ci=Br,fi=function(t){return function(e,r,n){var i,o=ui(e),a=ci(o),u=si(n,a);if(t&&r!=r){for(;a>u;)if((i=o[u++])!=i)return!0}else for(;a>u;u++)if((t||u in o)&&o[u]===r)return t||u||0;return!t&&-1}},li={includes:fi(!0),indexOf:fi(!1)},hi={},pi=Zt,vi=Z,di=li.indexOf,yi=hi,gi=m([].push),mi=function(t,e){var r,n=vi(t),i=0,o=[];for(r in n)!pi(yi,r)&&pi(n,r)&&gi(o,r);for(;e.length>i;)pi(n,r=e[i++])&&(~di(o,r)||gi(o,r));return o},bi=["constructor","hasOwnProperty","isPrototypeOf","propertyIsEnumerable","toLocaleString","toString","valueOf"],_i=mi,wi=bi,Ei=Object.keys||function(t){return _i(t,wi)},Ti=I,Oi=Ze,xi=Qe,ki=nr,Si=Z,ji=Ei;ri.f=Ti&&!Oi?Object.defineProperties:function(t,e){ki(t);for(var r,n=Si(e),i=ji(e),o=i.length,a=0;o>a;)xi.f(t,r=i[a++],n[r]);return t};var Ai,Pi=st("document","documentElement"),Ii=ie,Di=Bt("keys"),Li=function(t){return Di[t]||(Di[t]=Ii(t))},Ci=nr,Ri=ri,Mi=bi,Ni=hi,Fi=Pi,zi=Se,Ui="prototype",qi="script",Yi=Li("IE_PROTO"),Wi=function(){},Gi=function(t){return"<"+qi+">"+t+"</"+qi+">"},Xi=function(t){t.write(Gi("")),t.close();var e=t.parentWindow.Object;return t=null,e},Vi=function(){try{Ai=new ActiveXObject("htmlfile")}catch(t){}var t,e,r;Vi="undefined"!=typeof document?document.domain&&Ai?Xi(Ai):(e=zi("iframe"),r="java"+qi+":",e.style.display="none",Fi.appendChild(e),e.src=String(r),(t=e.contentWindow.document).open(),t.write(Gi("document.F=Object")),t.close(),t.F):Xi(Ai);for(var n=Mi.length;n--;)delete Vi[Ui][Mi[n]];return Vi()};Ni[Yi]=!0;var Bi=Object.create||function(t,e){var r;return null!==t?(Wi[Ui]=Ci(t),r=new Wi,Wi[Ui]=null,r[Yi]=t):r=Vi(),void 0===e?r:Ri.f(r,e)},Hi={},$i=mi,Ji=bi.concat("length","prototype");Hi.f=Object.getOwnPropertyNames||function(t){return $i(t,Ji)};var Ki={},Qi=ai,Zi=Br,to=Zr,eo=Array,ro=Math.max,no=function(t,e,r){for(var n=Zi(t),i=Qi(e,n),o=Qi(void 0===r?n:r,n),a=eo(ro(o-i,0)),u=0;i<o;i++,u++)to(a,u,t[i]);return a.length=u,a},io=E,oo=Z,ao=Hi.f,uo=no,so="object"==typeof window&&window&&Object.getOwnPropertyNames?Object.getOwnPropertyNames(window):[];Ki.f=function(t){return so&&"Window"==io(t)?function(t){try{return ao(t)}catch(t){return uo(so)}}(t):ao(oo(t))};var co={};co.f=Object.getOwnPropertySymbols;var fo=gr,lo=function(t,e,r,n){return n&&n.enumerable?t[e]=r:fo(t,e,r),t},ho=Qe,po=function(t,e,r){return ho.f(t,e,r)},vo={},yo=pe;vo.f=yo;var go,mo,bo,_o=nt,wo=Zt,Eo=vo,To=Qe.f,Oo=function(t){var e=_o.Symbol||(_o.Symbol={});wo(e,t)||To(e,t,{value:Eo.f(t)})},xo=C,ko=st,So=pe,jo=lo,Ao=function(){var t=ko("Symbol"),e=t&&t.prototype,r=e&&e.valueOf,n=So("toPrimitive");e&&!e[n]&&jo(e,n,(function(t){return xo(r,this)}),{arity:1})},Po=cn,Io=en?{}.toString:function(){return"[object "+Po(this)+"]"},Do=en,Lo=Qe.f,Co=gr,Ro=Zt,Mo=Io,No=pe("toStringTag"),Fo=function(t,e,r,n){if(t){var i=r?t:t.prototype;Ro(i,No)||Lo(i,No,{configurable:!0,value:e}),n&&!Do&&Co(i,"toString",Mo)}},zo=A,Uo=a.WeakMap,qo=zo(Uo)&&/native code/.test(String(Uo)),Yo=a,Wo=rt,Go=gr,Xo=Zt,Vo=Xt,Bo=Li,Ho=hi,$o="Object already initialized",Jo=Yo.TypeError,Ko=Yo.WeakMap;if(qo||Vo.state){var Qo=Vo.state||(Vo.state=new Ko);Qo.get=Qo.get,Qo.has=Qo.has,Qo.set=Qo.set,go=function(t,e){if(Qo.has(t))throw Jo($o);return e.facade=t,Qo.set(t,e),e},mo=function(t){return Qo.get(t)||{}},bo=function(t){return Qo.has(t)}}else{var Zo=Bo("state");Ho[Zo]=!0,go=function(t,e){if(Xo(t,Zo))throw Jo($o);return e.facade=t,Go(t,Zo,e),e},mo=function(t){return Xo(t,Zo)?t[Zo]:{}},bo=function(t){return Xo(t,Zo)}}var ta={set:go,get:mo,has:bo,enforce:function(t){return bo(t)?mo(t):go(t,{})},getterFor:function(t){return function(e){var r;if(!Wo(e)||(r=mo(e)).type!==t)throw Jo("Incompatible receiver, "+t+" required");return r}}},ea=Ke,ra=V,na=Jt,ia=Br,oa=Cn,aa=m([].push),ua=function(t){var e=1==t,r=2==t,n=3==t,i=4==t,o=6==t,a=7==t,u=5==t||o;return function(s,c,f,l){for(var h,p,v=na(s),d=ra(v),y=ea(c,f),g=ia(d),m=0,b=l||oa,_=e?b(s,g):r||a?b(s,0):void 0;g>m;m++)if((u||m in d)&&(p=y(h=d[m],m,v),t))if(e)_[m]=p;else if(p)switch(t){case 3:return!0;case 5:return h;case 6:return m;case 2:aa(_,h)}else switch(t){case 4:return!1;case 7:aa(_,h)}return o?-1:n||i?i:_}},sa={forEach:ua(0),map:ua(1),filter:ua(2),some:ua(3),every:ua(4),find:ua(5),findIndex:ua(6),filterReject:ua(7)},ca=Ar,fa=a,la=C,ha=m,pa=I,va=_t,da=u,ya=Zt,ga=ct,ma=nr,ba=Z,_a=Te,wa=ei,Ea=q,Ta=Bi,Oa=Ei,xa=Hi,ka=Ki,Sa=co,ja=P,Aa=Qe,Pa=ri,Ia=R,Da=lo,La=po,Ca=Bt,Ra=hi,Ma=ie,Na=pe,Fa=vo,za=Oo,Ua=Ao,qa=Fo,Ya=ta,Wa=sa.forEach,Ga=Li("hidden"),Xa="Symbol",Va="prototype",Ba=Ya.set,Ha=Ya.getterFor(Xa),$a=Object[Va],Ja=fa.Symbol,Ka=Ja&&Ja[Va],Qa=fa.TypeError,Za=fa.QObject,tu=ja.f,eu=Aa.f,ru=ka.f,nu=Ia.f,iu=ha([].push),ou=Ca("symbols"),au=Ca("op-symbols"),uu=Ca("wks"),su=!Za||!Za[Va]||!Za[Va].findChild,cu=pa&&da((function(){return 7!=Ta(eu({},"a",{get:function(){return eu(this,"a",{value:7}).a}})).a}))?function(t,e,r){var n=tu($a,e);n&&delete $a[e],eu(t,e,r),n&&t!==$a&&eu($a,e,n)}:eu,fu=function(t,e){var r=ou[t]=Ta(Ka);return Ba(r,{type:Xa,tag:t,description:e}),pa||(r.description=e),r},lu=function(t,e,r){t===$a&&lu(au,e,r),ma(t);var n=_a(e);return ma(r),ya(ou,n)?(r.enumerable?(ya(t,Ga)&&t[Ga][n]&&(t[Ga][n]=!1),r=Ta(r,{enumerable:Ea(0,!1)})):(ya(t,Ga)||eu(t,Ga,Ea(1,{})),t[Ga][n]=!0),cu(t,n,r)):eu(t,n,r)},hu=function(t,e){ma(t);var r=ba(e),n=Oa(r).concat(yu(r));return Wa(n,(function(e){pa&&!la(pu,r,e)||lu(t,e,r[e])})),t},pu=function(t){var e=_a(t),r=la(nu,this,e);return!(this===$a&&ya(ou,e)&&!ya(au,e))&&(!(r||!ya(this,e)||!ya(ou,e)||ya(this,Ga)&&this[Ga][e])||r)},vu=function(t,e){var r=ba(t),n=_a(e);if(r!==$a||!ya(ou,n)||ya(au,n)){var i=tu(r,n);return!i||!ya(ou,n)||ya(r,Ga)&&r[Ga][n]||(i.enumerable=!0),i}},du=function(t){var e=ru(ba(t)),r=[];return Wa(e,(function(t){ya(ou,t)||ya(Ra,t)||iu(r,t)})),r},yu=function(t){var e=t===$a,r=ru(e?au:ba(t)),n=[];return Wa(r,(function(t){!ya(ou,t)||e&&!ya($a,t)||iu(n,ou[t])})),n};va||(Ja=function(){if(ga(Ka,this))throw Qa("Symbol is not a constructor");var t=arguments.length&&void 0!==arguments[0]?wa(arguments[0]):void 0,e=Ma(t),r=function(t){this===$a&&la(r,au,t),ya(this,Ga)&&ya(this[Ga],e)&&(this[Ga][e]=!1),cu(this,e,Ea(1,t))};return pa&&su&&cu($a,e,{configurable:!0,set:r}),fu(e,t)},Da(Ka=Ja[Va],"toString",(function(){return Ha(this).tag})),Da(Ja,"withoutSetter",(function(t){return fu(Ma(t),t)})),Ia.f=pu,Aa.f=lu,Pa.f=hu,ja.f=vu,xa.f=ka.f=du,Sa.f=yu,Fa.f=function(t){return fu(Na(t),t)},pa&&La(Ka,"description",{configurable:!0,get:function(){return Ha(this).description}})),ca({global:!0,constructor:!0,wrap:!0,forced:!va,sham:!va},{Symbol:Ja}),Wa(Oa(uu),(function(t){za(t)})),ca({target:Xa,stat:!0,forced:!va},{useSetter:function(){su=!0},useSimple:function(){su=!1}}),ca({target:"Object",stat:!0,forced:!va,sham:!pa},{create:function(t,e){return void 0===e?Ta(t):hu(Ta(t),e)},defineProperty:lu,defineProperties:hu,getOwnPropertyDescriptor:vu}),ca({target:"Object",stat:!0,forced:!va},{getOwnPropertyNames:du}),Ua(),qa(Ja,Xa),Ra[Ga]=!0;var gu=_t&&!!Symbol.for&&!!Symbol.keyFor,mu=Ar,bu=st,_u=Zt,wu=ei,Eu=Bt,Tu=gu,Ou=Eu("string-to-symbol-registry"),xu=Eu("symbol-to-string-registry");mu({target:"Symbol",stat:!0,forced:!Tu},{for:function(t){var e=wu(t);if(_u(Ou,e))return Ou[e];var r=bu("Symbol")(e);return Ou[e]=r,xu[r]=e,r}});var ku=Ar,Su=Zt,ju=kt,Au=jt,Pu=gu,Iu=Bt("symbol-to-string-registry");ku({target:"Symbol",stat:!0,forced:!Pu},{keyFor:function(t){if(!ju(t))throw TypeError(Au(t)+" is not a symbol");if(Su(Iu,t))return Iu[t]}});var Du=m([].slice),Lu=zr,Cu=A,Ru=E,Mu=ei,Nu=m([].push),Fu=Ar,zu=st,Uu=p,qu=C,Yu=m,Wu=u,Gu=A,Xu=kt,Vu=Du,Bu=function(t){if(Cu(t))return t;if(Lu(t)){for(var e=t.length,r=[],n=0;n<e;n++){var i=t[n];"string"==typeof i?Nu(r,i):"number"!=typeof i&&"Number"!=Ru(i)&&"String"!=Ru(i)||Nu(r,Mu(i))}var o=r.length,a=!0;return function(t,e){if(a)return a=!1,e;if(Lu(this))return e;for(var n=0;n<o;n++)if(r[n]===t)return e}}},Hu=_t,$u=String,Ju=zu("JSON","stringify"),Ku=Yu(/./.exec),Qu=Yu("".charAt),Zu=Yu("".charCodeAt),ts=Yu("".replace),es=Yu(1..toString),rs=/[\uD800-\uDFFF]/g,ns=/^[\uD800-\uDBFF]$/,is=/^[\uDC00-\uDFFF]$/,os=!Hu||Wu((function(){var t=zu("Symbol")();return"[null]"!=Ju([t])||"{}"!=Ju({a:t})||"{}"!=Ju(Object(t))})),as=Wu((function(){return'"\\udf06\\ud834"'!==Ju("\udf06\ud834")||'"\\udead"'!==Ju("\udead")})),us=function(t,e){var r=Vu(arguments),n=Bu(e);if(Gu(n)||void 0!==t&&!Xu(t))return r[1]=function(t,e){if(Gu(n)&&(e=qu(n,this,$u(t),e)),!Xu(e))return e},Uu(Ju,null,r)},ss=function(t,e,r){var n=Qu(r,e-1),i=Qu(r,e+1);return Ku(ns,t)&&!Ku(is,i)||Ku(is,t)&&!Ku(ns,n)?"\\u"+es(Zu(t,0),16):t};Ju&&Fu({target:"JSON",stat:!0,arity:3,forced:os||as},{stringify:function(t,e,r){var n=Vu(arguments),i=Uu(os?us:Ju,null,n);return as&&"string"==typeof i?ts(i,rs,ss):i}});var cs=co,fs=Jt;Ar({target:"Object",stat:!0,forced:!_t||u((function(){cs.f(1)}))},{getOwnPropertySymbols:function(t){var e=cs.f;return e?e(fs(t)):[]}}),Oo("asyncIterator"),Oo("hasInstance"),Oo("isConcatSpreadable"),Oo("iterator"),Oo("match"),Oo("matchAll"),Oo("replace"),Oo("search"),Oo("species"),Oo("split");var ls=Ao;Oo("toPrimitive"),ls();var hs=st,ps=Fo;Oo("toStringTag"),ps(hs("Symbol"),"Symbol"),Oo("unscopables"),Fo(a.JSON,"JSON",!0);var vs,ds,ys,gs=nt.Symbol,ms={},bs=I,_s=Zt,ws=Function.prototype,Es=bs&&Object.getOwnPropertyDescriptor,Ts=_s(ws,"name"),Os={EXISTS:Ts,PROPER:Ts&&"something"===function(){}.name,CONFIGURABLE:Ts&&(!bs||bs&&Es(ws,"name").configurable)},xs=!u((function(){function t(){}return t.prototype.constructor=null,Object.getPrototypeOf(new t)!==t.prototype})),ks=Zt,Ss=A,js=Jt,As=xs,Ps=Li("IE_PROTO"),Is=Object,Ds=Is.prototype,Ls=As?Is.getPrototypeOf:function(t){var e=js(t);if(ks(e,Ps))return e[Ps];var r=e.constructor;return Ss(r)&&e instanceof r?r.prototype:e instanceof Is?Ds:null},Cs=u,Rs=A,Ms=rt,Ns=Bi,Fs=Ls,zs=lo,Us=pe("iterator"),qs=!1;[].keys&&("next"in(ys=[].keys())?(ds=Fs(Fs(ys)))!==Object.prototype&&(vs=ds):qs=!0);var Ys=!Ms(vs)||Cs((function(){var t={};return vs[Us].call(t)!==t}));Rs((vs=Ys?{}:Ns(vs))[Us])||zs(vs,Us,(function(){return this}));var Ws={IteratorPrototype:vs,BUGGY_SAFARI_ITERATORS:qs},Gs=Ws.IteratorPrototype,Xs=Bi,Vs=q,Bs=Fo,Hs=ms,$s=function(){return this},Js=m,Ks=Dt,Qs=A,Zs=String,tc=TypeError,ec=function(t,e,r){try{return Js(Ks(Object.getOwnPropertyDescriptor(t,e)[r]))}catch(t){}},rc=nr,nc=function(t){if("object"==typeof t||Qs(t))return t;throw tc("Can't set "+Zs(t)+" as a prototype")},ic=Object.setPrototypeOf||("__proto__"in{}?function(){var t,e=!1,r={};try{(t=ec(Object.prototype,"__proto__","set"))(r,[]),e=r instanceof Array}catch(t){}return function(r,n){return rc(r),nc(n),e?t(r,n):r.__proto__=n,r}}():void 0),oc=Ar,ac=C,uc=Os,sc=function(t,e,r,n){var i=e+" Iterator";return t.prototype=Xs(Gs,{next:Vs(+!n,r)}),Bs(t,i,!1,!0),Hs[i]=$s,t},cc=Ls,fc=Fo,lc=lo,hc=ms,pc=Ws,vc=uc.PROPER,dc=pc.BUGGY_SAFARI_ITERATORS,yc=pe("iterator"),gc="keys",mc="values",bc="entries",_c=function(){return this},wc=function(t,e,r,n,i,o,a){sc(r,e,n);var u,s,c,f=function(t){if(t===i&&d)return d;if(!dc&&t in p)return p[t];switch(t){case gc:case mc:case bc:return function(){return new r(this,t)}}return function(){return new r(this)}},l=e+" Iterator",h=!1,p=t.prototype,v=p[yc]||p["@@iterator"]||i&&p[i],d=!dc&&v||f(i),y="Array"==e&&p.entries||v;if(y&&(u=cc(y.call(new t)))!==Object.prototype&&u.next&&(fc(u,l,!0,!0),hc[l]=_c),vc&&i==mc&&v&&v.name!==mc&&(h=!0,d=function(){return ac(v,this)}),i)if(s={values:f(mc),keys:o?d:f(gc),entries:f(bc)},a)for(c in s)(dc||h||!(c in p))&&lc(p,c,s[c]);else oc({target:e,proto:!0,forced:dc||h},s);return a&&p[yc]!==d&&lc(p,yc,d,{name:i}),hc[e]=d,s},Ec=function(t,e){return{value:t,done:e}},Tc=Z,Oc=ms,xc=ta;Qe.f;var kc=wc,Sc=Ec,jc="Array Iterator",Ac=xc.set,Pc=xc.getterFor(jc);kc(Array,"Array",(function(t,e){Ac(this,{type:jc,target:Tc(t),index:0,kind:e})}),(function(){var t=Pc(this),e=t.target,r=t.kind,n=t.index++;return!e||n>=e.length?(t.target=void 0,Sc(void 0,!0)):Sc("keys"==r?n:"values"==r?e[n]:[n,e[n]],!1)}),"values"),Oc.Arguments=Oc.Array;var Ic={CSSRuleList:0,CSSStyleDeclaration:0,CSSValueList:0,ClientRectList:0,DOMRectList:0,DOMStringList:0,DOMTokenList:1,DataTransferItemList:0,FileList:0,HTMLAllCollection:0,HTMLCollection:0,HTMLFormElement:0,HTMLSelectElement:0,MediaList:0,MimeTypeArray:0,NamedNodeMap:0,NodeList:1,PaintRequestList:0,Plugin:0,PluginArray:0,SVGLengthList:0,SVGNumberList:0,SVGPathSegList:0,SVGPointList:0,SVGStringList:0,SVGTransformList:0,SourceBufferList:0,StyleSheetList:0,TextTrackCueList:0,TextTrackList:0,TouchList:0},Dc=a,Lc=cn,Cc=gr,Rc=ms,Mc=pe("toStringTag");for(var Nc in Ic){var Fc=Dc[Nc],zc=Fc&&Fc.prototype;zc&&Lc(zc)!==Mc&&Cc(zc,Mc,Nc),Rc[Nc]=Rc.Array}var Uc=gs;Oo("dispose");var qc=Uc;Oo("asyncDispose");var Yc=Ar,Wc=m,Gc=st("Symbol"),Xc=Gc.keyFor,Vc=Wc(Gc.prototype.valueOf);Yc({target:"Symbol",stat:!0},{isRegistered:function(t){try{return void 0!==Xc(Vc(t))}catch(t){return!1}}});for(var Bc=Ar,Hc=Bt,$c=st,Jc=m,Kc=kt,Qc=pe,Zc=$c("Symbol"),tf=Zc.isWellKnown,ef=$c("Object","getOwnPropertyNames"),rf=Jc(Zc.prototype.valueOf),nf=Hc("wks"),of=0,af=ef(Zc),uf=af.length;of<uf;of++)try{var sf=af[of];Kc(Zc[sf])&&Qc(sf)}catch(t){}Bc({target:"Symbol",stat:!0,forced:!0},{isWellKnown:function(t){if(tf&&tf(t))return!0;try{for(var e=rf(t),r=0,n=ef(nf),i=n.length;r<i;r++)if(nf[n[r]]==e)return!0}catch(t){}return!1}}),Oo("matcher"),Oo("metadataKey"),Oo("observable"),Oo("metadata"),Oo("patternMatch"),Oo("replaceAll");var cf=qc,ff=n(cf),lf=m,hf=Wr,pf=ei,vf=J,df=lf("".charAt),yf=lf("".charCodeAt),gf=lf("".slice),mf=function(t){return function(e,r){var n,i,o=pf(vf(e)),a=hf(r),u=o.length;return a<0||a>=u?t?"":void 0:(n=yf(o,a))<55296||n>56319||a+1===u||(i=yf(o,a+1))<56320||i>57343?t?df(o,a):n:t?gf(o,a,a+2):i-56320+(n-55296<<10)+65536}},bf={codeAt:mf(!1),charAt:mf(!0)}.charAt,_f=ei,wf=ta,Ef=wc,Tf=Ec,Of="String Iterator",xf=wf.set,kf=wf.getterFor(Of);Ef(String,"String",(function(t){xf(this,{type:Of,string:_f(t),index:0})}),(function(){var t,e=kf(this),r=e.string,n=e.index;return n>=r.length?Tf(void 0,!0):(t=bf(r,n),e.index+=t.length,Tf(t,!1))}));var Sf=vo.f("iterator"),jf=Sf,Af=n(jf);function Pf(t){return Pf="function"==typeof ff&&"symbol"==typeof Af?function(t){return typeof t}:function(t){return t&&"function"==typeof ff&&t.constructor===ff&&t!==ff.prototype?"symbol":typeof t},Pf(t)}var If=n(vo.f("toPrimitive"));function Df(t){var e=function(t,e){if("object"!==Pf(t)||null===t)return t;var r=t[If];if(void 0!==r){var n=r.call(t,e||"default");if("object"!==Pf(n))return n;throw new TypeError("@@toPrimitive must return a primitive value.")}return("string"===e?String:Number)(t)}(t,"string");return"symbol"===Pf(e)?e:String(e)}function Lf(t,e){for(var r=0;r<e.length;r++){var n=e[r];n.enumerable=n.enumerable||!1,n.configurable=!0,"value"in n&&(n.writable=!0),Nr(t,Df(n.key),n)}}function Cf(t,e,r){return e&&Lf(t.prototype,e),r&&Lf(t,r),Nr(t,"prototype",{writable:!1}),t}function Rf(t,e,r){return(e=Df(e))in t?Nr(t,e,{value:r,enumerable:!0,configurable:!0,writable:!0}):t[e]=r,t}var Mf=m,Nf=Dt,Ff=rt,zf=Zt,Uf=Du,qf=s,Yf=Function,Wf=Mf([].concat),Gf=Mf([].join),Xf={},Vf=qf?Yf.bind:function(t){var e=Nf(this),r=e.prototype,n=Uf(arguments,1),i=function(){var r=Wf(n,Uf(arguments));return this instanceof i?function(t,e,r){if(!zf(Xf,e)){for(var n=[],i=0;i<e;i++)n[i]="a["+i+"]";Xf[e]=Yf("C,a","return new C("+Gf(n,",")+")")}return Xf[e](t,r)}(e,r.length,r):e.apply(t,r)};return Ff(r)&&(i.prototype=r),i},Bf=Vf;Ar({target:"Function",proto:!0,forced:Function.bind!==Bf},{bind:Bf});var Hf=nt,$f=function(t){return Hf[t+"Prototype"]},Jf=$f("Function").bind,Kf=ct,Qf=Jf,Zf=Function.prototype,tl=function(t){var e=t.bind;return t===Zf||Kf(Zf,t)&&e===Zf.bind?Qf:e},el=n(tl),rl=Dt,nl=Jt,il=V,ol=Br,al=TypeError,ul=function(t){return function(e,r,n,i){rl(r);var o=nl(e),a=il(o),u=ol(o),s=t?u-1:0,c=t?-1:1;if(n<2)for(;;){if(s in a){i=a[s],s+=c;break}if(s+=c,t?s<0:u<=s)throw al("Reduce of empty array with no initial value")}for(;t?s>=0:u>s;s+=c)s in a&&(i=r(i,a[s],s,o));return i}},sl={left:ul(!1),right:ul(!0)},cl=u,fl=function(t,e){var r=[][t];return!!r&&cl((function(){r.call(null,e||function(){return 1},1)}))},ll="undefined"!=typeof process&&"process"==E(process),hl=sl.left;Ar({target:"Array",proto:!0,forced:!ll&&gt>79&&gt<83||!fl("reduce")},{reduce:function(t){var e=arguments.length;return hl(this,t,e,e>1?arguments[1]:void 0)}});var pl=$f("Array").reduce,vl=ct,dl=pl,yl=Array.prototype,gl=n((function(t){var e=t.reduce;return t===yl||vl(yl,t)&&e===yl.reduce?dl:e})),ml=sa.filter;Ar({target:"Array",proto:!0,forced:!Fn("filter")},{filter:function(t){return ml(this,t,arguments.length>1?arguments[1]:void 0)}});var bl=$f("Array").filter,_l=ct,wl=bl,El=Array.prototype,Tl=n((function(t){var e=t.filter;return t===El||_l(El,t)&&e===El.filter?wl:e})),Ol=sa.map;Ar({target:"Array",proto:!0,forced:!Fn("map")},{map:function(t){return Ol(this,t,arguments.length>1?arguments[1]:void 0)}});var xl=$f("Array").map,kl=ct,Sl=xl,jl=Array.prototype,Al=n((function(t){var e=t.map;return t===jl||kl(jl,t)&&e===jl.map?Sl:e})),Pl=zr,Il=Br,Dl=$r,Ll=Ke,Cl=function(t,e,r,n,i,o,a,u){for(var s,c,f=i,l=0,h=!!a&&Ll(a,u);l<n;)l in r&&(s=h?h(r[l],l,e):r[l],o>0&&Pl(s)?(c=Il(s),f=Cl(t,e,s,c,f,o-1)-1):(Dl(f+1),t[f]=s),f++),l++;return f},Rl=Cl,Ml=Dt,Nl=Jt,Fl=Br,zl=Cn;Ar({target:"Array",proto:!0},{flatMap:function(t){var e,r=Nl(this),n=Fl(r);return Ml(t),(e=zl(r,0)).length=Rl(e,r,r,n,0,1,t,arguments.length>1?arguments[1]:void 0),e}});var Ul=$f("Array").flatMap,ql=ct,Yl=Ul,Wl=Array.prototype,Gl=n((function(t){var e=t.flatMap;return t===Wl||ql(Wl,t)&&e===Wl.flatMap?Yl:e}));var Xl=function(){function t(r,n,i){var o,a,u;e(this,t),Rf(this,"_source",void 0),Rf(this,"_transformers",void 0),Rf(this,"_target",void 0),Rf(this,"_listeners",{add:el(o=this._add).call(o,this),remove:el(a=this._remove).call(a,this),update:el(u=this._update).call(u,this)}),this._source=r,this._transformers=n,this._target=i}return Cf(t,[{key:"all",value:function(){return this._target.update(this._transformItems(this._source.get())),this}},{key:"start",value:function(){return this._source.on("add",this._listeners.add),this._source.on("remove",this._listeners.remove),this._source.on("update",this._listeners.update),this}},{key:"stop",value:function(){return this._source.off("add",this._listeners.add),this._source.off("remove",this._listeners.remove),this._source.off("update",this._listeners.update),this}},{key:"_transformItems",value:function(t){var e;return gl(e=this._transformers).call(e,(function(t,e){return e(t)}),t)}},{key:"_add",value:function(t,e){null!=e&&this._target.add(this._transformItems(this._source.get(e.items)))}},{key:"_update",value:function(t,e){null!=e&&this._target.update(this._transformItems(this._source.get(e.items)))}},{key:"_remove",value:function(t,e){null!=e&&this._target.remove(this._transformItems(e.oldData))}}]),t}(),Vl=function(){function t(r){e(this,t),Rf(this,"_source",void 0),Rf(this,"_transformers",[]),this._source=r}return Cf(t,[{key:"filter",value:function(t){return this._transformers.push((function(e){return Tl(e).call(e,t)})),this}},{key:"map",value:function(t){return this._transformers.push((function(e){return Al(e).call(e,t)})),this}},{key:"flatMap",value:function(t){return this._transformers.push((function(e){return Gl(e).call(e,t)})),this}},{key:"to",value:function(t){return new Xl(this._source,this._transformers,t)}}]),t}(),Bl=C,Hl=nr,$l=Rt,Jl=function(t,e,r){var n,i;Hl(t);try{if(!(n=$l(t,"return"))){if("throw"===e)throw r;return r}n=Bl(n,t)}catch(t){i=!0,n=t}if("throw"===e)throw r;if(i)throw n;return Hl(n),r},Kl=nr,Ql=Jl,Zl=ms,th=pe("iterator"),eh=Array.prototype,rh=function(t){return void 0!==t&&(Zl.Array===t||eh[th]===t)},nh=cn,ih=Rt,oh=B,ah=ms,uh=pe("iterator"),sh=function(t){if(!oh(t))return ih(t,uh)||ih(t,"@@iterator")||ah[nh(t)]},ch=C,fh=Dt,lh=nr,hh=jt,ph=sh,vh=TypeError,dh=function(t,e){var r=arguments.length<2?ph(t):e;if(fh(r))return lh(ch(r,t));throw vh(hh(t)+" is not iterable")},yh=Ke,gh=C,mh=Jt,bh=function(t,e,r,n){try{return n?e(Kl(r)[0],r[1]):e(r)}catch(e){Ql(t,"throw",e)}},_h=rh,wh=Sn,Eh=Br,Th=Zr,Oh=dh,xh=sh,kh=Array,Sh=pe("iterator"),jh=!1;try{var Ah=0,Ph={next:function(){return{done:!!Ah++}},return:function(){jh=!0}};Ph[Sh]=function(){return this},Array.from(Ph,(function(){throw 2}))}catch(t){}var Ih=function(t,e){if(!e&&!jh)return!1;var r=!1;try{var n={};n[Sh]=function(){return{next:function(){return{done:r=!0}}}},t(n)}catch(t){}return r},Dh=function(t){var e=mh(t),r=wh(this),n=arguments.length,i=n>1?arguments[1]:void 0,o=void 0!==i;o&&(i=yh(i,n>2?arguments[2]:void 0));var a,u,s,c,f,l,h=xh(e),p=0;if(!h||this===kh&&_h(h))for(a=Eh(e),u=r?new this(a):kh(a);a>p;p++)l=o?i(e[p],p):e[p],Th(u,p,l);else for(f=(c=Oh(e,h)).next,u=r?new this:[];!(s=gh(f,c)).done;p++)l=o?bh(c,i,[s.value,p],!0):s.value,Th(u,p,l);return u.length=p,u};Ar({target:"Array",stat:!0,forced:!Ih((function(t){Array.from(t)}))},{from:Dh});var Lh=nt.Array.from,Ch=n(Lh),Rh=n(sh),Mh=n(nt.Object.getOwnPropertySymbols),Nh={exports:{}},Fh=Ar,zh=u,Uh=Z,qh=P.f,Yh=I;Fh({target:"Object",stat:!0,forced:!Yh||zh((function(){qh(1)})),sham:!Yh},{getOwnPropertyDescriptor:function(t,e){return qh(Uh(t),e)}});var Wh=nt.Object,Gh=Nh.exports=function(t,e){return Wh.getOwnPropertyDescriptor(t,e)};Wh.getOwnPropertyDescriptor.sham&&(Gh.sham=!0);var Xh=n(Nh.exports),Vh=st,Bh=Hi,Hh=co,$h=nr,Jh=m([].concat),Kh=Vh("Reflect","ownKeys")||function(t){var e=Bh.f($h(t)),r=Hh.f;return r?Jh(e,r(t)):e},Qh=Kh,Zh=Z,tp=P,ep=Zr;Ar({target:"Object",stat:!0,sham:!I},{getOwnPropertyDescriptors:function(t){for(var e,r,n=Zh(t),i=tp.f,o=Qh(n),a={},u=0;o.length>u;)void 0!==(r=i(n,e=o[u++]))&&ep(a,e,r);return a}});var rp=n(nt.Object.getOwnPropertyDescriptors),np={exports:{}},ip=Ar,op=I,ap=ri.f;ip({target:"Object",stat:!0,forced:Object.defineProperties!==ap,sham:!op},{defineProperties:ap});var up=nt.Object,sp=np.exports=function(t,e){return up.defineProperties(t,e)};up.defineProperties.sham&&(sp.sham=!0);var cp=n(np.exports),fp=n(Rr);Ar({target:"Array",stat:!0},{isArray:zr});var lp=nt.Array.isArray,hp=n(lp);var pp=Ar,vp=zr,dp=Sn,yp=rt,gp=ai,mp=Br,bp=Z,_p=Zr,wp=pe,Ep=Du,Tp=Fn("slice"),Op=wp("species"),xp=Array,kp=Math.max;pp({target:"Array",proto:!0,forced:!Tp},{slice:function(t,e){var r,n,i,o=bp(this),a=mp(o),u=gp(t,a),s=gp(void 0===e?a:e,a);if(vp(o)&&(r=o.constructor,(dp(r)&&(r===xp||vp(r.prototype))||yp(r)&&null===(r=r[Op]))&&(r=void 0),r===xp||void 0===r))return Ep(o,u,s);for(n=new(void 0===r?xp:r)(kp(s-u,0)),i=0;u<s;u++,i++)u in o&&_p(n,i,o[u]);return n.length=i,n}});var Sp=$f("Array").slice,jp=ct,Ap=Sp,Pp=Array.prototype,Ip=function(t){var e=t.slice;return t===Pp||jp(Pp,t)&&e===Pp.slice?Ap:e},Dp=Ip,Lp=n(Dp),Cp=n(Lh);function Rp(t,e){(null==e||e>t.length)&&(e=t.length);for(var r=0,n=new Array(e);r<e;r++)n[r]=t[r];return n}function Mp(t,e){var r;if(t){if("string"==typeof t)return Rp(t,e);var n=Lp(r=Object.prototype.toString.call(t)).call(r,8,-1);return"Object"===n&&t.constructor&&(n=t.constructor.name),"Map"===n||"Set"===n?Cp(t):"Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)?Rp(t,e):void 0}}function Np(t,e){return function(t){if(hp(t))return t}(t)||function(t,e){var r=null==t?null:void 0!==ff&&Rh(t)||t["@@iterator"];if(null!=r){var n,i,o,a,u=[],s=!0,c=!1;try{if(o=(r=r.call(t)).next,0===e){if(Object(r)!==r)return;s=!1}else for(;!(s=(n=o.call(r)).done)&&(u.push(n.value),u.length!==e);s=!0);}catch(t){c=!0,i=t}finally{try{if(!s&&null!=r.return&&(a=r.return(),Object(a)!==a))return}finally{if(c)throw i}}return u}}(t,e)||Mp(t,e)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}function Fp(t){return function(t){if(hp(t))return Rp(t)}(t)||function(t){if(void 0!==ff&&null!=Rh(t)||null!=t["@@iterator"])return Cp(t)}(t)||Mp(t)||function(){throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var zp=n(Uc),Up=$f("Array").concat,qp=ct,Yp=Up,Wp=Array.prototype,Gp=n((function(t){var e=t.concat;return t===Wp||qp(Wp,t)&&e===Wp.concat?Yp:e})),Xp=n(Ip);Ar({target:"Reflect",stat:!0},{ownKeys:Kh});var Vp=n(nt.Reflect.ownKeys),Bp=n(lp),Hp=Jt,$p=Ei;Ar({target:"Object",stat:!0,forced:u((function(){$p(1)}))},{keys:function(t){return $p(Hp(t))}});var Jp=n(nt.Object.keys),Kp=sa.forEach,Qp=fl("forEach")?[].forEach:function(t){return Kp(this,t,arguments.length>1?arguments[1]:void 0)};Ar({target:"Array",proto:!0,forced:[].forEach!=Qp},{forEach:Qp});var Zp=$f("Array").forEach,tv=cn,ev=Zt,rv=ct,nv=Zp,iv=Array.prototype,ov={DOMTokenList:!0,NodeList:!0},av=function(t){var e=t.forEach;return t===iv||rv(iv,t)&&e===iv.forEach||ev(ov,tv(t))?nv:e},uv=n(av),sv=Ar,cv=zr,fv=m([].reverse),lv=[1,2];sv({target:"Array",proto:!0,forced:String(lv)===String(lv.reverse())},{reverse:function(){return cv(this)&&(this.length=this.length),fv(this)}});var hv=$f("Array").reverse,pv=ct,vv=hv,dv=Array.prototype,yv=function(t){var e=t.reverse;return t===dv||pv(dv,t)&&e===dv.reverse?vv:e},gv=n(yv),mv=I,bv=zr,_v=TypeError,wv=Object.getOwnPropertyDescriptor,Ev=mv&&!function(){if(void 0!==this)return!0;try{Object.defineProperty([],"length",{writable:!1}).length=1}catch(t){return t instanceof TypeError}}(),Tv=jt,Ov=TypeError,xv=function(t,e){if(!delete t[e])throw Ov("Cannot delete property "+Tv(e)+" of "+Tv(t))},kv=Ar,Sv=Jt,jv=ai,Av=Wr,Pv=Br,Iv=Ev?function(t,e){if(bv(t)&&!wv(t,"length").writable)throw _v("Cannot set read only .length");return t.length=e}:function(t,e){return t.length=e},Dv=$r,Lv=Cn,Cv=Zr,Rv=xv,Mv=Fn("splice"),Nv=Math.max,Fv=Math.min;kv({target:"Array",proto:!0,forced:!Mv},{splice:function(t,e){var r,n,i,o,a,u,s=Sv(this),c=Pv(s),f=jv(t,c),l=arguments.length;for(0===l?r=n=0:1===l?(r=0,n=c-f):(r=l-2,n=Fv(Nv(Av(e),0),c-f)),Dv(c+r-n),i=Lv(s,n),o=0;o<n;o++)(a=f+o)in s&&Cv(i,o,s[a]);if(i.length=n,r<n){for(o=f;o<c-n;o++)u=o+r,(a=o+n)in s?s[u]=s[a]:Rv(s,u);for(o=c;o>c-n+r;o--)Rv(s,o-1)}else if(r>n)for(o=c-n;o>f;o--)u=o+r-1,(a=o+n-1)in s?s[u]=s[a]:Rv(s,u);for(o=0;o<r;o++)s[o+f]=arguments[o+2];return Iv(s,c-n+r),i}});var zv=$f("Array").splice,Uv=ct,qv=zv,Yv=Array.prototype,Wv=n((function(t){var e=t.splice;return t===Yv||Uv(Yv,t)&&e===Yv.splice?qv:e})),Gv=I,Xv=m,Vv=C,Bv=u,Hv=Ei,$v=co,Jv=R,Kv=Jt,Qv=V,Zv=Object.assign,td=Object.defineProperty,ed=Xv([].concat),rd=!Zv||Bv((function(){if(Gv&&1!==Zv({b:1},Zv(td({},"a",{enumerable:!0,get:function(){td(this,"b",{value:3,enumerable:!1})}}),{b:2})).b)return!0;var t={},e={},r=Symbol(),n="abcdefghijklmnopqrst";return t[r]=7,n.split("").forEach((function(t){e[t]=t})),7!=Zv({},t)[r]||Hv(Zv({},e)).join("")!=n}))?function(t,e){for(var r=Kv(t),n=arguments.length,i=1,o=$v.f,a=Jv.f;n>i;)for(var u,s=Qv(arguments[i++]),c=o?ed(Hv(s),o(s)):Hv(s),f=c.length,l=0;f>l;)u=c[l++],Gv&&!Vv(a,s,u)||(r[u]=s[u]);return r}:Zv,nd=rd;Ar({target:"Object",stat:!0,arity:2,forced:Object.assign!==nd},{assign:nd});var id=n(nt.Object.assign),od=Jt,ad=Ls,ud=xs;Ar({target:"Object",stat:!0,forced:u((function(){ad(1)})),sham:!ud},{getPrototypeOf:function(t){return ad(od(t))}});var sd=nt.Object.getPrototypeOf;Ar({target:"Object",stat:!0,sham:!I},{create:Bi});var cd=nt.Object,fd=function(t,e){return cd.create(t,e)},ld=n(fd),hd=nt,pd=p;hd.JSON||(hd.JSON={stringify:JSON.stringify});var vd=function(t,e,r){return pd(hd.JSON.stringify,null,arguments)},dd=n(vd),yd="function"==typeof Bun&&Bun&&"string"==typeof Bun.version,gd=TypeError,md=function(t,e){if(t<e)throw gd("Not enough arguments");return t},bd=a,_d=p,wd=A,Ed=yd,Td=ft,Od=Du,xd=md,kd=bd.Function,Sd=/MSIE .\./.test(Td)||Ed&&function(){var t=bd.Bun.version.split(".");return t.length<3||0==t[0]&&(t[1]<3||3==t[1]&&0==t[2])}(),jd=function(t,e){var r=e?2:1;return Sd?function(n,i){var o=xd(arguments.length,1)>r,a=wd(n)?n:kd(n),u=o?Od(arguments,r):[],s=o?function(){_d(a,this,u)}:a;return e?t(s,i):t(s)}:t},Ad=Ar,Pd=a,Id=jd(Pd.setInterval,!0);Ad({global:!0,bind:!0,forced:Pd.setInterval!==Id},{setInterval:Id});var Dd=Ar,Ld=a,Cd=jd(Ld.setTimeout,!0);Dd({global:!0,bind:!0,forced:Ld.setTimeout!==Cd},{setTimeout:Cd});var Rd=n(nt.setTimeout),Md={exports:{}};!function(t){function e(t){if(t)return function(t){for(var r in e.prototype)t[r]=e.prototype[r];return t}(t)}t.exports=e,e.prototype.on=e.prototype.addEventListener=function(t,e){return this._callbacks=this._callbacks||{},(this._callbacks["$"+t]=this._callbacks["$"+t]||[]).push(e),this},e.prototype.once=function(t,e){function r(){this.off(t,r),e.apply(this,arguments)}return r.fn=e,this.on(t,r),this},e.prototype.off=e.prototype.removeListener=e.prototype.removeAllListeners=e.prototype.removeEventListener=function(t,e){if(this._callbacks=this._callbacks||{},0==arguments.length)return this._callbacks={},this;var r,n=this._callbacks["$"+t];if(!n)return this;if(1==arguments.length)return delete this._callbacks["$"+t],this;for(var i=0;i<n.length;i++)if((r=n[i])===e||r.fn===e){n.splice(i,1);break}return 0===n.length&&delete this._callbacks["$"+t],this},e.prototype.emit=function(t){this._callbacks=this._callbacks||{};for(var e=new Array(arguments.length-1),r=this._callbacks["$"+t],n=1;n<arguments.length;n++)e[n-1]=arguments[n];if(r){n=0;for(var i=(r=r.slice(0)).length;n<i;++n)r[n].apply(this,e)}return this},e.prototype.listeners=function(t){return this._callbacks=this._callbacks||{},this._callbacks["$"+t]||[]},e.prototype.hasListeners=function(t){return!!this.listeners(t).length}}(Md);var Nd,Fd=n(Md.exports);
/*! Hammer.JS - v2.0.17-rc - 2019-12-16
   * http://naver.github.io/egjs
   *
   * Forked By Naver egjs
   * Copyright (c) hammerjs
   * Licensed under the MIT license */
function zd(){return zd=Object.assign||function(t){for(var e=1;e<arguments.length;e++){var r=arguments[e];for(var n in r)Object.prototype.hasOwnProperty.call(r,n)&&(t[n]=r[n])}return t},zd.apply(this,arguments)}function Ud(t,e){t.prototype=Object.create(e.prototype),t.prototype.constructor=t,t.__proto__=e}function qd(t){if(void 0===t)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return t}Nd="function"!=typeof Object.assign?function(t){if(null==t)throw new TypeError("Cannot convert undefined or null to object");for(var e=Object(t),r=1;r<arguments.length;r++){var n=arguments[r];if(null!=n)for(var i in n)n.hasOwnProperty(i)&&(e[i]=n[i])}return e}:Object.assign;var Yd,Wd=Nd,Gd=["","webkit","Moz","MS","ms","o"],Xd="undefined"==typeof document?{style:{}}:document.createElement("div"),Vd=Math.round,Bd=Math.abs,Hd=Date.now;function $d(t,e){for(var r,n,i=e[0].toUpperCase()+e.slice(1),o=0;o<Gd.length;){if((n=(r=Gd[o])?r+i:e)in t)return n;o++}}Yd="undefined"==typeof window?{}:window;var Jd=$d(Xd.style,"touchAction"),Kd=void 0!==Jd;var Qd="compute",Zd="auto",ty="manipulation",ey="none",ry="pan-x",ny="pan-y",iy=function(){if(!Kd)return!1;var t={},e=Yd.CSS&&Yd.CSS.supports;return["auto","manipulation","pan-y","pan-x","pan-x pan-y","none"].forEach((function(r){return t[r]=!e||Yd.CSS.supports("touch-action",r)})),t}(),oy="ontouchstart"in Yd,ay=void 0!==$d(Yd,"PointerEvent"),uy=oy&&/mobile|tablet|ip(ad|hone|od)|android/i.test(navigator.userAgent),sy="touch",cy="mouse",fy=25,ly=1,hy=4,py=8,vy=1,dy=2,yy=4,gy=8,my=16,by=dy|yy,_y=gy|my,wy=by|_y,Ey=["x","y"],Ty=["clientX","clientY"];function Oy(t,e,r){var n;if(t)if(t.forEach)t.forEach(e,r);else if(void 0!==t.length)for(n=0;n<t.length;)e.call(r,t[n],n,t),n++;else for(n in t)t.hasOwnProperty(n)&&e.call(r,t[n],n,t)}function xy(t,e){return"function"==typeof t?t.apply(e&&e[0]||void 0,e):t}function ky(t,e){return t.indexOf(e)>-1}var Sy=function(){function t(t,e){this.manager=t,this.set(e)}var e=t.prototype;return e.set=function(t){t===Qd&&(t=this.compute()),Kd&&this.manager.element.style&&iy[t]&&(this.manager.element.style[Jd]=t),this.actions=t.toLowerCase().trim()},e.update=function(){this.set(this.manager.options.touchAction)},e.compute=function(){var t=[];return Oy(this.manager.recognizers,(function(e){xy(e.options.enable,[e])&&(t=t.concat(e.getTouchAction()))})),function(t){if(ky(t,ey))return ey;var e=ky(t,ry),r=ky(t,ny);return e&&r?ey:e||r?e?ry:ny:ky(t,ty)?ty:Zd}(t.join(" "))},e.preventDefaults=function(t){var e=t.srcEvent,r=t.offsetDirection;if(this.manager.session.prevented)e.preventDefault();else{var n=this.actions,i=ky(n,ey)&&!iy[ey],o=ky(n,ny)&&!iy[ny],a=ky(n,ry)&&!iy[ry];if(i){var u=1===t.pointers.length,s=t.distance<2,c=t.deltaTime<250;if(u&&s&&c)return}if(!a||!o)return i||o&&r&by||a&&r&_y?this.preventSrc(e):void 0}},e.preventSrc=function(t){this.manager.session.prevented=!0,t.preventDefault()},t}();function jy(t,e){for(;t;){if(t===e)return!0;t=t.parentNode}return!1}function Ay(t){var e=t.length;if(1===e)return{x:Vd(t[0].clientX),y:Vd(t[0].clientY)};for(var r=0,n=0,i=0;i<e;)r+=t[i].clientX,n+=t[i].clientY,i++;return{x:Vd(r/e),y:Vd(n/e)}}function Py(t){for(var e=[],r=0;r<t.pointers.length;)e[r]={clientX:Vd(t.pointers[r].clientX),clientY:Vd(t.pointers[r].clientY)},r++;return{timeStamp:Hd(),pointers:e,center:Ay(e),deltaX:t.deltaX,deltaY:t.deltaY}}function Iy(t,e,r){r||(r=Ey);var n=e[r[0]]-t[r[0]],i=e[r[1]]-t[r[1]];return Math.sqrt(n*n+i*i)}function Dy(t,e,r){r||(r=Ey);var n=e[r[0]]-t[r[0]],i=e[r[1]]-t[r[1]];return 180*Math.atan2(i,n)/Math.PI}function Ly(t,e){return t===e?vy:Bd(t)>=Bd(e)?t<0?dy:yy:e<0?gy:my}function Cy(t,e,r){return{x:e/t||0,y:r/t||0}}function Ry(t,e){var r=t.session,n=e.pointers,i=n.length;r.firstInput||(r.firstInput=Py(e)),i>1&&!r.firstMultiple?r.firstMultiple=Py(e):1===i&&(r.firstMultiple=!1);var o=r.firstInput,a=r.firstMultiple,u=a?a.center:o.center,s=e.center=Ay(n);e.timeStamp=Hd(),e.deltaTime=e.timeStamp-o.timeStamp,e.angle=Dy(u,s),e.distance=Iy(u,s),function(t,e){var r=e.center,n=t.offsetDelta||{},i=t.prevDelta||{},o=t.prevInput||{};e.eventType!==ly&&o.eventType!==hy||(i=t.prevDelta={x:o.deltaX||0,y:o.deltaY||0},n=t.offsetDelta={x:r.x,y:r.y}),e.deltaX=i.x+(r.x-n.x),e.deltaY=i.y+(r.y-n.y)}(r,e),e.offsetDirection=Ly(e.deltaX,e.deltaY);var c,f,l=Cy(e.deltaTime,e.deltaX,e.deltaY);e.overallVelocityX=l.x,e.overallVelocityY=l.y,e.overallVelocity=Bd(l.x)>Bd(l.y)?l.x:l.y,e.scale=a?(c=a.pointers,Iy((f=n)[0],f[1],Ty)/Iy(c[0],c[1],Ty)):1,e.rotation=a?function(t,e){return Dy(e[1],e[0],Ty)+Dy(t[1],t[0],Ty)}(a.pointers,n):0,e.maxPointers=r.prevInput?e.pointers.length>r.prevInput.maxPointers?e.pointers.length:r.prevInput.maxPointers:e.pointers.length,function(t,e){var r,n,i,o,a=t.lastInterval||e,u=e.timeStamp-a.timeStamp;if(e.eventType!==py&&(u>fy||void 0===a.velocity)){var s=e.deltaX-a.deltaX,c=e.deltaY-a.deltaY,f=Cy(u,s,c);n=f.x,i=f.y,r=Bd(f.x)>Bd(f.y)?f.x:f.y,o=Ly(s,c),t.lastInterval=e}else r=a.velocity,n=a.velocityX,i=a.velocityY,o=a.direction;e.velocity=r,e.velocityX=n,e.velocityY=i,e.direction=o}(r,e);var h,p=t.element,v=e.srcEvent;jy(h=v.composedPath?v.composedPath()[0]:v.path?v.path[0]:v.target,p)&&(p=h),e.target=p}function My(t,e,r){var n=r.pointers.length,i=r.changedPointers.length,o=e&ly&&n-i==0,a=e&(hy|py)&&n-i==0;r.isFirst=!!o,r.isFinal=!!a,o&&(t.session={}),r.eventType=e,Ry(t,r),t.emit("hammer.input",r),t.recognize(r),t.session.prevInput=r}function Ny(t){return t.trim().split(/\s+/g)}function Fy(t,e,r){Oy(Ny(e),(function(e){t.addEventListener(e,r,!1)}))}function zy(t,e,r){Oy(Ny(e),(function(e){t.removeEventListener(e,r,!1)}))}function Uy(t){var e=t.ownerDocument||t;return e.defaultView||e.parentWindow||window}var qy=function(){function t(t,e){var r=this;this.manager=t,this.callback=e,this.element=t.element,this.target=t.options.inputTarget,this.domHandler=function(e){xy(t.options.enable,[t])&&r.handler(e)},this.init()}var e=t.prototype;return e.handler=function(){},e.init=function(){this.evEl&&Fy(this.element,this.evEl,this.domHandler),this.evTarget&&Fy(this.target,this.evTarget,this.domHandler),this.evWin&&Fy(Uy(this.element),this.evWin,this.domHandler)},e.destroy=function(){this.evEl&&zy(this.element,this.evEl,this.domHandler),this.evTarget&&zy(this.target,this.evTarget,this.domHandler),this.evWin&&zy(Uy(this.element),this.evWin,this.domHandler)},t}();function Yy(t,e,r){if(t.indexOf&&!r)return t.indexOf(e);for(var n=0;n<t.length;){if(r&&t[n][r]==e||!r&&t[n]===e)return n;n++}return-1}var Wy={pointerdown:ly,pointermove:2,pointerup:hy,pointercancel:py,pointerout:py},Gy={2:sy,3:"pen",4:cy,5:"kinect"},Xy="pointerdown",Vy="pointermove pointerup pointercancel";Yd.MSPointerEvent&&!Yd.PointerEvent&&(Xy="MSPointerDown",Vy="MSPointerMove MSPointerUp MSPointerCancel");var By=function(t){function e(){var r,n=e.prototype;return n.evEl=Xy,n.evWin=Vy,(r=t.apply(this,arguments)||this).store=r.manager.session.pointerEvents=[],r}return Ud(e,t),e.prototype.handler=function(t){var e=this.store,r=!1,n=t.type.toLowerCase().replace("ms",""),i=Wy[n],o=Gy[t.pointerType]||t.pointerType,a=o===sy,u=Yy(e,t.pointerId,"pointerId");i&ly&&(0===t.button||a)?u<0&&(e.push(t),u=e.length-1):i&(hy|py)&&(r=!0),u<0||(e[u]=t,this.callback(this.manager,i,{pointers:e,changedPointers:[t],pointerType:o,srcEvent:t}),r&&e.splice(u,1))},e}(qy);function Hy(t){return Array.prototype.slice.call(t,0)}function $y(t,e,r){for(var n=[],i=[],o=0;o<t.length;){var a=e?t[o][e]:t[o];Yy(i,a)<0&&n.push(t[o]),i[o]=a,o++}return r&&(n=e?n.sort((function(t,r){return t[e]>r[e]})):n.sort()),n}var Jy={touchstart:ly,touchmove:2,touchend:hy,touchcancel:py},Ky=function(t){function e(){var r;return e.prototype.evTarget="touchstart touchmove touchend touchcancel",(r=t.apply(this,arguments)||this).targetIds={},r}return Ud(e,t),e.prototype.handler=function(t){var e=Jy[t.type],r=Qy.call(this,t,e);r&&this.callback(this.manager,e,{pointers:r[0],changedPointers:r[1],pointerType:sy,srcEvent:t})},e}(qy);function Qy(t,e){var r,n,i=Hy(t.touches),o=this.targetIds;if(e&(2|ly)&&1===i.length)return o[i[0].identifier]=!0,[i,i];var a=Hy(t.changedTouches),u=[],s=this.target;if(n=i.filter((function(t){return jy(t.target,s)})),e===ly)for(r=0;r<n.length;)o[n[r].identifier]=!0,r++;for(r=0;r<a.length;)o[a[r].identifier]&&u.push(a[r]),e&(hy|py)&&delete o[a[r].identifier],r++;return u.length?[$y(n.concat(u),"identifier",!0),u]:void 0}var Zy={mousedown:ly,mousemove:2,mouseup:hy},tg=function(t){function e(){var r,n=e.prototype;return n.evEl="mousedown",n.evWin="mousemove mouseup",(r=t.apply(this,arguments)||this).pressed=!1,r}return Ud(e,t),e.prototype.handler=function(t){var e=Zy[t.type];e&ly&&0===t.button&&(this.pressed=!0),2&e&&1!==t.which&&(e=hy),this.pressed&&(e&hy&&(this.pressed=!1),this.callback(this.manager,e,{pointers:[t],changedPointers:[t],pointerType:cy,srcEvent:t}))},e}(qy),eg=2500;function rg(t){var e=t.changedPointers[0];if(e.identifier===this.primaryTouch){var r={x:e.clientX,y:e.clientY},n=this.lastTouches;this.lastTouches.push(r);setTimeout((function(){var t=n.indexOf(r);t>-1&&n.splice(t,1)}),eg)}}function ng(t,e){t&ly?(this.primaryTouch=e.changedPointers[0].identifier,rg.call(this,e)):t&(hy|py)&&rg.call(this,e)}function ig(t){for(var e=t.srcEvent.clientX,r=t.srcEvent.clientY,n=0;n<this.lastTouches.length;n++){var i=this.lastTouches[n],o=Math.abs(e-i.x),a=Math.abs(r-i.y);if(o<=25&&a<=25)return!0}return!1}var og=function(){return function(t){function e(e,r){var n;return(n=t.call(this,e,r)||this).handler=function(t,e,r){var i=r.pointerType===sy,o=r.pointerType===cy;if(!(o&&r.sourceCapabilities&&r.sourceCapabilities.firesTouchEvents)){if(i)ng.call(qd(qd(n)),e,r);else if(o&&ig.call(qd(qd(n)),r))return;n.callback(t,e,r)}},n.touch=new Ky(n.manager,n.handler),n.mouse=new tg(n.manager,n.handler),n.primaryTouch=null,n.lastTouches=[],n}return Ud(e,t),e.prototype.destroy=function(){this.touch.destroy(),this.mouse.destroy()},e}(qy)}();function ag(t,e,r){return!!Array.isArray(t)&&(Oy(t,r[e],r),!0)}var ug=32,sg=1;function cg(t,e){var r=e.manager;return r?r.get(t):t}function fg(t){return 16&t?"cancel":8&t?"end":4&t?"move":2&t?"start":""}var lg=function(){function t(t){void 0===t&&(t={}),this.options=zd({enable:!0},t),this.id=sg++,this.manager=null,this.state=1,this.simultaneous={},this.requireFail=[]}var e=t.prototype;return e.set=function(t){return Wd(this.options,t),this.manager&&this.manager.touchAction.update(),this},e.recognizeWith=function(t){if(ag(t,"recognizeWith",this))return this;var e=this.simultaneous;return e[(t=cg(t,this)).id]||(e[t.id]=t,t.recognizeWith(this)),this},e.dropRecognizeWith=function(t){return ag(t,"dropRecognizeWith",this)||(t=cg(t,this),delete this.simultaneous[t.id]),this},e.requireFailure=function(t){if(ag(t,"requireFailure",this))return this;var e=this.requireFail;return-1===Yy(e,t=cg(t,this))&&(e.push(t),t.requireFailure(this)),this},e.dropRequireFailure=function(t){if(ag(t,"dropRequireFailure",this))return this;t=cg(t,this);var e=Yy(this.requireFail,t);return e>-1&&this.requireFail.splice(e,1),this},e.hasRequireFailures=function(){return this.requireFail.length>0},e.canRecognizeWith=function(t){return!!this.simultaneous[t.id]},e.emit=function(t){var e=this,r=this.state;function n(r){e.manager.emit(r,t)}r<8&&n(e.options.event+fg(r)),n(e.options.event),t.additionalEvent&&n(t.additionalEvent),r>=8&&n(e.options.event+fg(r))},e.tryEmit=function(t){if(this.canEmit())return this.emit(t);this.state=ug},e.canEmit=function(){for(var t=0;t<this.requireFail.length;){if(!(33&this.requireFail[t].state))return!1;t++}return!0},e.recognize=function(t){var e=Wd({},t);if(!xy(this.options.enable,[this,e]))return this.reset(),void(this.state=ug);56&this.state&&(this.state=1),this.state=this.process(e),30&this.state&&this.tryEmit(e)},e.process=function(t){},e.getTouchAction=function(){},e.reset=function(){},t}(),hg=function(t){function e(e){var r;return void 0===e&&(e={}),(r=t.call(this,zd({event:"tap",pointers:1,taps:1,interval:300,time:250,threshold:9,posThreshold:10},e))||this).pTime=!1,r.pCenter=!1,r._timer=null,r._input=null,r.count=0,r}Ud(e,t);var r=e.prototype;return r.getTouchAction=function(){return[ty]},r.process=function(t){var e=this,r=this.options,n=t.pointers.length===r.pointers,i=t.distance<r.threshold,o=t.deltaTime<r.time;if(this.reset(),t.eventType&ly&&0===this.count)return this.failTimeout();if(i&&o&&n){if(t.eventType!==hy)return this.failTimeout();var a=!this.pTime||t.timeStamp-this.pTime<r.interval,u=!this.pCenter||Iy(this.pCenter,t.center)<r.posThreshold;if(this.pTime=t.timeStamp,this.pCenter=t.center,u&&a?this.count+=1:this.count=1,this._input=t,0===this.count%r.taps)return this.hasRequireFailures()?(this._timer=setTimeout((function(){e.state=8,e.tryEmit()}),r.interval),2):8}return ug},r.failTimeout=function(){var t=this;return this._timer=setTimeout((function(){t.state=ug}),this.options.interval),ug},r.reset=function(){clearTimeout(this._timer)},r.emit=function(){8===this.state&&(this._input.tapCount=this.count,this.manager.emit(this.options.event,this._input))},e}(lg),pg=function(t){function e(e){return void 0===e&&(e={}),t.call(this,zd({pointers:1},e))||this}Ud(e,t);var r=e.prototype;return r.attrTest=function(t){var e=this.options.pointers;return 0===e||t.pointers.length===e},r.process=function(t){var e=this.state,r=t.eventType,n=6&e,i=this.attrTest(t);return n&&(r&py||!i)?16|e:n||i?r&hy?8|e:2&e?4|e:2:ug},e}(lg);function vg(t){return t===my?"down":t===gy?"up":t===dy?"left":t===yy?"right":""}var dg=function(t){function e(e){var r;return void 0===e&&(e={}),(r=t.call(this,zd({event:"pan",threshold:10,pointers:1,direction:wy},e))||this).pX=null,r.pY=null,r}Ud(e,t);var r=e.prototype;return r.getTouchAction=function(){var t=this.options.direction,e=[];return t&by&&e.push(ny),t&_y&&e.push(ry),e},r.directionTest=function(t){var e=this.options,r=!0,n=t.distance,i=t.direction,o=t.deltaX,a=t.deltaY;return i&e.direction||(e.direction&by?(i=0===o?vy:o<0?dy:yy,r=o!==this.pX,n=Math.abs(t.deltaX)):(i=0===a?vy:a<0?gy:my,r=a!==this.pY,n=Math.abs(t.deltaY))),t.direction=i,r&&n>e.threshold&&i&e.direction},r.attrTest=function(t){return pg.prototype.attrTest.call(this,t)&&(2&this.state||!(2&this.state)&&this.directionTest(t))},r.emit=function(e){this.pX=e.deltaX,this.pY=e.deltaY;var r=vg(e.direction);r&&(e.additionalEvent=this.options.event+r),t.prototype.emit.call(this,e)},e}(pg),yg=function(t){function e(e){return void 0===e&&(e={}),t.call(this,zd({event:"swipe",threshold:10,velocity:.3,direction:by|_y,pointers:1},e))||this}Ud(e,t);var r=e.prototype;return r.getTouchAction=function(){return dg.prototype.getTouchAction.call(this)},r.attrTest=function(e){var r,n=this.options.direction;return n&(by|_y)?r=e.overallVelocity:n&by?r=e.overallVelocityX:n&_y&&(r=e.overallVelocityY),t.prototype.attrTest.call(this,e)&&n&e.offsetDirection&&e.distance>this.options.threshold&&e.maxPointers===this.options.pointers&&Bd(r)>this.options.velocity&&e.eventType&hy},r.emit=function(t){var e=vg(t.offsetDirection);e&&this.manager.emit(this.options.event+e,t),this.manager.emit(this.options.event,t)},e}(pg),gg=function(t){function e(e){return void 0===e&&(e={}),t.call(this,zd({event:"pinch",threshold:0,pointers:2},e))||this}Ud(e,t);var r=e.prototype;return r.getTouchAction=function(){return[ey]},r.attrTest=function(e){return t.prototype.attrTest.call(this,e)&&(Math.abs(e.scale-1)>this.options.threshold||2&this.state)},r.emit=function(e){if(1!==e.scale){var r=e.scale<1?"in":"out";e.additionalEvent=this.options.event+r}t.prototype.emit.call(this,e)},e}(pg),mg=function(t){function e(e){return void 0===e&&(e={}),t.call(this,zd({event:"rotate",threshold:0,pointers:2},e))||this}Ud(e,t);var r=e.prototype;return r.getTouchAction=function(){return[ey]},r.attrTest=function(e){return t.prototype.attrTest.call(this,e)&&(Math.abs(e.rotation)>this.options.threshold||2&this.state)},e}(pg),bg=function(t){function e(e){var r;return void 0===e&&(e={}),(r=t.call(this,zd({event:"press",pointers:1,time:251,threshold:9},e))||this)._timer=null,r._input=null,r}Ud(e,t);var r=e.prototype;return r.getTouchAction=function(){return[Zd]},r.process=function(t){var e=this,r=this.options,n=t.pointers.length===r.pointers,i=t.distance<r.threshold,o=t.deltaTime>r.time;if(this._input=t,!i||!n||t.eventType&(hy|py)&&!o)this.reset();else if(t.eventType&ly)this.reset(),this._timer=setTimeout((function(){e.state=8,e.tryEmit()}),r.time);else if(t.eventType&hy)return 8;return ug},r.reset=function(){clearTimeout(this._timer)},r.emit=function(t){8===this.state&&(t&&t.eventType&hy?this.manager.emit(this.options.event+"up",t):(this._input.timeStamp=Hd(),this.manager.emit(this.options.event,this._input)))},e}(lg),_g={domEvents:!1,touchAction:Qd,enable:!0,inputTarget:null,inputClass:null,cssProps:{userSelect:"none",touchSelect:"none",touchCallout:"none",contentZooming:"none",userDrag:"none",tapHighlightColor:"rgba(0,0,0,0)"}},wg=[[mg,{enable:!1}],[gg,{enable:!1},["rotate"]],[yg,{direction:by}],[dg,{direction:by},["swipe"]],[hg],[hg,{event:"doubletap",taps:2},["tap"]],[bg]];function Eg(t,e){var r,n=t.element;n.style&&(Oy(t.options.cssProps,(function(i,o){r=$d(n.style,o),e?(t.oldCssProps[r]=n.style[r],n.style[r]=i):n.style[r]=t.oldCssProps[r]||""})),e||(t.oldCssProps={}))}var Tg=function(){function t(t,e){var r,n=this;this.options=Wd({},_g,e||{}),this.options.inputTarget=this.options.inputTarget||t,this.handlers={},this.session={},this.recognizers=[],this.oldCssProps={},this.element=t,this.input=new((r=this).options.inputClass||(ay?By:uy?Ky:oy?og:tg))(r,My),this.touchAction=new Sy(this,this.options.touchAction),Eg(this,!0),Oy(this.options.recognizers,(function(t){var e=n.add(new t[0](t[1]));t[2]&&e.recognizeWith(t[2]),t[3]&&e.requireFailure(t[3])}),this)}var e=t.prototype;return e.set=function(t){return Wd(this.options,t),t.touchAction&&this.touchAction.update(),t.inputTarget&&(this.input.destroy(),this.input.target=t.inputTarget,this.input.init()),this},e.stop=function(t){this.session.stopped=t?2:1},e.recognize=function(t){var e=this.session;if(!e.stopped){var r;this.touchAction.preventDefaults(t);var n=this.recognizers,i=e.curRecognizer;(!i||i&&8&i.state)&&(e.curRecognizer=null,i=null);for(var o=0;o<n.length;)r=n[o],2===e.stopped||i&&r!==i&&!r.canRecognizeWith(i)?r.reset():r.recognize(t),!i&&14&r.state&&(e.curRecognizer=r,i=r),o++}},e.get=function(t){if(t instanceof lg)return t;for(var e=this.recognizers,r=0;r<e.length;r++)if(e[r].options.event===t)return e[r];return null},e.add=function(t){if(ag(t,"add",this))return this;var e=this.get(t.options.event);return e&&this.remove(e),this.recognizers.push(t),t.manager=this,this.touchAction.update(),t},e.remove=function(t){if(ag(t,"remove",this))return this;var e=this.get(t);if(t){var r=this.recognizers,n=Yy(r,e);-1!==n&&(r.splice(n,1),this.touchAction.update())}return this},e.on=function(t,e){if(void 0===t||void 0===e)return this;var r=this.handlers;return Oy(Ny(t),(function(t){r[t]=r[t]||[],r[t].push(e)})),this},e.off=function(t,e){if(void 0===t)return this;var r=this.handlers;return Oy(Ny(t),(function(t){e?r[t]&&r[t].splice(Yy(r[t],e),1):delete r[t]})),this},e.emit=function(t,e){this.options.domEvents&&function(t,e){var r=document.createEvent("Event");r.initEvent(t,!0,!0),r.gesture=e,e.target.dispatchEvent(r)}(t,e);var r=this.handlers[t]&&this.handlers[t].slice();if(r&&r.length){e.type=t,e.preventDefault=function(){e.srcEvent.preventDefault()};for(var n=0;n<r.length;)r[n](e),n++}},e.destroy=function(){this.element&&Eg(this,!1),this.handlers={},this.session={},this.input.destroy(),this.element=null},t}(),Og={touchstart:ly,touchmove:2,touchend:hy,touchcancel:py},xg=function(t){function e(){var r,n=e.prototype;return n.evTarget="touchstart",n.evWin="touchstart touchmove touchend touchcancel",(r=t.apply(this,arguments)||this).started=!1,r}return Ud(e,t),e.prototype.handler=function(t){var e=Og[t.type];if(e===ly&&(this.started=!0),this.started){var r=kg.call(this,t,e);e&(hy|py)&&r[0].length-r[1].length==0&&(this.started=!1),this.callback(this.manager,e,{pointers:r[0],changedPointers:r[1],pointerType:sy,srcEvent:t})}},e}(qy);function kg(t,e){var r=Hy(t.touches),n=Hy(t.changedTouches);return e&(hy|py)&&(r=$y(r.concat(n),"identifier",!0)),[r,n]}function Sg(t,e,r){var n="DEPRECATED METHOD: "+e+"\n"+r+" AT \n";return function(){var e=new Error("get-stack-trace"),r=e&&e.stack?e.stack.replace(/^[^\(]+?[\n$]/gm,"").replace(/^\s+at\s+/gm,"").replace(/^Object.<anonymous>\s*\(/gm,"{anonymous}()@"):"Unknown Stack Trace",i=window.console&&(window.console.warn||window.console.log);return i&&i.call(window.console,n,r),t.apply(this,arguments)}}var jg=Sg((function(t,e,r){for(var n=Object.keys(e),i=0;i<n.length;)(!r||r&&void 0===t[n[i]])&&(t[n[i]]=e[n[i]]),i++;return t}),"extend","Use `assign`."),Ag=Sg((function(t,e){return jg(t,e,!0)}),"merge","Use `assign`.");function Pg(t,e,r){var n,i=e.prototype;(n=t.prototype=Object.create(i)).constructor=t,n._super=i,r&&Wd(n,r)}function Ig(t,e){return function(){return t.apply(e,arguments)}}var Dg=function(){var t=function(t,e){return void 0===e&&(e={}),new Tg(t,zd({recognizers:wg.concat()},e))};return t.VERSION="2.0.17-rc",t.DIRECTION_ALL=wy,t.DIRECTION_DOWN=my,t.DIRECTION_LEFT=dy,t.DIRECTION_RIGHT=yy,t.DIRECTION_UP=gy,t.DIRECTION_HORIZONTAL=by,t.DIRECTION_VERTICAL=_y,t.DIRECTION_NONE=vy,t.DIRECTION_DOWN=my,t.INPUT_START=ly,t.INPUT_MOVE=2,t.INPUT_END=hy,t.INPUT_CANCEL=py,t.STATE_POSSIBLE=1,t.STATE_BEGAN=2,t.STATE_CHANGED=4,t.STATE_ENDED=8,t.STATE_RECOGNIZED=8,t.STATE_CANCELLED=16,t.STATE_FAILED=ug,t.Manager=Tg,t.Input=qy,t.TouchAction=Sy,t.TouchInput=Ky,t.MouseInput=tg,t.PointerEventInput=By,t.TouchMouseInput=og,t.SingleTouchInput=xg,t.Recognizer=lg,t.AttrRecognizer=pg,t.Tap=hg,t.Pan=dg,t.Swipe=yg,t.Pinch=gg,t.Rotate=mg,t.Press=bg,t.on=Fy,t.off=zy,t.each=Oy,t.merge=Ag,t.extend=jg,t.bindFn=Ig,t.assign=Wd,t.inherit=Pg,t.bindFn=Ig,t.prefixed=$d,t.toArray=Hy,t.inArray=Yy,t.uniqueArray=$y,t.splitStr=Ny,t.boolOrFn=xy,t.hasParent=jy,t.addEventListeners=Fy,t.removeEventListeners=zy,t.defaults=Wd({},_g,{preset:wg}),t}();function Lg(t,e){var r=void 0!==zp&&Rh(t)||t["@@iterator"];if(!r){if(Bp(t)||(r=function(t,e){var r;if(!t)return;if("string"==typeof t)return Cg(t,e);var n=Xp(r=Object.prototype.toString.call(t)).call(r,8,-1);"Object"===n&&t.constructor&&(n=t.constructor.name);if("Map"===n||"Set"===n)return Ch(t);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return Cg(t,e)}(t))||e&&t&&"number"==typeof t.length){r&&(t=r);var n=0,i=function(){};return{s:i,n:function(){return n>=t.length?{done:!0}:{done:!1,value:t[n++]}},e:function(t){throw t},f:i}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var o,a=!0,u=!1;return{s:function(){r=r.call(t)},n:function(){var t=r.next();return a=t.done,t},e:function(t){u=!0,o=t},f:function(){try{a||null==r.return||r.return()}finally{if(u)throw o}}}}function Cg(t,e){(null==e||e>t.length)&&(e=t.length);for(var r=0,n=new Array(e);r<e;r++)n[r]=t[r];return n}var Rg=zp("DELETE");function Mg(){var t=Ng.apply(void 0,arguments);return zg(t),t}function Ng(){for(var t=arguments.length,e=new Array(t),r=0;r<t;r++)e[r]=arguments[r];if(e.length<2)return e[0];var n;if(e.length>2)return Ng.apply(void 0,Gp(n=[Mg(e[0],e[1])]).call(n,Fp(Xp(e).call(e,2))));var i,o=e[0],a=e[1],u=Lg(Vp(a));try{for(u.s();!(i=u.n()).done;){var s=i.value;Object.prototype.propertyIsEnumerable.call(a,s)&&(a[s]===Rg?delete o[s]:null===o[s]||null===a[s]||"object"!==Pf(o[s])||"object"!==Pf(a[s])||Bp(o[s])||Bp(a[s])?o[s]=Fg(a[s]):o[s]=Ng(o[s],a[s]))}}catch(t){u.e(t)}finally{u.f()}return o}function Fg(t){return Bp(t)?Al(t).call(t,(function(t){return Fg(t)})):"object"===Pf(t)&&null!==t?Ng({},t):t}function zg(t){for(var e=0,r=Jp(t);e<r.length;e++){var n=r[e];t[n]===Rg?delete t[n]:"object"===Pf(t[n])&&null!==t[n]&&zg(t[n])}}var Ug="undefined"!=typeof window?window.Hammer||Dg:function(){return function(){var t=function(){};return{on:t,off:t,destroy:t,emit:t,get:function(){return{set:t}}}}()};function qg(t){var e,r=this;this._cleanupQueue=[],this.active=!1,this._dom={container:t,overlay:document.createElement("div")},this._dom.overlay.classList.add("vis-overlay"),this._dom.container.appendChild(this._dom.overlay),this._cleanupQueue.push((function(){r._dom.overlay.parentNode.removeChild(r._dom.overlay)}));var n=Ug(this._dom.overlay);n.on("tap",el(e=this._onTapOverlay).call(e,this)),this._cleanupQueue.push((function(){n.destroy()}));var i=["tap","doubletap","press","pinch","pan","panstart","panmove","panend"];uv(i).call(i,(function(t){n.on(t,(function(t){t.srcEvent.stopPropagation()}))})),document&&document.body&&(this._onClick=function(e){(function(t,e){for(;t;){if(t===e)return!0;t=t.parentNode}return!1})(e.target,t)||r.deactivate()},document.body.addEventListener("click",this._onClick),this._cleanupQueue.push((function(){document.body.removeEventListener("click",r._onClick)}))),this._escListener=function(t){("key"in t?"Escape"===t.key:27===t.keyCode)&&r.deactivate()}}Fd(qg.prototype),qg.current=null,qg.prototype.destroy=function(){var t,e;this.deactivate();var r,n=Lg(gv(t=Wv(e=this._cleanupQueue).call(e,0)).call(t));try{for(n.s();!(r=n.n()).done;){(0,r.value)()}}catch(t){n.e(t)}finally{n.f()}},qg.prototype.activate=function(){qg.current&&qg.current.deactivate(),qg.current=this,this.active=!0,this._dom.overlay.style.display="none",this._dom.container.classList.add("vis-active"),this.emit("change"),this.emit("activate"),document.body.addEventListener("keydown",this._escListener)},qg.prototype.deactivate=function(){this.active=!1,this._dom.overlay.style.display="block",this._dom.container.classList.remove("vis-active"),document.body.removeEventListener("keydown",this._escListener),this.emit("change"),this.emit("deactivate")},qg.prototype._onTapOverlay=function(t){this.activate(),t.srcEvent.stopPropagation()};var Yg=Sn,Wg=jt,Gg=TypeError,Xg=function(t){if(Yg(t))return t;throw Gg(Wg(t)+" is not a constructor")},Vg=Ar,Bg=p,Hg=Vf,$g=Xg,Jg=nr,Kg=rt,Qg=Bi,Zg=u,tm=st("Reflect","construct"),em=Object.prototype,rm=[].push,nm=Zg((function(){function t(){}return!(tm((function(){}),[],t)instanceof t)})),im=!Zg((function(){tm((function(){}))})),om=nm||im;Vg({target:"Reflect",stat:!0,forced:om,sham:om},{construct:function(t,e){$g(t),Jg(e);var r=arguments.length<3?t:$g(arguments[2]);if(im&&!nm)return tm(t,e,r);if(t==r){switch(e.length){case 0:return new t;case 1:return new t(e[0]);case 2:return new t(e[0],e[1]);case 3:return new t(e[0],e[1],e[2]);case 4:return new t(e[0],e[1],e[2],e[3])}var n=[null];return Bg(rm,n,e),new(Bg(Hg,t,n))}var i=r.prototype,o=Qg(Kg(i)?i:em),a=Bg(t,o,e);return Kg(a)?a:o}});var am=n(nt.Reflect.construct);function um(t){if(void 0===t)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return t}var sm=fd,cm=n(sm);Ar({target:"Object",stat:!0},{setPrototypeOf:ic});var fm=nt.Object.setPrototypeOf,lm=n(fm),hm=n(tl);function pm(t,e){var r;return pm=lm?hm(r=lm).call(r):function(t,e){return t.__proto__=e,t},pm(t,e)}function vm(t,e){if("function"!=typeof e&&null!==e)throw new TypeError("Super expression must either be null or a function");t.prototype=cm(e&&e.prototype,{constructor:{value:t,writable:!0,configurable:!0}}),Nr(t,"prototype",{writable:!1}),e&&pm(t,e)}function dm(t,e){if(e&&("object"===Pf(e)||"function"==typeof e))return e;if(void 0!==e)throw new TypeError("Derived constructors may only return object or undefined");return um(t)}var ym=sd,gm=n(ym);function mm(t){var e;return mm=lm?hm(e=gm).call(e):function(t){return t.__proto__||gm(t)},mm(t)}var bm={exports:{}},_m={exports:{}};!function(t){var e=cf,r=jf;function n(i){return t.exports=n="function"==typeof e&&"symbol"==typeof r?function(t){return typeof t}:function(t){return t&&"function"==typeof e&&t.constructor===e&&t!==e.prototype?"symbol":typeof t},t.exports.__esModule=!0,t.exports.default=t.exports,n(i)}t.exports=n,t.exports.__esModule=!0,t.exports.default=t.exports}(_m);var wm=_m.exports,Em=av,Tm=Zt,Om=Kh,xm=P,km=Qe,Sm=rt,jm=gr,Am=Error,Pm=m("".replace),Im=String(Am("zxcasd").stack),Dm=/\n\s*at [^:]*:[^\n]*/,Lm=Dm.test(Im),Cm=q,Rm=!u((function(){var t=Error("a");return!("stack"in t)||(Object.defineProperty(t,"stack",Cm(1,7)),7!==t.stack)})),Mm=gr,Nm=function(t,e){if(Lm&&"string"==typeof t&&!Am.prepareStackTrace)for(;e--;)t=Pm(t,Dm,"");return t},Fm=Rm,zm=Error.captureStackTrace,Um=Ke,qm=C,Ym=nr,Wm=jt,Gm=rh,Xm=Br,Vm=ct,Bm=dh,Hm=sh,$m=Jl,Jm=TypeError,Km=function(t,e){this.stopped=t,this.result=e},Qm=Km.prototype,Zm=function(t,e,r){var n,i,o,a,u,s,c,f=r&&r.that,l=!(!r||!r.AS_ENTRIES),h=!(!r||!r.IS_RECORD),p=!(!r||!r.IS_ITERATOR),v=!(!r||!r.INTERRUPTED),d=Um(e,f),y=function(t){return n&&$m(n,"normal",t),new Km(!0,t)},g=function(t){return l?(Ym(t),v?d(t[0],t[1],y):d(t[0],t[1])):v?d(t,y):d(t)};if(h)n=t.iterator;else if(p)n=t;else{if(!(i=Hm(t)))throw Jm(Wm(t)+" is not iterable");if(Gm(i)){for(o=0,a=Xm(t);a>o;o++)if((u=g(t[o]))&&Vm(Qm,u))return u;return new Km(!1)}n=Bm(t,i)}for(s=h?t.next:n.next;!(c=qm(s,n)).done;){try{u=g(c.value)}catch(t){$m(n,"throw",t)}if("object"==typeof u&&u&&Vm(Qm,u))return u}return new Km(!1)},tb=ei,eb=Ar,rb=ct,nb=Ls,ib=ic,ob=function(t,e,r){for(var n=Om(e),i=km.f,o=xm.f,a=0;a<n.length;a++){var u=n[a];Tm(t,u)||r&&Tm(r,u)||i(t,u,o(e,u))}},ab=Bi,ub=gr,sb=q,cb=function(t,e){Sm(e)&&"cause"in e&&jm(t,"cause",e.cause)},fb=function(t,e,r,n){Fm&&(zm?zm(t,e):Mm(t,"stack",Nm(r,n)))},lb=Zm,hb=function(t,e){return void 0===t?arguments.length<2?"":e:tb(t)},pb=pe("toStringTag"),vb=Error,db=[].push,yb=function(t,e){var r,n=rb(gb,this);ib?r=ib(vb(),n?nb(this):gb):(r=n?this:ab(gb),ub(r,pb,"Error")),void 0!==e&&ub(r,"message",hb(e)),fb(r,yb,r.stack,1),arguments.length>2&&cb(r,arguments[2]);var i=[];return lb(t,db,{that:i}),ub(r,"errors",i),r};ib?ib(yb,vb):ob(yb,vb,{name:!0});var gb=yb.prototype=ab(vb.prototype,{constructor:sb(1,yb),message:sb(1,""),name:sb(1,"AggregateError")});eb({global:!0,constructor:!0,arity:2},{AggregateError:yb});var mb,bb,_b,wb,Eb=st,Tb=po,Ob=I,xb=pe("species"),kb=function(t){var e=Eb(t);Ob&&e&&!e[xb]&&Tb(e,xb,{configurable:!0,get:function(){return this}})},Sb=ct,jb=TypeError,Ab=function(t,e){if(Sb(e,t))return t;throw jb("Incorrect invocation")},Pb=nr,Ib=Xg,Db=B,Lb=pe("species"),Cb=function(t,e){var r,n=Pb(t).constructor;return void 0===n||Db(r=Pb(n)[Lb])?e:Ib(r)},Rb=/(?:ipad|iphone|ipod).*applewebkit/i.test(ft),Mb=a,Nb=p,Fb=Ke,zb=A,Ub=Zt,qb=u,Yb=Pi,Wb=Du,Gb=Se,Xb=md,Vb=Rb,Bb=ll,Hb=Mb.setImmediate,$b=Mb.clearImmediate,Jb=Mb.process,Kb=Mb.Dispatch,Qb=Mb.Function,Zb=Mb.MessageChannel,t_=Mb.String,e_=0,r_={},n_="onreadystatechange";qb((function(){mb=Mb.location}));var i_=function(t){if(Ub(r_,t)){var e=r_[t];delete r_[t],e()}},o_=function(t){return function(){i_(t)}},a_=function(t){i_(t.data)},u_=function(t){Mb.postMessage(t_(t),mb.protocol+"//"+mb.host)};Hb&&$b||(Hb=function(t){Xb(arguments.length,1);var e=zb(t)?t:Qb(t),r=Wb(arguments,1);return r_[++e_]=function(){Nb(e,void 0,r)},bb(e_),e_},$b=function(t){delete r_[t]},Bb?bb=function(t){Jb.nextTick(o_(t))}:Kb&&Kb.now?bb=function(t){Kb.now(o_(t))}:Zb&&!Vb?(wb=(_b=new Zb).port2,_b.port1.onmessage=a_,bb=Fb(wb.postMessage,wb)):Mb.addEventListener&&zb(Mb.postMessage)&&!Mb.importScripts&&mb&&"file:"!==mb.protocol&&!qb(u_)?(bb=u_,Mb.addEventListener("message",a_,!1)):bb=n_ in Gb("script")?function(t){Yb.appendChild(Gb("script"))[n_]=function(){Yb.removeChild(this),i_(t)}}:function(t){setTimeout(o_(t),0)});var s_={set:Hb,clear:$b},c_=function(){this.head=null,this.tail=null};c_.prototype={add:function(t){var e={item:t,next:null},r=this.tail;r?r.next=e:this.head=e,this.tail=e},get:function(){var t=this.head;if(t)return null===(this.head=t.next)&&(this.tail=null),t.item}};var f_,l_,h_,p_,v_,d_=c_,y_=/ipad|iphone|ipod/i.test(ft)&&"undefined"!=typeof Pebble,g_=/web0s(?!.*chrome)/i.test(ft),m_=a,b_=Ke,__=P.f,w_=s_.set,E_=d_,T_=Rb,O_=y_,x_=g_,k_=ll,S_=m_.MutationObserver||m_.WebKitMutationObserver,j_=m_.document,A_=m_.process,P_=m_.Promise,I_=__(m_,"queueMicrotask"),D_=I_&&I_.value;if(!D_){var L_=new E_,C_=function(){var t,e;for(k_&&(t=A_.domain)&&t.exit();e=L_.get();)try{e()}catch(t){throw L_.head&&f_(),t}t&&t.enter()};T_||k_||x_||!S_||!j_?!O_&&P_&&P_.resolve?((p_=P_.resolve(void 0)).constructor=P_,v_=b_(p_.then,p_),f_=function(){v_(C_)}):k_?f_=function(){A_.nextTick(C_)}:(w_=b_(w_,m_),f_=function(){w_(C_)}):(l_=!0,h_=j_.createTextNode(""),new S_(C_).observe(h_,{characterData:!0}),f_=function(){h_.data=l_=!l_}),D_=function(t){L_.head||f_(),L_.add(t)}}var R_=D_,M_=function(t){try{return{error:!1,value:t()}}catch(t){return{error:!0,value:t}}},N_=a.Promise,F_="object"==typeof Deno&&Deno&&"object"==typeof Deno.version,z_=!F_&&!ll&&"object"==typeof window&&"object"==typeof document,U_=a,q_=N_,Y_=A,W_=Be,G_=pn,X_=pe,V_=z_,B_=F_,H_=gt,$_=q_&&q_.prototype,J_=X_("species"),K_=!1,Q_=Y_(U_.PromiseRejectionEvent),Z_=W_("Promise",(function(){var t=G_(q_),e=t!==String(q_);if(!e&&66===H_)return!0;if(!$_.catch||!$_.finally)return!0;if(!H_||H_<51||!/native code/.test(t)){var r=new q_((function(t){t(1)})),n=function(t){t((function(){}),(function(){}))};if((r.constructor={})[J_]=n,!(K_=r.then((function(){}))instanceof n))return!0}return!e&&(V_||B_)&&!Q_})),tw={CONSTRUCTOR:Z_,REJECTION_EVENT:Q_,SUBCLASSING:K_},ew={},rw=Dt,nw=TypeError,iw=function(t){var e,r;this.promise=new t((function(t,n){if(void 0!==e||void 0!==r)throw nw("Bad Promise constructor");e=t,r=n})),this.resolve=rw(e),this.reject=rw(r)};ew.f=function(t){return new iw(t)};var ow,aw,uw=Ar,sw=ll,cw=a,fw=C,lw=lo,hw=Fo,pw=kb,vw=Dt,dw=A,yw=rt,gw=Ab,mw=Cb,bw=s_.set,_w=R_,ww=function(t,e){try{1==arguments.length?console.error(t):console.error(t,e)}catch(t){}},Ew=M_,Tw=d_,Ow=ta,xw=N_,kw=tw,Sw=ew,jw="Promise",Aw=kw.CONSTRUCTOR,Pw=kw.REJECTION_EVENT,Iw=Ow.getterFor(jw),Dw=Ow.set,Lw=xw&&xw.prototype,Cw=xw,Rw=Lw,Mw=cw.TypeError,Nw=cw.document,Fw=cw.process,zw=Sw.f,Uw=zw,qw=!!(Nw&&Nw.createEvent&&cw.dispatchEvent),Yw="unhandledrejection",Ww=function(t){var e;return!(!yw(t)||!dw(e=t.then))&&e},Gw=function(t,e){var r,n,i,o=e.value,a=1==e.state,u=a?t.ok:t.fail,s=t.resolve,c=t.reject,f=t.domain;try{u?(a||(2===e.rejection&&$w(e),e.rejection=1),!0===u?r=o:(f&&f.enter(),r=u(o),f&&(f.exit(),i=!0)),r===t.promise?c(Mw("Promise-chain cycle")):(n=Ww(r))?fw(n,r,s,c):s(r)):c(o)}catch(t){f&&!i&&f.exit(),c(t)}},Xw=function(t,e){t.notified||(t.notified=!0,_w((function(){for(var r,n=t.reactions;r=n.get();)Gw(r,t);t.notified=!1,e&&!t.rejection&&Bw(t)})))},Vw=function(t,e,r){var n,i;qw?((n=Nw.createEvent("Event")).promise=e,n.reason=r,n.initEvent(t,!1,!0),cw.dispatchEvent(n)):n={promise:e,reason:r},!Pw&&(i=cw["on"+t])?i(n):t===Yw&&ww("Unhandled promise rejection",r)},Bw=function(t){fw(bw,cw,(function(){var e,r=t.facade,n=t.value;if(Hw(t)&&(e=Ew((function(){sw?Fw.emit("unhandledRejection",n,r):Vw(Yw,r,n)})),t.rejection=sw||Hw(t)?2:1,e.error))throw e.value}))},Hw=function(t){return 1!==t.rejection&&!t.parent},$w=function(t){fw(bw,cw,(function(){var e=t.facade;sw?Fw.emit("rejectionHandled",e):Vw("rejectionhandled",e,t.value)}))},Jw=function(t,e,r){return function(n){t(e,n,r)}},Kw=function(t,e,r){t.done||(t.done=!0,r&&(t=r),t.value=e,t.state=2,Xw(t,!0))},Qw=function(t,e,r){if(!t.done){t.done=!0,r&&(t=r);try{if(t.facade===e)throw Mw("Promise can't be resolved itself");var n=Ww(e);n?_w((function(){var r={done:!1};try{fw(n,e,Jw(Qw,r,t),Jw(Kw,r,t))}catch(e){Kw(r,e,t)}})):(t.value=e,t.state=1,Xw(t,!1))}catch(e){Kw({done:!1},e,t)}}};Aw&&(Rw=(Cw=function(t){gw(this,Rw),vw(t),fw(ow,this);var e=Iw(this);try{t(Jw(Qw,e),Jw(Kw,e))}catch(t){Kw(e,t)}}).prototype,(ow=function(t){Dw(this,{type:jw,done:!1,notified:!1,parent:!1,reactions:new Tw,rejection:!1,state:0,value:void 0})}).prototype=lw(Rw,"then",(function(t,e){var r=Iw(this),n=zw(mw(this,Cw));return r.parent=!0,n.ok=!dw(t)||t,n.fail=dw(e)&&e,n.domain=sw?Fw.domain:void 0,0==r.state?r.reactions.add(n):_w((function(){Gw(n,r)})),n.promise})),aw=function(){var t=new ow,e=Iw(t);this.promise=t,this.resolve=Jw(Qw,e),this.reject=Jw(Kw,e)},Sw.f=zw=function(t){return t===Cw||undefined===t?new aw(t):Uw(t)}),uw({global:!0,constructor:!0,wrap:!0,forced:Aw},{Promise:Cw}),hw(Cw,jw,!1,!0),pw(jw);var Zw=N_,tE=tw.CONSTRUCTOR||!Ih((function(t){Zw.all(t).then(void 0,(function(){}))})),eE=C,rE=Dt,nE=ew,iE=M_,oE=Zm;Ar({target:"Promise",stat:!0,forced:tE},{all:function(t){var e=this,r=nE.f(e),n=r.resolve,i=r.reject,o=iE((function(){var r=rE(e.resolve),o=[],a=0,u=1;oE(t,(function(t){var s=a++,c=!1;u++,eE(r,e,t).then((function(t){c||(c=!0,o[s]=t,--u||n(o))}),i)})),--u||n(o)}));return o.error&&i(o.value),r.promise}});var aE=Ar,uE=tw.CONSTRUCTOR;N_&&N_.prototype,aE({target:"Promise",proto:!0,forced:uE,real:!0},{catch:function(t){return this.then(void 0,t)}});var sE=C,cE=Dt,fE=ew,lE=M_,hE=Zm;Ar({target:"Promise",stat:!0,forced:tE},{race:function(t){var e=this,r=fE.f(e),n=r.reject,i=lE((function(){var i=cE(e.resolve);hE(t,(function(t){sE(i,e,t).then(r.resolve,n)}))}));return i.error&&n(i.value),r.promise}});var pE=C,vE=ew;Ar({target:"Promise",stat:!0,forced:tw.CONSTRUCTOR},{reject:function(t){var e=vE.f(this);return pE(e.reject,void 0,t),e.promise}});var dE=nr,yE=rt,gE=ew,mE=function(t,e){if(dE(t),yE(e)&&e.constructor===t)return e;var r=gE.f(t);return(0,r.resolve)(e),r.promise},bE=Ar,_E=N_,wE=tw.CONSTRUCTOR,EE=mE,TE=st("Promise"),OE=!wE;bE({target:"Promise",stat:!0,forced:true},{resolve:function(t){return EE(OE&&this===TE?_E:this,t)}});var xE=C,kE=Dt,SE=ew,jE=M_,AE=Zm;Ar({target:"Promise",stat:!0,forced:tE},{allSettled:function(t){var e=this,r=SE.f(e),n=r.resolve,i=r.reject,o=jE((function(){var r=kE(e.resolve),i=[],o=0,a=1;AE(t,(function(t){var u=o++,s=!1;a++,xE(r,e,t).then((function(t){s||(s=!0,i[u]={status:"fulfilled",value:t},--a||n(i))}),(function(t){s||(s=!0,i[u]={status:"rejected",reason:t},--a||n(i))}))})),--a||n(i)}));return o.error&&i(o.value),r.promise}});var PE=C,IE=Dt,DE=st,LE=ew,CE=M_,RE=Zm,ME="No one promise resolved";Ar({target:"Promise",stat:!0,forced:tE},{any:function(t){var e=this,r=DE("AggregateError"),n=LE.f(e),i=n.resolve,o=n.reject,a=CE((function(){var n=IE(e.resolve),a=[],u=0,s=1,c=!1;RE(t,(function(t){var f=u++,l=!1;s++,PE(n,e,t).then((function(t){l||c||(c=!0,i(t))}),(function(t){l||c||(l=!0,a[f]=t,--s||o(new r(a,ME)))}))})),--s||o(new r(a,ME))}));return a.error&&o(a.value),n.promise}});var NE=Ar,FE=N_,zE=u,UE=st,qE=A,YE=Cb,WE=mE,GE=FE&&FE.prototype;NE({target:"Promise",proto:!0,real:!0,forced:!!FE&&zE((function(){GE.finally.call({then:function(){}},(function(){}))}))},{finally:function(t){var e=YE(this,UE("Promise")),r=qE(t);return this.then(r?function(r){return WE(e,t()).then((function(){return r}))}:t,r?function(r){return WE(e,t()).then((function(){throw r}))}:t)}});var XE=nt.Promise,VE=ew,BE=M_;Ar({target:"Promise",stat:!0,forced:!0},{try:function(t){var e=VE.f(this),r=BE(t);return(r.error?e.reject:e.resolve)(r.value),e.promise}});var HE=XE,$E=yv;!function(t){var e=wm.default,r=Mr,n=cf,i=sm,o=ym,a=Em,u=fm,s=HE,c=$E,f=Dp;function l(){t.exports=l=function(){return h},t.exports.__esModule=!0,t.exports.default=t.exports;var h={},p=Object.prototype,v=p.hasOwnProperty,d=r||function(t,e,r){t[e]=r.value},y="function"==typeof n?n:{},g=y.iterator||"@@iterator",m=y.asyncIterator||"@@asyncIterator",b=y.toStringTag||"@@toStringTag";function _(t,e,n){return r(t,e,{value:n,enumerable:!0,configurable:!0,writable:!0}),t[e]}try{_({},"")}catch(t){_=function(t,e,r){return t[e]=r}}function w(t,e,r,n){var o=e&&e.prototype instanceof O?e:O,a=i(o.prototype),u=new M(n||[]);return d(a,"_invoke",{value:D(t,r,u)}),a}function E(t,e,r){try{return{type:"normal",arg:t.call(e,r)}}catch(t){return{type:"throw",arg:t}}}h.wrap=w;var T={};function O(){}function x(){}function k(){}var S={};_(S,g,(function(){return this}));var j=o&&o(o(N([])));j&&j!==p&&v.call(j,g)&&(S=j);var A=k.prototype=O.prototype=i(S);function P(t){var e;a(e=["next","throw","return"]).call(e,(function(e){_(t,e,(function(t){return this._invoke(e,t)}))}))}function I(t,r){function n(i,o,a,u){var s=E(t[i],t,o);if("throw"!==s.type){var c=s.arg,f=c.value;return f&&"object"==e(f)&&v.call(f,"__await")?r.resolve(f.__await).then((function(t){n("next",t,a,u)}),(function(t){n("throw",t,a,u)})):r.resolve(f).then((function(t){c.value=t,a(c)}),(function(t){return n("throw",t,a,u)}))}u(s.arg)}var i;d(this,"_invoke",{value:function(t,e){function o(){return new r((function(r,i){n(t,e,r,i)}))}return i=i?i.then(o,o):o()}})}function D(t,e,r){var n="suspendedStart";return function(i,o){if("executing"===n)throw new Error("Generator is already running");if("completed"===n){if("throw"===i)throw o;return F()}for(r.method=i,r.arg=o;;){var a=r.delegate;if(a){var u=L(a,r);if(u){if(u===T)continue;return u}}if("next"===r.method)r.sent=r._sent=r.arg;else if("throw"===r.method){if("suspendedStart"===n)throw n="completed",r.arg;r.dispatchException(r.arg)}else"return"===r.method&&r.abrupt("return",r.arg);n="executing";var s=E(t,e,r);if("normal"===s.type){if(n=r.done?"completed":"suspendedYield",s.arg===T)continue;return{value:s.arg,done:r.done}}"throw"===s.type&&(n="completed",r.method="throw",r.arg=s.arg)}}}function L(t,e){var r=e.method,n=t.iterator[r];if(void 0===n)return e.delegate=null,"throw"===r&&t.iterator.return&&(e.method="return",e.arg=void 0,L(t,e),"throw"===e.method)||"return"!==r&&(e.method="throw",e.arg=new TypeError("The iterator does not provide a '"+r+"' method")),T;var i=E(n,t.iterator,e.arg);if("throw"===i.type)return e.method="throw",e.arg=i.arg,e.delegate=null,T;var o=i.arg;return o?o.done?(e[t.resultName]=o.value,e.next=t.nextLoc,"return"!==e.method&&(e.method="next",e.arg=void 0),e.delegate=null,T):o:(e.method="throw",e.arg=new TypeError("iterator result is not an object"),e.delegate=null,T)}function C(t){var e={tryLoc:t[0]};1 in t&&(e.catchLoc=t[1]),2 in t&&(e.finallyLoc=t[2],e.afterLoc=t[3]),this.tryEntries.push(e)}function R(t){var e=t.completion||{};e.type="normal",delete e.arg,t.completion=e}function M(t){this.tryEntries=[{tryLoc:"root"}],a(t).call(t,C,this),this.reset(!0)}function N(t){if(t){var e=t[g];if(e)return e.call(t);if("function"==typeof t.next)return t;if(!isNaN(t.length)){var r=-1,n=function e(){for(;++r<t.length;)if(v.call(t,r))return e.value=t[r],e.done=!1,e;return e.value=void 0,e.done=!0,e};return n.next=n}}return{next:F}}function F(){return{value:void 0,done:!0}}return x.prototype=k,d(A,"constructor",{value:k,configurable:!0}),d(k,"constructor",{value:x,configurable:!0}),x.displayName=_(k,b,"GeneratorFunction"),h.isGeneratorFunction=function(t){var e="function"==typeof t&&t.constructor;return!!e&&(e===x||"GeneratorFunction"===(e.displayName||e.name))},h.mark=function(t){return u?u(t,k):(t.__proto__=k,_(t,b,"GeneratorFunction")),t.prototype=i(A),t},h.awrap=function(t){return{__await:t}},P(I.prototype),_(I.prototype,m,(function(){return this})),h.AsyncIterator=I,h.async=function(t,e,r,n,i){void 0===i&&(i=s);var o=new I(w(t,e,r,n),i);return h.isGeneratorFunction(e)?o:o.next().then((function(t){return t.done?t.value:o.next()}))},P(A),_(A,b,"Generator"),_(A,g,(function(){return this})),_(A,"toString",(function(){return"[object Generator]"})),h.keys=function(t){var e=Object(t),r=[];for(var n in e)r.push(n);return c(r).call(r),function t(){for(;r.length;){var n=r.pop();if(n in e)return t.value=n,t.done=!1,t}return t.done=!0,t}},h.values=N,M.prototype={constructor:M,reset:function(t){var e;if(this.prev=0,this.next=0,this.sent=this._sent=void 0,this.done=!1,this.delegate=null,this.method="next",this.arg=void 0,a(e=this.tryEntries).call(e,R),!t)for(var r in this)"t"===r.charAt(0)&&v.call(this,r)&&!isNaN(+f(r).call(r,1))&&(this[r]=void 0)},stop:function(){this.done=!0;var t=this.tryEntries[0].completion;if("throw"===t.type)throw t.arg;return this.rval},dispatchException:function(t){if(this.done)throw t;var e=this;function r(r,n){return o.type="throw",o.arg=t,e.next=r,n&&(e.method="next",e.arg=void 0),!!n}for(var n=this.tryEntries.length-1;n>=0;--n){var i=this.tryEntries[n],o=i.completion;if("root"===i.tryLoc)return r("end");if(i.tryLoc<=this.prev){var a=v.call(i,"catchLoc"),u=v.call(i,"finallyLoc");if(a&&u){if(this.prev<i.catchLoc)return r(i.catchLoc,!0);if(this.prev<i.finallyLoc)return r(i.finallyLoc)}else if(a){if(this.prev<i.catchLoc)return r(i.catchLoc,!0)}else{if(!u)throw new Error("try statement without catch or finally");if(this.prev<i.finallyLoc)return r(i.finallyLoc)}}}},abrupt:function(t,e){for(var r=this.tryEntries.length-1;r>=0;--r){var n=this.tryEntries[r];if(n.tryLoc<=this.prev&&v.call(n,"finallyLoc")&&this.prev<n.finallyLoc){var i=n;break}}i&&("break"===t||"continue"===t)&&i.tryLoc<=e&&e<=i.finallyLoc&&(i=null);var o=i?i.completion:{};return o.type=t,o.arg=e,i?(this.method="next",this.next=i.finallyLoc,T):this.complete(o)},complete:function(t,e){if("throw"===t.type)throw t.arg;return"break"===t.type||"continue"===t.type?this.next=t.arg:"return"===t.type?(this.rval=this.arg=t.arg,this.method="return",this.next="end"):"normal"===t.type&&e&&(this.next=e),T},finish:function(t){for(var e=this.tryEntries.length-1;e>=0;--e){var r=this.tryEntries[e];if(r.finallyLoc===t)return this.complete(r.completion,r.afterLoc),R(r),T}},catch:function(t){for(var e=this.tryEntries.length-1;e>=0;--e){var r=this.tryEntries[e];if(r.tryLoc===t){var n=r.completion;if("throw"===n.type){var i=n.arg;R(r)}return i}}throw new Error("illegal catch attempt")},delegateYield:function(t,e,r){return this.delegate={iterator:N(t),resultName:e,nextLoc:r},"next"===this.method&&(this.arg=void 0),T}},h}t.exports=l,t.exports.__esModule=!0,t.exports.default=t.exports}(bm);var JE=(0,bm.exports)(),KE=JE;try{regeneratorRuntime=JE}catch(t){"object"==typeof globalThis?globalThis.regeneratorRuntime=JE:Function("r","regeneratorRuntime = r")(JE)}var QE=n(KE),ZE={exports:{}},tT=u((function(){if("function"==typeof ArrayBuffer){var t=new ArrayBuffer(8);Object.isExtensible(t)&&Object.defineProperty(t,"a",{value:8})}})),eT=u,rT=rt,nT=E,iT=tT,oT=Object.isExtensible,aT=eT((function(){oT(1)}))||iT?function(t){return!!rT(t)&&((!iT||"ArrayBuffer"!=nT(t))&&(!oT||oT(t)))}:oT,uT=!u((function(){return Object.isExtensible(Object.preventExtensions({}))})),sT=Ar,cT=m,fT=hi,lT=rt,hT=Zt,pT=Qe.f,vT=Hi,dT=Ki,yT=aT,gT=uT,mT=!1,bT=ie("meta"),_T=0,wT=function(t){pT(t,bT,{value:{objectID:"O"+_T++,weakData:{}}})},ET=ZE.exports={enable:function(){ET.enable=function(){},mT=!0;var t=vT.f,e=cT([].splice),r={};r[bT]=1,t(r).length&&(vT.f=function(r){for(var n=t(r),i=0,o=n.length;i<o;i++)if(n[i]===bT){e(n,i,1);break}return n},sT({target:"Object",stat:!0,forced:!0},{getOwnPropertyNames:dT.f}))},fastKey:function(t,e){if(!lT(t))return"symbol"==typeof t?t:("string"==typeof t?"S":"P")+t;if(!hT(t,bT)){if(!yT(t))return"F";if(!e)return"E";wT(t)}return t[bT].objectID},getWeakData:function(t,e){if(!hT(t,bT)){if(!yT(t))return!0;if(!e)return!1;wT(t)}return t[bT].weakData},onFreeze:function(t){return gT&&mT&&yT(t)&&!hT(t,bT)&&wT(t),t}};fT[bT]=!0;var TT=ZE.exports,OT=Ar,xT=a,kT=TT,ST=u,jT=gr,AT=Zm,PT=Ab,IT=A,DT=rt,LT=Fo,CT=Qe.f,RT=sa.forEach,MT=I,NT=ta.set,FT=ta.getterFor,zT=function(t,e,r){var n,i=-1!==t.indexOf("Map"),o=-1!==t.indexOf("Weak"),a=i?"set":"add",u=xT[t],s=u&&u.prototype,c={};if(MT&&IT(u)&&(o||s.forEach&&!ST((function(){(new u).entries().next()})))){var f=(n=e((function(e,r){NT(PT(e,f),{type:t,collection:new u}),null!=r&&AT(r,e[a],{that:e,AS_ENTRIES:i})}))).prototype,l=FT(t);RT(["add","clear","delete","forEach","get","has","set","keys","values","entries"],(function(t){var e="add"==t||"set"==t;!(t in s)||o&&"clear"==t||jT(f,t,(function(r,n){var i=l(this).collection;if(!e&&o&&!DT(r))return"get"==t&&void 0;var a=i[t](0===r?0:r,n);return e?this:a}))})),o||CT(f,"size",{configurable:!0,get:function(){return l(this).collection.size}})}else n=r.getConstructor(e,t,i,a),kT.enable();return LT(n,t,!1,!0),c[t]=n,OT({global:!0,forced:!0},c),o||r.setStrong(n,t,i),n},UT=lo,qT=Bi,YT=po,WT=function(t,e,r){for(var n in e)r&&r.unsafe&&t[n]?t[n]=e[n]:UT(t,n,e[n],r);return t},GT=Ke,XT=Ab,VT=B,BT=Zm,HT=wc,$T=Ec,JT=kb,KT=I,QT=TT.fastKey,ZT=ta.set,tO=ta.getterFor,eO={getConstructor:function(t,e,r,n){var i=t((function(t,i){XT(t,o),ZT(t,{type:e,index:qT(null),first:void 0,last:void 0,size:0}),KT||(t.size=0),VT(i)||BT(i,t[n],{that:t,AS_ENTRIES:r})})),o=i.prototype,a=tO(e),u=function(t,e,r){var n,i,o=a(t),u=s(t,e);return u?u.value=r:(o.last=u={index:i=QT(e,!0),key:e,value:r,previous:n=o.last,next:void 0,removed:!1},o.first||(o.first=u),n&&(n.next=u),KT?o.size++:t.size++,"F"!==i&&(o.index[i]=u)),t},s=function(t,e){var r,n=a(t),i=QT(e);if("F"!==i)return n.index[i];for(r=n.first;r;r=r.next)if(r.key==e)return r};return WT(o,{clear:function(){for(var t=a(this),e=t.index,r=t.first;r;)r.removed=!0,r.previous&&(r.previous=r.previous.next=void 0),delete e[r.index],r=r.next;t.first=t.last=void 0,KT?t.size=0:this.size=0},delete:function(t){var e=this,r=a(e),n=s(e,t);if(n){var i=n.next,o=n.previous;delete r.index[n.index],n.removed=!0,o&&(o.next=i),i&&(i.previous=o),r.first==n&&(r.first=i),r.last==n&&(r.last=o),KT?r.size--:e.size--}return!!n},forEach:function(t){for(var e,r=a(this),n=GT(t,arguments.length>1?arguments[1]:void 0);e=e?e.next:r.first;)for(n(e.value,e.key,this);e&&e.removed;)e=e.previous},has:function(t){return!!s(this,t)}}),WT(o,r?{get:function(t){var e=s(this,t);return e&&e.value},set:function(t,e){return u(this,0===t?0:t,e)}}:{add:function(t){return u(this,t=0===t?0:t,t)}}),KT&&YT(o,"size",{configurable:!0,get:function(){return a(this).size}}),i},setStrong:function(t,e,r){var n=e+" Iterator",i=tO(e),o=tO(n);HT(t,e,(function(t,e){ZT(this,{type:n,target:t,state:i(t),kind:e,last:void 0})}),(function(){for(var t=o(this),e=t.kind,r=t.last;r&&r.removed;)r=r.previous;return t.target&&(t.last=r=r?r.next:t.state.first)?$T("keys"==e?r.key:"values"==e?r.value:[r.key,r.value],!1):(t.target=void 0,$T(void 0,!0))}),r?"entries":"values",!r,!0),JT(e)}};zT("Map",(function(t){return function(){return t(this,arguments.length?arguments[0]:void 0)}}),eO);var rO=n(nt.Map),nO=sa.some;Ar({target:"Array",proto:!0,forced:!fl("some")},{some:function(t){return nO(this,t,arguments.length>1?arguments[1]:void 0)}});var iO=$f("Array").some,oO=ct,aO=iO,uO=Array.prototype,sO=n((function(t){var e=t.some;return t===uO||oO(uO,t)&&e===uO.some?aO:e})),cO=$f("Array").keys,fO=cn,lO=Zt,hO=ct,pO=cO,vO=Array.prototype,dO={DOMTokenList:!0,NodeList:!0},yO=n((function(t){var e=t.keys;return t===vO||hO(vO,t)&&e===vO.keys||lO(dO,fO(t))?pO:e})),gO=no,mO=Math.floor,bO=function(t,e){var r=t.length,n=mO(r/2);return r<8?_O(t,e):wO(t,bO(gO(t,0,n),e),bO(gO(t,n),e),e)},_O=function(t,e){for(var r,n,i=t.length,o=1;o<i;){for(n=o,r=t[o];n&&e(t[n-1],r)>0;)t[n]=t[--n];n!==o++&&(t[n]=r)}return t},wO=function(t,e,r,n){for(var i=e.length,o=r.length,a=0,u=0;a<i||u<o;)t[a+u]=a<i&&u<o?n(e[a],r[u])<=0?e[a++]:r[u++]:a<i?e[a++]:r[u++];return t},EO=bO,TO=ft.match(/firefox\/(\d+)/i),OO=!!TO&&+TO[1],xO=/MSIE|Trident/.test(ft),kO=ft.match(/AppleWebKit\/(\d+)\./),SO=!!kO&&+kO[1],jO=Ar,AO=m,PO=Dt,IO=Jt,DO=Br,LO=xv,CO=ei,RO=u,MO=EO,NO=fl,FO=OO,zO=xO,UO=gt,qO=SO,YO=[],WO=AO(YO.sort),GO=AO(YO.push),XO=RO((function(){YO.sort(void 0)})),VO=RO((function(){YO.sort(null)})),BO=NO("sort"),HO=!RO((function(){if(UO)return UO<70;if(!(FO&&FO>3)){if(zO)return!0;if(qO)return qO<603;var t,e,r,n,i="";for(t=65;t<76;t++){switch(e=String.fromCharCode(t),t){case 66:case 69:case 70:case 72:r=3;break;case 68:case 71:r=4;break;default:r=2}for(n=0;n<47;n++)YO.push({k:e+n,v:r})}for(YO.sort((function(t,e){return e.v-t.v})),n=0;n<YO.length;n++)e=YO[n].k.charAt(0),i.charAt(i.length-1)!==e&&(i+=e);return"DGBEFHACIJK"!==i}}));jO({target:"Array",proto:!0,forced:XO||!VO||!BO||!HO},{sort:function(t){void 0!==t&&PO(t);var e=IO(this);if(HO)return void 0===t?WO(e):WO(e,t);var r,n,i=[],o=DO(e);for(n=0;n<o;n++)n in e&&GO(i,e[n]);for(MO(i,function(t){return function(e,r){return void 0===r?-1:void 0===e?1:void 0!==t?+t(e,r)||0:CO(e)>CO(r)?1:-1}}(t)),r=DO(i),n=0;n<r;)e[n]=i[n++];for(;n<o;)LO(e,n++);return e}});var $O=$f("Array").sort,JO=ct,KO=$O,QO=Array.prototype,ZO=n((function(t){var e=t.sort;return t===QO||JO(QO,t)&&e===QO.sort?KO:e})),tx=$f("Array").values,ex=cn,rx=Zt,nx=ct,ix=tx,ox=Array.prototype,ax={DOMTokenList:!0,NodeList:!0},ux=n((function(t){var e=t.values;return t===ox||nx(ox,t)&&e===ox.values||rx(ax,ex(t))?ix:e})),sx=n(Sf),cx=$f("Array").entries,fx=cn,lx=Zt,hx=ct,px=cx,vx=Array.prototype,dx={DOMTokenList:!0,NodeList:!0},yx=n((function(t){var e=t.entries;return t===vx||hx(vx,t)&&e===vx.entries||lx(dx,fx(t))?px:e}));let gx;const mx=new Uint8Array(16);function bx(){if(!gx&&(gx="undefined"!=typeof crypto&&crypto.getRandomValues&&crypto.getRandomValues.bind(crypto),!gx))throw new Error("crypto.getRandomValues() not supported. See https://github.com/uuidjs/uuid#getrandomvalues-not-supported");return gx(mx)}const _x=[];for(let t=0;t<256;++t)_x.push((t+256).toString(16).slice(1));var wx={randomUUID:"undefined"!=typeof crypto&&crypto.randomUUID&&crypto.randomUUID.bind(crypto)};function Ex(t,e,r){if(wx.randomUUID&&!e&&!t)return wx.randomUUID();const n=(t=t||{}).random||(t.rng||bx)();if(n[6]=15&n[6]|64,n[8]=63&n[8]|128,e){r=r||0;for(let t=0;t<16;++t)e[r+t]=n[t];return e}return function(t,e=0){return _x[t[e+0]]+_x[t[e+1]]+_x[t[e+2]]+_x[t[e+3]]+"-"+_x[t[e+4]]+_x[t[e+5]]+"-"+_x[t[e+6]]+_x[t[e+7]]+"-"+_x[t[e+8]]+_x[t[e+9]]+"-"+_x[t[e+10]]+_x[t[e+11]]+_x[t[e+12]]+_x[t[e+13]]+_x[t[e+14]]+_x[t[e+15]]}(n)}function Tx(t){return"string"==typeof t||"number"==typeof t}var Ox=function(){function t(r){e(this,t),Rf(this,"delay",void 0),Rf(this,"max",void 0),Rf(this,"_queue",[]),Rf(this,"_timeout",null),Rf(this,"_extended",null),this.delay=null,this.max=1/0,this.setOptions(r)}return Cf(t,[{key:"setOptions",value:function(t){t&&void 0!==t.delay&&(this.delay=t.delay),t&&void 0!==t.max&&(this.max=t.max),this._flushIfNeeded()}},{key:"destroy",value:function(){if(this.flush(),this._extended){for(var t=this._extended.object,e=this._extended.methods,r=0;r<e.length;r++){var n=e[r];n.original?t[n.name]=n.original:delete t[n.name]}this._extended=null}}},{key:"replace",value:function(t,e){var r=this,n=t[e];if(!n)throw new Error("Method "+e+" undefined");t[e]=function(){for(var t=arguments.length,e=new Array(t),i=0;i<t;i++)e[i]=arguments[i];r.queue({args:e,fn:n,context:this})}}},{key:"queue",value:function(t){"function"==typeof t?this._queue.push({fn:t}):this._queue.push(t),this._flushIfNeeded()}},{key:"_flushIfNeeded",value:function(){var t=this;this._queue.length>this.max&&this.flush(),null!=this._timeout&&(clearTimeout(this._timeout),this._timeout=null),this.queue.length>0&&"number"==typeof this.delay&&(this._timeout=Rd((function(){t.flush()}),this.delay))}},{key:"flush",value:function(){var t,e;uv(t=Wv(e=this._queue).call(e,0)).call(t,(function(t){t.fn.apply(t.context||t.fn,t.args||[])}))}}],[{key:"extend",value:function(e,r){var n=new t(r);if(void 0!==e.flush)throw new Error("Target object already has a property flush");e.flush=function(){n.flush()};var i=[{name:"flush",original:void 0}];if(r&&r.replace)for(var o=0;o<r.replace.length;o++){var a=r.replace[o];i.push({name:a,original:e[a]}),n.replace(e,a)}return n._extended={object:e,methods:i},n}}]),t}(),xx=function(){function t(){e(this,t),Rf(this,"_subscribers",{"*":[],add:[],remove:[],update:[]}),Rf(this,"subscribe",t.prototype.on),Rf(this,"unsubscribe",t.prototype.off)}return Cf(t,[{key:"_trigger",value:function(t,e,r){var n,i;if("*"===t)throw new Error("Cannot trigger event *");uv(n=Gp(i=[]).call(i,Fp(this._subscribers[t]),Fp(this._subscribers["*"]))).call(n,(function(n){n(t,e,null!=r?r:null)}))}},{key:"on",value:function(t,e){"function"==typeof e&&this._subscribers[t].push(e)}},{key:"off",value:function(t,e){var r;this._subscribers[t]=Tl(r=this._subscribers[t]).call(r,(function(t){return t!==e}))}}]),t}();zT("Set",(function(t){return function(){return t(this,arguments.length?arguments[0]:void 0)}}),eO);var kx,Sx=n(nt.Set),jx=n(dh);function Ax(t,e){var r=void 0!==zp&&Rh(t)||t["@@iterator"];if(!r){if(Bp(t)||(r=function(t,e){var r;if(!t)return;if("string"==typeof t)return Px(t,e);var n=Xp(r=Object.prototype.toString.call(t)).call(r,8,-1);"Object"===n&&t.constructor&&(n=t.constructor.name);if("Map"===n||"Set"===n)return Ch(t);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return Px(t,e)}(t))||e&&t&&"number"==typeof t.length){r&&(t=r);var n=0,i=function(){};return{s:i,n:function(){return n>=t.length?{done:!0}:{done:!1,value:t[n++]}},e:function(t){throw t},f:i}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var o,a=!0,u=!1;return{s:function(){r=r.call(t)},n:function(){var t=r.next();return a=t.done,t},e:function(t){u=!0,o=t},f:function(){try{a||null==r.return||r.return()}finally{if(u)throw o}}}}function Px(t,e){(null==e||e>t.length)&&(e=t.length);for(var r=0,n=new Array(e);r<e;r++)n[r]=t[r];return n}kx=sx;var Ix=function(){function t(r){e(this,t),Rf(this,"_pairs",void 0),this._pairs=r}return Cf(t,[{key:kx,value:QE.mark((function t(){var e,r,n,i,o;return QE.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:e=Ax(this._pairs),t.prev=1,e.s();case 3:if((r=e.n()).done){t.next=9;break}return n=Np(r.value,2),i=n[0],o=n[1],t.next=7,[i,o];case 7:t.next=3;break;case 9:t.next=14;break;case 11:t.prev=11,t.t0=t.catch(1),e.e(t.t0);case 14:return t.prev=14,e.f(),t.finish(14);case 17:case"end":return t.stop()}}),t,this,[[1,11,14,17]])}))},{key:"entries",value:QE.mark((function t(){var e,r,n,i,o;return QE.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:e=Ax(this._pairs),t.prev=1,e.s();case 3:if((r=e.n()).done){t.next=9;break}return n=Np(r.value,2),i=n[0],o=n[1],t.next=7,[i,o];case 7:t.next=3;break;case 9:t.next=14;break;case 11:t.prev=11,t.t0=t.catch(1),e.e(t.t0);case 14:return t.prev=14,e.f(),t.finish(14);case 17:case"end":return t.stop()}}),t,this,[[1,11,14,17]])}))},{key:"keys",value:QE.mark((function t(){var e,r,n,i;return QE.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:e=Ax(this._pairs),t.prev=1,e.s();case 3:if((r=e.n()).done){t.next=9;break}return n=Np(r.value,1),i=n[0],t.next=7,i;case 7:t.next=3;break;case 9:t.next=14;break;case 11:t.prev=11,t.t0=t.catch(1),e.e(t.t0);case 14:return t.prev=14,e.f(),t.finish(14);case 17:case"end":return t.stop()}}),t,this,[[1,11,14,17]])}))},{key:"values",value:QE.mark((function t(){var e,r,n,i;return QE.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:e=Ax(this._pairs),t.prev=1,e.s();case 3:if((r=e.n()).done){t.next=9;break}return n=Np(r.value,2),i=n[1],t.next=7,i;case 7:t.next=3;break;case 9:t.next=14;break;case 11:t.prev=11,t.t0=t.catch(1),e.e(t.t0);case 14:return t.prev=14,e.f(),t.finish(14);case 17:case"end":return t.stop()}}),t,this,[[1,11,14,17]])}))},{key:"toIdArray",value:function(){var t;return Al(t=Fp(this._pairs)).call(t,(function(t){return t[0]}))}},{key:"toItemArray",value:function(){var t;return Al(t=Fp(this._pairs)).call(t,(function(t){return t[1]}))}},{key:"toEntryArray",value:function(){return Fp(this._pairs)}},{key:"toObjectMap",value:function(){var t,e=ld(null),r=Ax(this._pairs);try{for(r.s();!(t=r.n()).done;){var n=Np(t.value,2),i=n[0],o=n[1];e[i]=o}}catch(t){r.e(t)}finally{r.f()}return e}},{key:"toMap",value:function(){return new rO(this._pairs)}},{key:"toIdSet",value:function(){return new Sx(this.toIdArray())}},{key:"toItemSet",value:function(){return new Sx(this.toItemArray())}},{key:"cache",value:function(){return new t(Fp(this._pairs))}},{key:"distinct",value:function(t){var e,r=new Sx,n=Ax(this._pairs);try{for(n.s();!(e=n.n()).done;){var i=Np(e.value,2),o=i[0],a=i[1];r.add(t(a,o))}}catch(t){n.e(t)}finally{n.f()}return r}},{key:"filter",value:function(e){var r=this._pairs;return new t(Rf({},sx,QE.mark((function t(){var n,i,o,a,u;return QE.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:n=Ax(r),t.prev=1,n.s();case 3:if((i=n.n()).done){t.next=10;break}if(o=Np(i.value,2),a=o[0],u=o[1],!e(u,a)){t.next=8;break}return t.next=8,[a,u];case 8:t.next=3;break;case 10:t.next=15;break;case 12:t.prev=12,t.t0=t.catch(1),n.e(t.t0);case 15:return t.prev=15,n.f(),t.finish(15);case 18:case"end":return t.stop()}}),t,null,[[1,12,15,18]])}))))}},{key:"forEach",value:function(t){var e,r=Ax(this._pairs);try{for(r.s();!(e=r.n()).done;){var n=Np(e.value,2),i=n[0];t(n[1],i)}}catch(t){r.e(t)}finally{r.f()}}},{key:"map",value:function(e){var r=this._pairs;return new t(Rf({},sx,QE.mark((function t(){var n,i,o,a,u;return QE.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:n=Ax(r),t.prev=1,n.s();case 3:if((i=n.n()).done){t.next=9;break}return o=Np(i.value,2),a=o[0],u=o[1],t.next=7,[a,e(u,a)];case 7:t.next=3;break;case 9:t.next=14;break;case 11:t.prev=11,t.t0=t.catch(1),n.e(t.t0);case 14:return t.prev=14,n.f(),t.finish(14);case 17:case"end":return t.stop()}}),t,null,[[1,11,14,17]])}))))}},{key:"max",value:function(t){var e=jx(this._pairs),r=e.next();if(r.done)return null;for(var n=r.value[1],i=t(r.value[1],r.value[0]);!(r=e.next()).done;){var o=Np(r.value,2),a=o[0],u=o[1],s=t(u,a);s>i&&(i=s,n=u)}return n}},{key:"min",value:function(t){var e=jx(this._pairs),r=e.next();if(r.done)return null;for(var n=r.value[1],i=t(r.value[1],r.value[0]);!(r=e.next()).done;){var o=Np(r.value,2),a=o[0],u=o[1],s=t(u,a);s<i&&(i=s,n=u)}return n}},{key:"reduce",value:function(t,e){var r,n=Ax(this._pairs);try{for(n.s();!(r=n.n()).done;){var i=Np(r.value,2),o=i[0];e=t(e,i[1],o)}}catch(t){n.e(t)}finally{n.f()}return e}},{key:"sort",value:function(e){var r=this;return new t(Rf({},sx,(function(){var t;return jx(ZO(t=Fp(r._pairs)).call(t,(function(t,r){var n=Np(t,2),i=n[0],o=n[1],a=Np(r,2),u=a[0],s=a[1];return e(o,s,i,u)})))})))}}]),t}();function Dx(t,e){var r=Jp(t);if(Mh){var n=Mh(t);e&&(n=Tl(n).call(n,(function(e){return Xh(t,e).enumerable}))),r.push.apply(r,n)}return r}function Lx(t){for(var e=1;e<arguments.length;e++){var r,n,i=null!=arguments[e]?arguments[e]:{};e%2?uv(r=Dx(Object(i),!0)).call(r,(function(e){Rf(t,e,i[e])})):rp?cp(t,rp(i)):uv(n=Dx(Object(i))).call(n,(function(e){fp(t,e,Xh(i,e))}))}return t}function Cx(t,e){var r=void 0!==zp&&Rh(t)||t["@@iterator"];if(!r){if(Bp(t)||(r=function(t,e){var r;if(!t)return;if("string"==typeof t)return Rx(t,e);var n=Xp(r=Object.prototype.toString.call(t)).call(r,8,-1);"Object"===n&&t.constructor&&(n=t.constructor.name);if("Map"===n||"Set"===n)return Ch(t);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return Rx(t,e)}(t))||e&&t&&"number"==typeof t.length){r&&(t=r);var n=0,i=function(){};return{s:i,n:function(){return n>=t.length?{done:!0}:{done:!1,value:t[n++]}},e:function(t){throw t},f:i}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var o,a=!0,u=!1;return{s:function(){r=r.call(t)},n:function(){var t=r.next();return a=t.done,t},e:function(t){u=!0,o=t},f:function(){try{a||null==r.return||r.return()}finally{if(u)throw o}}}}function Rx(t,e){(null==e||e>t.length)&&(e=t.length);for(var r=0,n=new Array(e);r<e;r++)n[r]=t[r];return n}function Mx(t){var e=function(){if("undefined"==typeof Reflect||!am)return!1;if(am.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(am(Boolean,[],(function(){}))),!0}catch(t){return!1}}();return function(){var r,n=mm(t);if(e){var i=mm(this).constructor;r=am(n,arguments,i)}else r=n.apply(this,arguments);return dm(this,r)}}var Nx=function(t){vm(n,t);var r=Mx(n);function n(t,i){var o;return e(this,n),Rf(um(o=r.call(this)),"flush",void 0),Rf(um(o),"length",void 0),Rf(um(o),"_options",void 0),Rf(um(o),"_data",void 0),Rf(um(o),"_idProp",void 0),Rf(um(o),"_queue",null),t&&!Bp(t)&&(i=t,t=[]),o._options=i||{},o._data=new rO,o.length=0,o._idProp=o._options.fieldId||"id",t&&t.length&&o.add(t),o.setOptions(i),o}return Cf(n,[{key:"idProp",get:function(){return this._idProp}},{key:"setOptions",value:function(t){t&&void 0!==t.queue&&(!1===t.queue?this._queue&&(this._queue.destroy(),this._queue=null):(this._queue||(this._queue=Ox.extend(this,{replace:["add","update","remove"]})),t.queue&&"object"===Pf(t.queue)&&this._queue.setOptions(t.queue)))}},{key:"add",value:function(t,e){var r,n=this,i=[];if(Bp(t)){var o=Al(t).call(t,(function(t){return t[n._idProp]}));if(sO(o).call(o,(function(t){return n._data.has(t)})))throw new Error("A duplicate id was found in the parameter array.");for(var a=0,u=t.length;a<u;a++)r=this._addItem(t[a]),i.push(r)}else{if(!t||"object"!==Pf(t))throw new Error("Unknown dataType");r=this._addItem(t),i.push(r)}return i.length&&this._trigger("add",{items:i},e),i}},{key:"update",value:function(t,e){var r=this,n=[],i=[],o=[],a=[],u=this._idProp,s=function(t){var e=t[u];if(null!=e&&r._data.has(e)){var s=t,c=id({},r._data.get(e)),f=r._updateItem(s);i.push(f),a.push(s),o.push(c)}else{var l=r._addItem(t);n.push(l)}};if(Bp(t))for(var c=0,f=t.length;c<f;c++)t[c]&&"object"===Pf(t[c])?s(t[c]):console.warn("Ignoring input item, which is not an object at index "+c);else{if(!t||"object"!==Pf(t))throw new Error("Unknown dataType");s(t)}if(n.length&&this._trigger("add",{items:n},e),i.length){var l={items:i,oldData:o,data:a};this._trigger("update",l,e)}return Gp(n).call(n,i)}},{key:"updateOnly",value:function(t,e){var r,n=this;Bp(t)||(t=[t]);var i=Al(r=Al(t).call(t,(function(t){var e=n._data.get(t[n._idProp]);if(null==e)throw new Error("Updating non-existent items is not allowed.");return{oldData:e,update:t}}))).call(r,(function(t){var e=t.oldData,r=t.update,i=e[n._idProp],o=function(t){for(var e,r=arguments.length,n=new Array(r>1?r-1:0),i=1;i<r;i++)n[i-1]=arguments[i];return Mg.apply(void 0,Gp(e=[{},t]).call(e,n))}(e,r);return n._data.set(i,o),{id:i,oldData:e,updatedData:o}}));if(i.length){var o={items:Al(i).call(i,(function(t){return t.id})),oldData:Al(i).call(i,(function(t){return t.oldData})),data:Al(i).call(i,(function(t){return t.updatedData}))};return this._trigger("update",o,e),o.items}return[]}},{key:"get",value:function(t,e){var r=void 0,n=void 0,i=void 0;Tx(t)?(r=t,i=e):Bp(t)?(n=t,i=e):i=t;var o,a=i&&"Object"===i.returnType?"Object":"Array",u=i&&Tl(i),s=[],c=void 0,f=void 0,l=void 0;if(null!=r)(c=this._data.get(r))&&u&&!u(c)&&(c=void 0);else if(null!=n)for(var h=0,p=n.length;h<p;h++)null==(c=this._data.get(n[h]))||u&&!u(c)||s.push(c);else for(var v,d=0,y=(f=Fp(yO(v=this._data).call(v))).length;d<y;d++)l=f[d],null==(c=this._data.get(l))||u&&!u(c)||s.push(c);if(i&&i.order&&null==r&&this._sort(s,i.order),i&&i.fields){var g=i.fields;if(null!=r&&null!=c)c=this._filterFields(c,g);else for(var m=0,b=s.length;m<b;m++)s[m]=this._filterFields(s[m],g)}if("Object"==a){for(var _={},w=0,E=s.length;w<E;w++){var T=s[w];_[T[this._idProp]]=T}return _}return null!=r?null!==(o=c)&&void 0!==o?o:null:s}},{key:"getIds",value:function(t){var e=this._data,r=t&&Tl(t),n=t&&t.order,i=Fp(yO(e).call(e)),o=[];if(r)if(n){for(var a=[],u=0,s=i.length;u<s;u++){var c=i[u],f=this._data.get(c);null!=f&&r(f)&&a.push(f)}this._sort(a,n);for(var l=0,h=a.length;l<h;l++)o.push(a[l][this._idProp])}else for(var p=0,v=i.length;p<v;p++){var d=i[p],y=this._data.get(d);null!=y&&r(y)&&o.push(y[this._idProp])}else if(n){for(var g=[],m=0,b=i.length;m<b;m++){var _=i[m];g.push(e.get(_))}this._sort(g,n);for(var w=0,E=g.length;w<E;w++)o.push(g[w][this._idProp])}else for(var T=0,O=i.length;T<O;T++){var x=i[T],k=e.get(x);null!=k&&o.push(k[this._idProp])}return o}},{key:"getDataSet",value:function(){return this}},{key:"forEach",value:function(t,e){var r=e&&Tl(e),n=this._data,i=Fp(yO(n).call(n));if(e&&e.order)for(var o=this.get(e),a=0,u=o.length;a<u;a++){var s=o[a];t(s,s[this._idProp])}else for(var c=0,f=i.length;c<f;c++){var l=i[c],h=this._data.get(l);null==h||r&&!r(h)||t(h,l)}}},{key:"map",value:function(t,e){for(var r=e&&Tl(e),n=[],i=this._data,o=Fp(yO(i).call(i)),a=0,u=o.length;a<u;a++){var s=o[a],c=this._data.get(s);null==c||r&&!r(c)||n.push(t(c,s))}return e&&e.order&&this._sort(n,e.order),n}},{key:"_filterFields",value:function(t,e){var r;return t?gl(r=Bp(e)?e:Jp(e)).call(r,(function(e,r){return e[r]=t[r],e}),{}):t}},{key:"_sort",value:function(t,e){if("string"==typeof e){var r=e;ZO(t).call(t,(function(t,e){var n=t[r],i=e[r];return n>i?1:n<i?-1:0}))}else{if("function"!=typeof e)throw new TypeError("Order must be a function or a string");ZO(t).call(t,e)}}},{key:"remove",value:function(t,e){for(var r=[],n=[],i=Bp(t)?t:[t],o=0,a=i.length;o<a;o++){var u=this._remove(i[o]);if(u){var s=u[this._idProp];null!=s&&(r.push(s),n.push(u))}}return r.length&&this._trigger("remove",{items:r,oldData:n},e),r}},{key:"_remove",value:function(t){var e;if(Tx(t)?e=t:t&&"object"===Pf(t)&&(e=t[this._idProp]),null!=e&&this._data.has(e)){var r=this._data.get(e)||null;return this._data.delete(e),--this.length,r}return null}},{key:"clear",value:function(t){for(var e,r=Fp(yO(e=this._data).call(e)),n=[],i=0,o=r.length;i<o;i++)n.push(this._data.get(r[i]));return this._data.clear(),this.length=0,this._trigger("remove",{items:r,oldData:n},t),r}},{key:"max",value:function(t){var e,r,n=null,i=null,o=Cx(ux(e=this._data).call(e));try{for(o.s();!(r=o.n()).done;){var a=r.value,u=a[t];"number"==typeof u&&(null==i||u>i)&&(n=a,i=u)}}catch(t){o.e(t)}finally{o.f()}return n||null}},{key:"min",value:function(t){var e,r,n=null,i=null,o=Cx(ux(e=this._data).call(e));try{for(o.s();!(r=o.n()).done;){var a=r.value,u=a[t];"number"==typeof u&&(null==i||u<i)&&(n=a,i=u)}}catch(t){o.e(t)}finally{o.f()}return n||null}},{key:"distinct",value:function(t){for(var e=this._data,r=Fp(yO(e).call(e)),n=[],i=0,o=0,a=r.length;o<a;o++){for(var u=r[o],s=e.get(u)[t],c=!1,f=0;f<i;f++)if(n[f]==s){c=!0;break}c||void 0===s||(n[i]=s,i++)}return n}},{key:"_addItem",value:function(t){var e=function(t,e){return null==t[e]&&(t[e]=Ex()),t}(t,this._idProp),r=e[this._idProp];if(this._data.has(r))throw new Error("Cannot add item: item with id "+r+" already exists");return this._data.set(r,e),++this.length,r}},{key:"_updateItem",value:function(t){var e=t[this._idProp];if(null==e)throw new Error("Cannot update item: item has no id (item: "+dd(t)+")");var r=this._data.get(e);if(!r)throw new Error("Cannot update item: no item with id "+e+" found");return this._data.set(e,Lx(Lx({},r),t)),e}},{key:"stream",value:function(t){if(t){var e=this._data;return new Ix(Rf({},sx,QE.mark((function r(){var n,i,o,a;return QE.wrap((function(r){for(;;)switch(r.prev=r.next){case 0:n=Cx(t),r.prev=1,n.s();case 3:if((i=n.n()).done){r.next=11;break}if(o=i.value,null==(a=e.get(o))){r.next=9;break}return r.next=9,[o,a];case 9:r.next=3;break;case 11:r.next=16;break;case 13:r.prev=13,r.t0=r.catch(1),n.e(r.t0);case 16:return r.prev=16,n.f(),r.finish(16);case 19:case"end":return r.stop()}}),r,null,[[1,13,16,19]])}))))}var r;return new Ix(Rf({},sx,el(r=yx(this._data)).call(r,this._data)))}}]),n}(xx);function Fx(t,e){var r=void 0!==zp&&Rh(t)||t["@@iterator"];if(!r){if(Bp(t)||(r=function(t,e){var r;if(!t)return;if("string"==typeof t)return zx(t,e);var n=Xp(r=Object.prototype.toString.call(t)).call(r,8,-1);"Object"===n&&t.constructor&&(n=t.constructor.name);if("Map"===n||"Set"===n)return Ch(t);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return zx(t,e)}(t))||e&&t&&"number"==typeof t.length){r&&(t=r);var n=0,i=function(){};return{s:i,n:function(){return n>=t.length?{done:!0}:{done:!1,value:t[n++]}},e:function(t){throw t},f:i}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var o,a=!0,u=!1;return{s:function(){r=r.call(t)},n:function(){var t=r.next();return a=t.done,t},e:function(t){u=!0,o=t},f:function(){try{a||null==r.return||r.return()}finally{if(u)throw o}}}}function zx(t,e){(null==e||e>t.length)&&(e=t.length);for(var r=0,n=new Array(e);r<e;r++)n[r]=t[r];return n}function Ux(t){var e=function(){if("undefined"==typeof Reflect||!am)return!1;if(am.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(am(Boolean,[],(function(){}))),!0}catch(t){return!1}}();return function(){var r,n=mm(t);if(e){var i=mm(this).constructor;r=am(n,arguments,i)}else r=n.apply(this,arguments);return dm(this,r)}}var qx=function(t){vm(n,t);var r=Ux(n);function n(t,i){var o,a;return e(this,n),Rf(um(a=r.call(this)),"length",0),Rf(um(a),"_listener",void 0),Rf(um(a),"_data",void 0),Rf(um(a),"_ids",new Sx),Rf(um(a),"_options",void 0),a._options=i||{},a._listener=el(o=a._onEvent).call(o,um(a)),a.setData(t),a}return Cf(n,[{key:"idProp",get:function(){return this.getDataSet().idProp}},{key:"setData",value:function(t){if(this._data){this._data.off&&this._data.off("*",this._listener);var e=this._data.getIds({filter:Tl(this._options)}),r=this._data.get(e);this._ids.clear(),this.length=0,this._trigger("remove",{items:e,oldData:r})}if(null!=t){this._data=t;for(var n=this._data.getIds({filter:Tl(this._options)}),i=0,o=n.length;i<o;i++){var a=n[i];this._ids.add(a)}this.length=n.length,this._trigger("add",{items:n})}else this._data=new Nx;this._data.on&&this._data.on("*",this._listener)}},{key:"refresh",value:function(){for(var t=this._data.getIds({filter:Tl(this._options)}),e=Fp(this._ids),r={},n=[],i=[],o=[],a=0,u=t.length;a<u;a++){var s=t[a];r[s]=!0,this._ids.has(s)||(n.push(s),this._ids.add(s))}for(var c=0,f=e.length;c<f;c++){var l=e[c],h=this._data.get(l);null==h?console.error("If you see this, report it please."):r[l]||(i.push(l),o.push(h),this._ids.delete(l))}this.length+=n.length-i.length,n.length&&this._trigger("add",{items:n}),i.length&&this._trigger("remove",{items:i,oldData:o})}},{key:"get",value:function(t,e){if(null==this._data)return null;var r,n=null;Tx(t)||Bp(t)?(n=t,r=e):r=t;var i=id({},this._options,r),o=Tl(this._options),a=r&&Tl(r);return o&&a&&(i.filter=function(t){return o(t)&&a(t)}),null==n?this._data.get(i):this._data.get(n,i)}},{key:"getIds",value:function(t){if(this._data.length){var e,r=Tl(this._options),n=null!=t?Tl(t):null;return e=n?r?function(t){return r(t)&&n(t)}:n:r,this._data.getIds({filter:e,order:t&&t.order})}return[]}},{key:"forEach",value:function(t,e){if(this._data){var r,n,i=Tl(this._options),o=e&&Tl(e);n=o?i?function(t){return i(t)&&o(t)}:o:i,uv(r=this._data).call(r,t,{filter:n,order:e&&e.order})}}},{key:"map",value:function(t,e){if(this._data){var r,n,i=Tl(this._options),o=e&&Tl(e);return n=o?i?function(t){return i(t)&&o(t)}:o:i,Al(r=this._data).call(r,t,{filter:n,order:e&&e.order})}return[]}},{key:"getDataSet",value:function(){return this._data.getDataSet()}},{key:"stream",value:function(t){var e;return this._data.stream(t||Rf({},sx,el(e=yO(this._ids)).call(e,this._ids)))}},{key:"dispose",value:function(){var t;null!==(t=this._data)&&void 0!==t&&t.off&&this._data.off("*",this._listener);var e,r="This data view has already been disposed of.",i={get:function(){throw new Error(r)},set:function(){throw new Error(r)},configurable:!1},o=Fx(Vp(n.prototype));try{for(o.s();!(e=o.n()).done;){var a=e.value;fp(this,a,i)}}catch(t){o.e(t)}finally{o.f()}}},{key:"_onEvent",value:function(t,e,r){if(e&&e.items&&this._data){var n=e.items,i=[],o=[],a=[],u=[],s=[],c=[];switch(t){case"add":for(var f=0,l=n.length;f<l;f++){var h=n[f];this.get(h)&&(this._ids.add(h),i.push(h))}break;case"update":for(var p=0,v=n.length;p<v;p++){var d=n[p];this.get(d)?this._ids.has(d)?(o.push(d),s.push(e.data[p]),u.push(e.oldData[p])):(this._ids.add(d),i.push(d)):this._ids.has(d)&&(this._ids.delete(d),a.push(d),c.push(e.oldData[p]))}break;case"remove":for(var y=0,g=n.length;y<g;y++){var m=n[y];this._ids.has(m)&&(this._ids.delete(m),a.push(m),c.push(e.oldData[y]))}}this.length+=i.length-a.length,i.length&&this._trigger("add",{items:i},r),o.length&&this._trigger("update",{items:o,oldData:u,data:s},r),a.length&&this._trigger("remove",{items:a,oldData:c},r)}}}]),n}(xx);function Yx(t,e){return"object"===Pf(e)&&null!==e&&t===e.idProp&&"function"==typeof e.add&&"function"==typeof e.clear&&"function"==typeof e.distinct&&"function"==typeof uv(e)&&"function"==typeof e.get&&"function"==typeof e.getDataSet&&"function"==typeof e.getIds&&"number"==typeof e.length&&"function"==typeof Al(e)&&"function"==typeof e.max&&"function"==typeof e.min&&"function"==typeof e.off&&"function"==typeof e.on&&"function"==typeof e.remove&&"function"==typeof e.setOptions&&"function"==typeof e.stream&&"function"==typeof e.update&&"function"==typeof e.updateOnly}t.DELETE=Rg,t.DataSet=Nx,t.DataStream=Ix,t.DataView=qx,t.Queue=Ox,t.createNewDataPipeFrom=function(t){return new Vl(t)},t.isDataSetLike=Yx,t.isDataViewLike=function(t,e){return"object"===Pf(e)&&null!==e&&t===e.idProp&&"function"==typeof uv(e)&&"function"==typeof e.get&&"function"==typeof e.getDataSet&&"function"==typeof e.getIds&&"number"==typeof e.length&&"function"==typeof Al(e)&&"function"==typeof e.off&&"function"==typeof e.on&&"function"==typeof e.stream&&Yx(t,e.getDataSet())}}));
//# sourceMappingURL=vis-data.min.js.map
